// This code conforms with the UFC specification version 1.0
// and was automatically generated by FFC version 0.5.0.
//
// Warning: This code was generated with the option '-l dolfin'
// and contains DOLFIN-specific wrappers that depend on DOLFIN.

#ifndef __NONLINEAR2D_H
#define __NONLINEAR2D_H

#include <cmath>
#include <stdexcept>
#include <fstream>
#include <ufc.h>

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_0_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_0_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_0_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_0_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_0_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_0_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 20;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[20][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[20][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[20][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[10];
    vertex_values[3] = dof_values[11];
    vertex_values[5] = dof_values[12];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_finite_element_0_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_finite_element_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_1_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_1_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_1_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_1_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_1_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_1_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_1_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_1_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 20;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[20][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[20][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[20][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[10];
    vertex_values[3] = dof_values[11];
    vertex_values[5] = dof_values[12];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_finite_element_1_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_finite_element_1_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_2_0: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_2_0() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_2_0()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_2_0();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_2_1: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_2_1() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_2_1()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Lagrange finite element of degree 3 on a triangle";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 10;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 0;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 1;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    *values = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Extract relevant coefficients
    const double coeff0_0 = coefficients0[dof][0];
    const double coeff0_1 = coefficients0[dof][1];
    const double coeff0_2 = coefficients0[dof][2];
    const double coeff0_3 = coefficients0[dof][3];
    const double coeff0_4 = coefficients0[dof][4];
    const double coeff0_5 = coefficients0[dof][5];
    const double coeff0_6 = coefficients0[dof][6];
    const double coeff0_7 = coefficients0[dof][7];
    const double coeff0_8 = coefficients0[dof][8];
    const double coeff0_9 = coefficients0[dof][9];
    
    // Compute value(s)
    *values = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 1*num_derivatives; j++)
      values[j] = 0;
    
    // Map degree of freedom to element degree of freedom
    const unsigned int dof = i;
    
    // Generate scalings
    const double scalings_y_0 = 1;
    const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
    const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
    const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
    // Compute psitilde_a
    const double psitilde_a_0 = 1;
    const double psitilde_a_1 = x;
    const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
    const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
    // Compute psitilde_bs
    const double psitilde_bs_0_0 = 1;
    const double psitilde_bs_0_1 = 1.5*y + 0.5;
    const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
    const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
    const double psitilde_bs_1_0 = 1;
    const double psitilde_bs_1_1 = 2.5*y + 1.5;
    const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
    const double psitilde_bs_2_0 = 1;
    const double psitilde_bs_2_1 = 3.5*y + 2.5;
    const double psitilde_bs_3_0 = 1;
    
    // Compute basisvalues
    const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
    const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
    const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
    const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
    const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
    const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
    const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
    const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
    const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
    const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
    // Table(s) of coefficients
    const static double coefficients0[10][10] = \
    {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
    {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
    {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
    {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
    {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
    {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
    {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
    {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
    // Interesting (new) part
    // Tables of derivatives of the polynomial base (transpose)
    const static double dmats0[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
    {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
    {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
    {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
    const static double dmats1[10][10] = \
    {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
    {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
    {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
    {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
    {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
    {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
    {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
    // Compute reference derivatives
    // Declare pointer to array of derivatives on FIAT element
    double *derivatives = new double [num_derivatives];
    
    // Declare coefficients
    double coeff0_0 = 0;
    double coeff0_1 = 0;
    double coeff0_2 = 0;
    double coeff0_3 = 0;
    double coeff0_4 = 0;
    double coeff0_5 = 0;
    double coeff0_6 = 0;
    double coeff0_7 = 0;
    double coeff0_8 = 0;
    double coeff0_9 = 0;
    
    // Declare new coefficients
    double new_coeff0_0 = 0;
    double new_coeff0_1 = 0;
    double new_coeff0_2 = 0;
    double new_coeff0_3 = 0;
    double new_coeff0_4 = 0;
    double new_coeff0_5 = 0;
    double new_coeff0_6 = 0;
    double new_coeff0_7 = 0;
    double new_coeff0_8 = 0;
    double new_coeff0_9 = 0;
    
    // Loop possible derivatives
    for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
    {
      // Get values from coefficients array
      new_coeff0_0 = coefficients0[dof][0];
      new_coeff0_1 = coefficients0[dof][1];
      new_coeff0_2 = coefficients0[dof][2];
      new_coeff0_3 = coefficients0[dof][3];
      new_coeff0_4 = coefficients0[dof][4];
      new_coeff0_5 = coefficients0[dof][5];
      new_coeff0_6 = coefficients0[dof][6];
      new_coeff0_7 = coefficients0[dof][7];
      new_coeff0_8 = coefficients0[dof][8];
      new_coeff0_9 = coefficients0[dof][9];
    
      // Loop derivative order
      for (unsigned int j = 0; j < n; j++)
      {
        // Update old coefficients
        coeff0_0 = new_coeff0_0;
        coeff0_1 = new_coeff0_1;
        coeff0_2 = new_coeff0_2;
        coeff0_3 = new_coeff0_3;
        coeff0_4 = new_coeff0_4;
        coeff0_5 = new_coeff0_5;
        coeff0_6 = new_coeff0_6;
        coeff0_7 = new_coeff0_7;
        coeff0_8 = new_coeff0_8;
        coeff0_9 = new_coeff0_9;
    
        if(combinations[deriv_num][j] == 0)
        {
          new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
          new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
          new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
          new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
          new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
          new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
          new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
          new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
          new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
          new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
        }
        if(combinations[deriv_num][j] == 1)
        {
          new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
          new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
          new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
          new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
          new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
          new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
          new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
          new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
          new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
          new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
        }
    
      }
      // Compute derivatives on reference element as dot product of coefficients and basisvalues
      derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
    }
    
    // Transform derivatives back to physical element
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        values[row] += transform[row][col]*derivatives[col];
      }
    }
    // Delete pointer to array of derivatives on FIAT element
    delete [] derivatives;
    
    // Delete pointer to array of combinations of derivatives and transform
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      delete [] combinations[row];
      delete [] transform[row];
    }
    
    delete [] combinations;
    delete [] transform;
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[10][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[10][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[10][1][1] = {{{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}, {{1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[1];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 1; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 1;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_finite_element_2_1();
  }

};

/// This class defines the interface for a finite element.

class UFC_Nonlinear2DBilinearForm_finite_element_2: public ufc::finite_element
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_finite_element_2()
  {
    // Do nothing
  }

  /// Return a string identifying the finite element
  virtual const char* signature() const
  {
    return "Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return the cell shape
  virtual ufc::shape cell_shape() const
  {
    return ufc::triangle;
  }

  /// Return the dimension of the finite element function space
  virtual unsigned int space_dimension() const
  {
    return 20;
  }

  /// Return the rank of the value space
  virtual unsigned int value_rank() const
  {
    return 1;
  }

  /// Return the dimension of the value space for axis i
  virtual unsigned int value_dimension(unsigned int i) const
  {
    return 2;
  }

  /// Evaluate basis function i at given point in cell
  virtual void evaluate_basis(unsigned int i,
                              double* values,
                              const double* coordinates,
                              const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Reset values
    values[0] = 0;
    values[1] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[0] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Extract relevant coefficients
      const double coeff0_0 =   coefficients0[dof][0];
      const double coeff0_1 =   coefficients0[dof][1];
      const double coeff0_2 =   coefficients0[dof][2];
      const double coeff0_3 =   coefficients0[dof][3];
      const double coeff0_4 =   coefficients0[dof][4];
      const double coeff0_5 =   coefficients0[dof][5];
      const double coeff0_6 =   coefficients0[dof][6];
      const double coeff0_7 =   coefficients0[dof][7];
      const double coeff0_8 =   coefficients0[dof][8];
      const double coeff0_9 =   coefficients0[dof][9];
    
      // Compute value(s)
      values[1] = coeff0_0*basisvalue0 + coeff0_1*basisvalue1 + coeff0_2*basisvalue2 + coeff0_3*basisvalue3 + coeff0_4*basisvalue4 + coeff0_5*basisvalue5 + coeff0_6*basisvalue6 + coeff0_7*basisvalue7 + coeff0_8*basisvalue8 + coeff0_9*basisvalue9;
    }
    
  }

  /// Evaluate all basis functions at given point in cell
  virtual void evaluate_basis_all(double* values,
                                  const double* coordinates,
                                  const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis() is not yet implemented.");
  }

  /// Evaluate order n derivatives of basis function i at given point in cell
  virtual void evaluate_basis_derivatives(unsigned int i,
                                          unsigned int n,
                                          double* values,
                                          const double* coordinates,
                                          const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * element_coordinates = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = element_coordinates[1][0] - element_coordinates[0][0];
    const double J_01 = element_coordinates[2][0] - element_coordinates[0][0];
    const double J_10 = element_coordinates[1][1] - element_coordinates[0][1];
    const double J_11 = element_coordinates[2][1] - element_coordinates[0][1];
      
    // Compute determinant of Jacobian
    const double detJ = J_00*J_11 - J_01*J_10;
    
    // Compute inverse of Jacobian
    
    // Get coordinates and map to the reference (UFC) element
    double x = (element_coordinates[0][1]*element_coordinates[2][0] -\
                element_coordinates[0][0]*element_coordinates[2][1] +\
                J_11*coordinates[0] - J_01*coordinates[1]) / detJ;
    double y = (element_coordinates[1][1]*element_coordinates[0][0] -\
                element_coordinates[1][0]*element_coordinates[0][1] -\
                J_10*coordinates[0] + J_00*coordinates[1]) / detJ;
    
    // Map coordinates to the reference square
    if (std::abs(y - 1.0) < 1e-14)
      x = -1.0;
    else
      x = 2.0 *x/(1.0 - y) - 1.0;
    y = 2.0*y - 1.0;
    
    // Compute number of derivatives
    unsigned int num_derivatives = 1;
    
    for (unsigned int j = 0; j < n; j++)
      num_derivatives *= 2;
    
    
    // Declare pointer to two dimensional array that holds combinations of derivatives and initialise
    unsigned int **combinations = new unsigned int *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      combinations[j] = new unsigned int [n];
      for (unsigned int k = 0; k < n; k++)
        combinations[j][k] = 0;
    }
        
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] =  {{J_11 / detJ, -J_01 / detJ}, {-J_10 / detJ, J_00 / detJ}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double **transform = new double *[num_derivatives];
        
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      transform[j] = new double [num_derivatives];
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    
    // Reset values
    for (unsigned int j = 0; j < 2*num_derivatives; j++)
      values[j] = 0;
    
    if (0 <= i && i <= 9)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
    if (10 <= i && i <= 19)
    {
      // Map degree of freedom to element degree of freedom
      const unsigned int dof = i - 10;
    
      // Generate scalings
      const double scalings_y_0 = 1;
      const double scalings_y_1 = scalings_y_0*(0.5 - 0.5*y);
      const double scalings_y_2 = scalings_y_1*(0.5 - 0.5*y);
      const double scalings_y_3 = scalings_y_2*(0.5 - 0.5*y);
    
      // Compute psitilde_a
      const double psitilde_a_0 = 1;
      const double psitilde_a_1 = x;
      const double psitilde_a_2 = 1.5*x*psitilde_a_1 - 0.5*psitilde_a_0;
      const double psitilde_a_3 = 1.66666666666667*x*psitilde_a_2 - 0.666666666666667*psitilde_a_1;
    
      // Compute psitilde_bs
      const double psitilde_bs_0_0 = 1;
      const double psitilde_bs_0_1 = 1.5*y + 0.5;
      const double psitilde_bs_0_2 = 0.111111111111111*psitilde_bs_0_1 + 1.66666666666667*y*psitilde_bs_0_1 - 0.555555555555556*psitilde_bs_0_0;
      const double psitilde_bs_0_3 = 0.05*psitilde_bs_0_2 + 1.75*y*psitilde_bs_0_2 - 0.7*psitilde_bs_0_1;
      const double psitilde_bs_1_0 = 1;
      const double psitilde_bs_1_1 = 2.5*y + 1.5;
      const double psitilde_bs_1_2 = 0.54*psitilde_bs_1_1 + 2.1*y*psitilde_bs_1_1 - 0.56*psitilde_bs_1_0;
      const double psitilde_bs_2_0 = 1;
      const double psitilde_bs_2_1 = 3.5*y + 2.5;
      const double psitilde_bs_3_0 = 1;
    
      // Compute basisvalues
      const double basisvalue0 = 0.707106781186548*psitilde_a_0*scalings_y_0*psitilde_bs_0_0;
      const double basisvalue1 = 1.73205080756888*psitilde_a_1*scalings_y_1*psitilde_bs_1_0;
      const double basisvalue2 = psitilde_a_0*scalings_y_0*psitilde_bs_0_1;
      const double basisvalue3 = 2.73861278752583*psitilde_a_2*scalings_y_2*psitilde_bs_2_0;
      const double basisvalue4 = 2.12132034355964*psitilde_a_1*scalings_y_1*psitilde_bs_1_1;
      const double basisvalue5 = 1.22474487139159*psitilde_a_0*scalings_y_0*psitilde_bs_0_2;
      const double basisvalue6 = 3.74165738677394*psitilde_a_3*scalings_y_3*psitilde_bs_3_0;
      const double basisvalue7 = 3.16227766016838*psitilde_a_2*scalings_y_2*psitilde_bs_2_1;
      const double basisvalue8 = 2.44948974278318*psitilde_a_1*scalings_y_1*psitilde_bs_1_2;
      const double basisvalue9 = 1.4142135623731*psitilde_a_0*scalings_y_0*psitilde_bs_0_3;
    
      // Table(s) of coefficients
      const static double coefficients0[10][10] =   \
      {{0.0471404520791031, -0.0288675134594812, -0.0166666666666666, 0.0782460796435951, 0.0606091526731327, 0.0349927106111883, -0.0601337794302955, -0.0508223195384204, -0.0393667994375868, -0.0227284322524248},
      {0.0471404520791032, 0.0288675134594812, -0.0166666666666666, 0.0782460796435952, -0.0606091526731327, 0.0349927106111883, 0.0601337794302955, -0.0508223195384204, 0.0393667994375868, -0.0227284322524248},
      {0.0471404520791031, 0, 0.0333333333333334, 0, 0, 0.104978131833565, 0, 0, 0, 0.0909137290096989},
      {0.106066017177982, 0.259807621135332, -0.15, 0.117369119465393, 0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, -0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, 0.151522881682832, 0.0262445329583912, 0, 0, 0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, 0.117369119465393, -0.0606091526731326, -0.0787335988751736, 0, 0.101644639076841, 0.131222664791956, 0.090913729009699},
      {0.106066017177982, 0, 0.3, 0, -0.151522881682832, 0.0262445329583912, 0, 0, -0.131222664791956, -0.136370593514548},
      {0.106066017177982, -0.259807621135332, -0.15, -0.0782460796435951, 0.090913729009699, 0.0962299541807677, 0.180401338290886, 0.0508223195384204, -0.0131222664791956, -0.0227284322524248},
      {0.106066017177982, 0.259807621135332, -0.15, -0.0782460796435952, -0.090913729009699, 0.0962299541807677, -0.180401338290886, 0.0508223195384203, 0.0131222664791956, -0.0227284322524247},
      {0.636396103067893, 0, 0, -0.234738238930785, 0, -0.262445329583912, 0, -0.203289278153681, 0, 0.090913729009699}};
    
      // Interesting (new) part
      // Tables of derivatives of the polynomial base (transpose)
      const static double dmats0[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.89897948556636, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {0, 9.48683298050514, 0, 0, 0, 0, 0, 0, 0, 0},
      {4, 0, 7.07106781186548, 0, 0, 0, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {5.29150262212918, 0, -2.99332590941915, 13.6626010212795, 0, 0.611010092660779, 0, 0, 0, 0},
      {0, 4.38178046004133, 0, 0, 12.5219806739988, 0, 0, 0, 0, 0},
      {3.46410161513775, 0, 7.83836717690617, 0, 0, 8.4, 0, 0, 0, 0},
      {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    
      const static double dmats1[10][10] =   \
      {{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.44948974278318, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {4.24264068711928, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {2.58198889747161, 4.74341649025257, -0.912870929175276, 0, 0, 0, 0, 0, 0, 0},
      {2, 6.12372435695795, 3.53553390593274, 0, 0, 0, 0, 0, 0, 0},
      {-2.3094010767585, 0, 8.16496580927726, 0, 0, 0, 0, 0, 0, 0},
      {2.64575131106459, 5.18459255872629, -1.49666295470958, 6.83130051063973, -1.05830052442584, 0.305505046330391, 0, 0, 0, 0},
      {2.23606797749979, 2.19089023002067, 2.5298221281347, 8.08290376865476, 6.26099033699941, -1.80739222823013, 0, 0, 0, 0},
      {1.73205080756888, -5.09116882454314, 3.91918358845309, 0, 9.69948452238571, 4.2, 0, 0, 0, 0},
      {5, 0, -2.82842712474619, 0, 0, 12.1243556529821, 0, 0, 0, 0}};
    
      // Compute reference derivatives
      // Declare pointer to array of derivatives on FIAT element
      double *derivatives = new double [num_derivatives];
    
      // Declare coefficients
      double coeff0_0 = 0;
      double coeff0_1 = 0;
      double coeff0_2 = 0;
      double coeff0_3 = 0;
      double coeff0_4 = 0;
      double coeff0_5 = 0;
      double coeff0_6 = 0;
      double coeff0_7 = 0;
      double coeff0_8 = 0;
      double coeff0_9 = 0;
    
      // Declare new coefficients
      double new_coeff0_0 = 0;
      double new_coeff0_1 = 0;
      double new_coeff0_2 = 0;
      double new_coeff0_3 = 0;
      double new_coeff0_4 = 0;
      double new_coeff0_5 = 0;
      double new_coeff0_6 = 0;
      double new_coeff0_7 = 0;
      double new_coeff0_8 = 0;
      double new_coeff0_9 = 0;
    
      // Loop possible derivatives
      for (unsigned int deriv_num = 0; deriv_num < num_derivatives; deriv_num++)
      {
        // Get values from coefficients array
        new_coeff0_0 = coefficients0[dof][0];
        new_coeff0_1 = coefficients0[dof][1];
        new_coeff0_2 = coefficients0[dof][2];
        new_coeff0_3 = coefficients0[dof][3];
        new_coeff0_4 = coefficients0[dof][4];
        new_coeff0_5 = coefficients0[dof][5];
        new_coeff0_6 = coefficients0[dof][6];
        new_coeff0_7 = coefficients0[dof][7];
        new_coeff0_8 = coefficients0[dof][8];
        new_coeff0_9 = coefficients0[dof][9];
    
        // Loop derivative order
        for (unsigned int j = 0; j < n; j++)
        {
          // Update old coefficients
          coeff0_0 = new_coeff0_0;
          coeff0_1 = new_coeff0_1;
          coeff0_2 = new_coeff0_2;
          coeff0_3 = new_coeff0_3;
          coeff0_4 = new_coeff0_4;
          coeff0_5 = new_coeff0_5;
          coeff0_6 = new_coeff0_6;
          coeff0_7 = new_coeff0_7;
          coeff0_8 = new_coeff0_8;
          coeff0_9 = new_coeff0_9;
    
          if(combinations[deriv_num][j] == 0)
          {
            new_coeff0_0 = coeff0_0*dmats0[0][0] + coeff0_1*dmats0[1][0] + coeff0_2*dmats0[2][0] + coeff0_3*dmats0[3][0] + coeff0_4*dmats0[4][0] + coeff0_5*dmats0[5][0] + coeff0_6*dmats0[6][0] + coeff0_7*dmats0[7][0] + coeff0_8*dmats0[8][0] + coeff0_9*dmats0[9][0];
            new_coeff0_1 = coeff0_0*dmats0[0][1] + coeff0_1*dmats0[1][1] + coeff0_2*dmats0[2][1] + coeff0_3*dmats0[3][1] + coeff0_4*dmats0[4][1] + coeff0_5*dmats0[5][1] + coeff0_6*dmats0[6][1] + coeff0_7*dmats0[7][1] + coeff0_8*dmats0[8][1] + coeff0_9*dmats0[9][1];
            new_coeff0_2 = coeff0_0*dmats0[0][2] + coeff0_1*dmats0[1][2] + coeff0_2*dmats0[2][2] + coeff0_3*dmats0[3][2] + coeff0_4*dmats0[4][2] + coeff0_5*dmats0[5][2] + coeff0_6*dmats0[6][2] + coeff0_7*dmats0[7][2] + coeff0_8*dmats0[8][2] + coeff0_9*dmats0[9][2];
            new_coeff0_3 = coeff0_0*dmats0[0][3] + coeff0_1*dmats0[1][3] + coeff0_2*dmats0[2][3] + coeff0_3*dmats0[3][3] + coeff0_4*dmats0[4][3] + coeff0_5*dmats0[5][3] + coeff0_6*dmats0[6][3] + coeff0_7*dmats0[7][3] + coeff0_8*dmats0[8][3] + coeff0_9*dmats0[9][3];
            new_coeff0_4 = coeff0_0*dmats0[0][4] + coeff0_1*dmats0[1][4] + coeff0_2*dmats0[2][4] + coeff0_3*dmats0[3][4] + coeff0_4*dmats0[4][4] + coeff0_5*dmats0[5][4] + coeff0_6*dmats0[6][4] + coeff0_7*dmats0[7][4] + coeff0_8*dmats0[8][4] + coeff0_9*dmats0[9][4];
            new_coeff0_5 = coeff0_0*dmats0[0][5] + coeff0_1*dmats0[1][5] + coeff0_2*dmats0[2][5] + coeff0_3*dmats0[3][5] + coeff0_4*dmats0[4][5] + coeff0_5*dmats0[5][5] + coeff0_6*dmats0[6][5] + coeff0_7*dmats0[7][5] + coeff0_8*dmats0[8][5] + coeff0_9*dmats0[9][5];
            new_coeff0_6 = coeff0_0*dmats0[0][6] + coeff0_1*dmats0[1][6] + coeff0_2*dmats0[2][6] + coeff0_3*dmats0[3][6] + coeff0_4*dmats0[4][6] + coeff0_5*dmats0[5][6] + coeff0_6*dmats0[6][6] + coeff0_7*dmats0[7][6] + coeff0_8*dmats0[8][6] + coeff0_9*dmats0[9][6];
            new_coeff0_7 = coeff0_0*dmats0[0][7] + coeff0_1*dmats0[1][7] + coeff0_2*dmats0[2][7] + coeff0_3*dmats0[3][7] + coeff0_4*dmats0[4][7] + coeff0_5*dmats0[5][7] + coeff0_6*dmats0[6][7] + coeff0_7*dmats0[7][7] + coeff0_8*dmats0[8][7] + coeff0_9*dmats0[9][7];
            new_coeff0_8 = coeff0_0*dmats0[0][8] + coeff0_1*dmats0[1][8] + coeff0_2*dmats0[2][8] + coeff0_3*dmats0[3][8] + coeff0_4*dmats0[4][8] + coeff0_5*dmats0[5][8] + coeff0_6*dmats0[6][8] + coeff0_7*dmats0[7][8] + coeff0_8*dmats0[8][8] + coeff0_9*dmats0[9][8];
            new_coeff0_9 = coeff0_0*dmats0[0][9] + coeff0_1*dmats0[1][9] + coeff0_2*dmats0[2][9] + coeff0_3*dmats0[3][9] + coeff0_4*dmats0[4][9] + coeff0_5*dmats0[5][9] + coeff0_6*dmats0[6][9] + coeff0_7*dmats0[7][9] + coeff0_8*dmats0[8][9] + coeff0_9*dmats0[9][9];
          }
          if(combinations[deriv_num][j] == 1)
          {
            new_coeff0_0 = coeff0_0*dmats1[0][0] + coeff0_1*dmats1[1][0] + coeff0_2*dmats1[2][0] + coeff0_3*dmats1[3][0] + coeff0_4*dmats1[4][0] + coeff0_5*dmats1[5][0] + coeff0_6*dmats1[6][0] + coeff0_7*dmats1[7][0] + coeff0_8*dmats1[8][0] + coeff0_9*dmats1[9][0];
            new_coeff0_1 = coeff0_0*dmats1[0][1] + coeff0_1*dmats1[1][1] + coeff0_2*dmats1[2][1] + coeff0_3*dmats1[3][1] + coeff0_4*dmats1[4][1] + coeff0_5*dmats1[5][1] + coeff0_6*dmats1[6][1] + coeff0_7*dmats1[7][1] + coeff0_8*dmats1[8][1] + coeff0_9*dmats1[9][1];
            new_coeff0_2 = coeff0_0*dmats1[0][2] + coeff0_1*dmats1[1][2] + coeff0_2*dmats1[2][2] + coeff0_3*dmats1[3][2] + coeff0_4*dmats1[4][2] + coeff0_5*dmats1[5][2] + coeff0_6*dmats1[6][2] + coeff0_7*dmats1[7][2] + coeff0_8*dmats1[8][2] + coeff0_9*dmats1[9][2];
            new_coeff0_3 = coeff0_0*dmats1[0][3] + coeff0_1*dmats1[1][3] + coeff0_2*dmats1[2][3] + coeff0_3*dmats1[3][3] + coeff0_4*dmats1[4][3] + coeff0_5*dmats1[5][3] + coeff0_6*dmats1[6][3] + coeff0_7*dmats1[7][3] + coeff0_8*dmats1[8][3] + coeff0_9*dmats1[9][3];
            new_coeff0_4 = coeff0_0*dmats1[0][4] + coeff0_1*dmats1[1][4] + coeff0_2*dmats1[2][4] + coeff0_3*dmats1[3][4] + coeff0_4*dmats1[4][4] + coeff0_5*dmats1[5][4] + coeff0_6*dmats1[6][4] + coeff0_7*dmats1[7][4] + coeff0_8*dmats1[8][4] + coeff0_9*dmats1[9][4];
            new_coeff0_5 = coeff0_0*dmats1[0][5] + coeff0_1*dmats1[1][5] + coeff0_2*dmats1[2][5] + coeff0_3*dmats1[3][5] + coeff0_4*dmats1[4][5] + coeff0_5*dmats1[5][5] + coeff0_6*dmats1[6][5] + coeff0_7*dmats1[7][5] + coeff0_8*dmats1[8][5] + coeff0_9*dmats1[9][5];
            new_coeff0_6 = coeff0_0*dmats1[0][6] + coeff0_1*dmats1[1][6] + coeff0_2*dmats1[2][6] + coeff0_3*dmats1[3][6] + coeff0_4*dmats1[4][6] + coeff0_5*dmats1[5][6] + coeff0_6*dmats1[6][6] + coeff0_7*dmats1[7][6] + coeff0_8*dmats1[8][6] + coeff0_9*dmats1[9][6];
            new_coeff0_7 = coeff0_0*dmats1[0][7] + coeff0_1*dmats1[1][7] + coeff0_2*dmats1[2][7] + coeff0_3*dmats1[3][7] + coeff0_4*dmats1[4][7] + coeff0_5*dmats1[5][7] + coeff0_6*dmats1[6][7] + coeff0_7*dmats1[7][7] + coeff0_8*dmats1[8][7] + coeff0_9*dmats1[9][7];
            new_coeff0_8 = coeff0_0*dmats1[0][8] + coeff0_1*dmats1[1][8] + coeff0_2*dmats1[2][8] + coeff0_3*dmats1[3][8] + coeff0_4*dmats1[4][8] + coeff0_5*dmats1[5][8] + coeff0_6*dmats1[6][8] + coeff0_7*dmats1[7][8] + coeff0_8*dmats1[8][8] + coeff0_9*dmats1[9][8];
            new_coeff0_9 = coeff0_0*dmats1[0][9] + coeff0_1*dmats1[1][9] + coeff0_2*dmats1[2][9] + coeff0_3*dmats1[3][9] + coeff0_4*dmats1[4][9] + coeff0_5*dmats1[5][9] + coeff0_6*dmats1[6][9] + coeff0_7*dmats1[7][9] + coeff0_8*dmats1[8][9] + coeff0_9*dmats1[9][9];
          }
    
        }
        // Compute derivatives on reference element as dot product of coefficients and basisvalues
        derivatives[deriv_num] = new_coeff0_0*basisvalue0 + new_coeff0_1*basisvalue1 + new_coeff0_2*basisvalue2 + new_coeff0_3*basisvalue3 + new_coeff0_4*basisvalue4 + new_coeff0_5*basisvalue5 + new_coeff0_6*basisvalue6 + new_coeff0_7*basisvalue7 + new_coeff0_8*basisvalue8 + new_coeff0_9*basisvalue9;
      }
    
      // Transform derivatives back to physical element
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        for (unsigned int col = 0; col < num_derivatives; col++)
        {
          values[num_derivatives + row] += transform[row][col]*derivatives[col];
        }
      }
      // Delete pointer to array of derivatives on FIAT element
      delete [] derivatives;
    
      // Delete pointer to array of combinations of derivatives and transform
      for (unsigned int row = 0; row < num_derivatives; row++)
      {
        delete [] combinations[row];
        delete [] transform[row];
      }
    
      delete [] combinations;
      delete [] transform;
    }
    
  }

  /// Evaluate order n derivatives of all basis functions at given point in cell
  virtual void evaluate_basis_derivatives_all(unsigned int n,
                                              double* values,
                                              const double* coordinates,
                                              const ufc::cell& c) const
  {
    throw std::runtime_error("The vectorised version of evaluate_basis_derivatives() is not yet implemented.");
  }

  /// Evaluate linear functional for dof i on the function f
  virtual double evaluate_dof(unsigned int i,
                              const ufc::function& f,
                              const ufc::cell& c) const
  {
    // The reference points, direction and weights:
    const static double X[20][1][2] = {{{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}, {{0, 0}}, {{1, 0}}, {{0, 1}}, {{0.666666666666667, 0.333333333333333}}, {{0.333333333333333, 0.666666666666667}}, {{0, 0.333333333333333}}, {{0, 0.666666666666667}}, {{0.333333333333333, 0}}, {{0.666666666666667, 0}}, {{0.333333333333333, 0.333333333333333}}};
    const static double W[20][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    const static double D[20][1][2] = {{{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{1, 0}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}, {{0, 1}}};
    
    const double * const * x = c.coordinates;
    double result = 0.0;
    // Iterate over the points:
    // Evaluate basis functions for affine mapping
    const double w0 = 1.0 - X[i][0][0] - X[i][0][1];
    const double w1 = X[i][0][0];
    const double w2 = X[i][0][1];
    
    // Compute affine mapping y = F(X)
    double y[2];
    y[0] = w0*x[0][0] + w1*x[1][0] + w2*x[2][0];
    y[1] = w0*x[0][1] + w1*x[1][1] + w2*x[2][1];
    
    // Evaluate function at physical points
    double values[2];
    f.evaluate(values, y, c);
    
    // Map function values using appropriate mapping
    // Affine map: Do nothing
    
    // Note that we do not map the weights (yet).
    
    // Take directional components
    for(int k = 0; k < 2; k++)
      result += values[k]*D[i][0][k];
    // Multiply by weights 
    result *= W[i][0];
    
    return result;
  }

  /// Evaluate linear functionals for all dofs on the function f
  virtual void evaluate_dofs(double* values,
                             const ufc::function& f,
                             const ufc::cell& c) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Interpolate vertex values from dof values
  virtual void interpolate_vertex_values(double* vertex_values,
                                         const double* dof_values,
                                         const ufc::cell& c) const
  {
    // Evaluate at vertices and use affine mapping
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate at vertices and use affine mapping
    vertex_values[1] = dof_values[10];
    vertex_values[3] = dof_values[11];
    vertex_values[5] = dof_values[12];
  }

  /// Return the number of sub elements (for a mixed element)
  virtual unsigned int num_sub_elements() const
  {
    return 2;
  }

  /// Create a new finite element for sub element i (for a mixed element)
  virtual ufc::finite_element* create_sub_element(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_finite_element_2_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_finite_element_2_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_0_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_0_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_0_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_0_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_0_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_0_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_0_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_0_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 4*m.num_entities[1] + 2*m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 20;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 8;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
    offset = offset + m.num_entities[2];
    dofs[10] = offset + c.entity_indices[0][0];
    dofs[11] = offset + c.entity_indices[0][1];
    dofs[12] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[13] = offset + 2*c.entity_indices[1][0];
    dofs[14] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[15] = offset + 2*c.entity_indices[1][1];
    dofs[16] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[17] = offset + 2*c.entity_indices[1][2];
    dofs[18] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[19] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 11;
      dofs[5] = 12;
      dofs[6] = 13;
      dofs[7] = 14;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 10;
      dofs[5] = 12;
      dofs[6] = 15;
      dofs[7] = 16;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      dofs[4] = 10;
      dofs[5] = 11;
      dofs[6] = 17;
      dofs[7] = 18;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[10][0] = x[0][0];
    coordinates[10][1] = x[0][1];
    coordinates[11][0] = x[1][0];
    coordinates[11][1] = x[1][1];
    coordinates[12][0] = x[2][0];
    coordinates[12][1] = x[2][1];
    coordinates[13][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[13][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[14][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[14][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[15][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[15][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[16][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[16][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[17][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[17][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[18][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[18][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[19][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[19][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_dof_map_0_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_dof_map_0_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_1_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_1_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_1_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_1_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_1_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_1_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_1_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_1_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 4*m.num_entities[1] + 2*m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 20;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 8;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
    offset = offset + m.num_entities[2];
    dofs[10] = offset + c.entity_indices[0][0];
    dofs[11] = offset + c.entity_indices[0][1];
    dofs[12] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[13] = offset + 2*c.entity_indices[1][0];
    dofs[14] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[15] = offset + 2*c.entity_indices[1][1];
    dofs[16] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[17] = offset + 2*c.entity_indices[1][2];
    dofs[18] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[19] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 11;
      dofs[5] = 12;
      dofs[6] = 13;
      dofs[7] = 14;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 10;
      dofs[5] = 12;
      dofs[6] = 15;
      dofs[7] = 16;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      dofs[4] = 10;
      dofs[5] = 11;
      dofs[6] = 17;
      dofs[7] = 18;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[10][0] = x[0][0];
    coordinates[10][1] = x[0][1];
    coordinates[11][0] = x[1][0];
    coordinates[11][1] = x[1][1];
    coordinates[12][0] = x[2][0];
    coordinates[12][1] = x[2][1];
    coordinates[13][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[13][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[14][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[14][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[15][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[15][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[16][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[16][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[17][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[17][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[18][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[18][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[19][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[19][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_dof_map_1_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_dof_map_1_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_2_0: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_2_0() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_2_0()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_2_0();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_2_1: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_2_1() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_2_1()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Lagrange finite element of degree 3 on a triangle";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = m.num_entities[0] + 2*m.num_entities[1] + m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 10;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 4;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 1;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_dof_map_2_1();
  }

};

/// This class defines the interface for a local-to-global mapping of
/// degrees of freedom (dofs).

class UFC_Nonlinear2DBilinearForm_dof_map_2: public ufc::dof_map
{
private:

  unsigned int __global_dimension;

public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_dof_map_2() : ufc::dof_map()
  {
    __global_dimension = 0;
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_dof_map_2()
  {
    // Do nothing
  }

  /// Return a string identifying the dof map
  virtual const char* signature() const
  {
    return "FFC dof map for Mixed finite element: [Lagrange finite element of degree 3 on a triangle, Lagrange finite element of degree 3 on a triangle]";
  }

  /// Return true iff mesh entities of topological dimension d are needed
  virtual bool needs_mesh_entities(unsigned int d) const
  {
    switch ( d )
    {
    case 0:
      return true;
      break;
    case 1:
      return true;
      break;
    case 2:
      return true;
      break;
    }
    return false;
  }

  /// Initialize dof map for mesh (return true iff init_cell() is needed)
  virtual bool init_mesh(const ufc::mesh& m)
  {
    __global_dimension = 2*m.num_entities[0] + 4*m.num_entities[1] + 2*m.num_entities[2];
    return false;
  }

  /// Initialize dof map for given cell
  virtual void init_cell(const ufc::mesh& m,
                         const ufc::cell& c)
  {
    // Do nothing
  }

  /// Finish initialization of dof map for cells
  virtual void init_cell_finalize()
  {
    // Do nothing
  }

  /// Return the dimension of the global finite element function space
  virtual unsigned int global_dimension() const
  {
    return __global_dimension;
  }

  /// Return the dimension of the local finite element function space
  virtual unsigned int local_dimension() const
  {
    return 20;
  }

  // Return the geometric dimension of the coordinates this dof map provides
  virtual unsigned int geometric_dimension() const
  {
    return 2;
  }

  /// Return the number of dofs on each cell facet
  virtual unsigned int num_facet_dofs() const
  {
    return 8;
  }

  /// Return the number of dofs associated with each cell entity of dimension d
  virtual unsigned int num_entity_dofs(unsigned int d) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the local-to-global mapping of dofs on a cell
  virtual void tabulate_dofs(unsigned int* dofs,
                             const ufc::mesh& m,
                             const ufc::cell& c) const
  {
    dofs[0] = c.entity_indices[0][0];
    dofs[1] = c.entity_indices[0][1];
    dofs[2] = c.entity_indices[0][2];
    unsigned int offset = m.num_entities[0];
    dofs[3] = offset + 2*c.entity_indices[1][0];
    dofs[4] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[5] = offset + 2*c.entity_indices[1][1];
    dofs[6] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[7] = offset + 2*c.entity_indices[1][2];
    dofs[8] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[9] = offset + c.entity_indices[2][0];
    offset = offset + m.num_entities[2];
    dofs[10] = offset + c.entity_indices[0][0];
    dofs[11] = offset + c.entity_indices[0][1];
    dofs[12] = offset + c.entity_indices[0][2];
    offset = offset + m.num_entities[0];
    dofs[13] = offset + 2*c.entity_indices[1][0];
    dofs[14] = offset + 2*c.entity_indices[1][0] + 1;
    dofs[15] = offset + 2*c.entity_indices[1][1];
    dofs[16] = offset + 2*c.entity_indices[1][1] + 1;
    dofs[17] = offset + 2*c.entity_indices[1][2];
    dofs[18] = offset + 2*c.entity_indices[1][2] + 1;
    offset = offset + 2*m.num_entities[1];
    dofs[19] = offset + c.entity_indices[2][0];
  }

  /// Tabulate the local-to-local mapping from facet dofs to cell dofs
  virtual void tabulate_facet_dofs(unsigned int* dofs,
                                   unsigned int facet) const
  {
    switch ( facet )
    {
    case 0:
      dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 11;
      dofs[5] = 12;
      dofs[6] = 13;
      dofs[7] = 14;
      break;
    case 1:
      dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 5;
      dofs[3] = 6;
      dofs[4] = 10;
      dofs[5] = 12;
      dofs[6] = 15;
      dofs[7] = 16;
      break;
    case 2:
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 7;
      dofs[3] = 8;
      dofs[4] = 10;
      dofs[5] = 11;
      dofs[6] = 17;
      dofs[7] = 18;
      break;
    }
  }

  /// Tabulate the local-to-local mapping of dofs on entity (d, i)
  virtual void tabulate_entity_dofs(unsigned int* dofs,
                                    unsigned int d, unsigned int i) const
  {
    throw std::runtime_error("Not implemented (introduced in UFC v1.1).");
  }

  /// Tabulate the coordinates of all dofs on a cell
  virtual void tabulate_coordinates(double** coordinates,
                                    const ufc::cell& c) const
  {
    const double * const * x = c.coordinates;
    coordinates[0][0] = x[0][0];
    coordinates[0][1] = x[0][1];
    coordinates[1][0] = x[1][0];
    coordinates[1][1] = x[1][1];
    coordinates[2][0] = x[2][0];
    coordinates[2][1] = x[2][1];
    coordinates[3][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[3][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[4][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[4][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[5][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[5][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[6][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[6][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[7][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[7][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[8][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[8][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[9][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[9][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[10][0] = x[0][0];
    coordinates[10][1] = x[0][1];
    coordinates[11][0] = x[1][0];
    coordinates[11][1] = x[1][1];
    coordinates[12][0] = x[2][0];
    coordinates[12][1] = x[2][1];
    coordinates[13][0] = 0.666666666666667*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[13][1] = 0.666666666666667*x[1][1] + 0.333333333333333*x[2][1];
    coordinates[14][0] = 0.333333333333333*x[1][0] + 0.666666666666667*x[2][0];
    coordinates[14][1] = 0.333333333333333*x[1][1] + 0.666666666666667*x[2][1];
    coordinates[15][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[2][0];
    coordinates[15][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[2][1];
    coordinates[16][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[2][0];
    coordinates[16][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[2][1];
    coordinates[17][0] = 0.666666666666667*x[0][0] + 0.333333333333333*x[1][0];
    coordinates[17][1] = 0.666666666666667*x[0][1] + 0.333333333333333*x[1][1];
    coordinates[18][0] = 0.333333333333333*x[0][0] + 0.666666666666667*x[1][0];
    coordinates[18][1] = 0.333333333333333*x[0][1] + 0.666666666666667*x[1][1];
    coordinates[19][0] = 0.333333333333333*x[0][0] + 0.333333333333333*x[1][0] + 0.333333333333333*x[2][0];
    coordinates[19][1] = 0.333333333333333*x[0][1] + 0.333333333333333*x[1][1] + 0.333333333333333*x[2][1];
  }

  /// Return the number of sub dof maps (for a mixed element)
  virtual unsigned int num_sub_dof_maps() const
  {
    return 2;
  }

  /// Create a new dof_map for sub dof map i (for a mixed element)
  virtual ufc::dof_map* create_sub_dof_map(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_dof_map_2_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_dof_map_2_1();
      break;
    }
    return 0;
  }

};

/// This class defines the interface for the tabulation of the cell
/// tensor corresponding to the local contribution to a form from
/// the integral over a cell.

class UFC_Nonlinear2DBilinearForm_cell_integral_0: public ufc::cell_integral
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm_cell_integral_0() : ufc::cell_integral()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm_cell_integral_0()
  {
    // Do nothing
  }

  /// Tabulate the tensor for the contribution from a local cell
  virtual void tabulate_tensor(double* A,
                               const double * const * w,
                               const ufc::cell& c) const
  {
    // Extract vertex coordinates
    const double * const * x = c.coordinates;
    
    // Compute Jacobian of affine map from reference cell
    const double J_00 = x[1][0] - x[0][0];
    const double J_01 = x[2][0] - x[0][0];
    const double J_10 = x[1][1] - x[0][1];
    const double J_11 = x[2][1] - x[0][1];
      
    // Compute determinant of Jacobian
    double detJ = J_00*J_11 - J_01*J_10;
      
    // Compute inverse of Jacobian
    const double Jinv_00 =  J_11 / detJ;
    const double Jinv_01 = -J_01 / detJ;
    const double Jinv_10 = -J_10 / detJ;
    const double Jinv_11 =  J_00 / detJ;
    
    // Set scale factor
    const double det = std::abs(detJ);
    
    // Compute coefficients
    const double c0_0_0_0 = w[0][0];
    const double c0_0_0_1 = w[0][1];
    const double c0_0_0_2 = w[0][2];
    const double c0_0_0_3 = w[0][3];
    const double c0_0_0_4 = w[0][4];
    const double c0_0_0_5 = w[0][5];
    const double c0_0_0_6 = w[0][6];
    const double c0_0_0_7 = w[0][7];
    const double c0_0_0_8 = w[0][8];
    const double c0_0_0_9 = w[0][9];
    const double c0_0_0_10 = w[0][10];
    const double c0_0_0_11 = w[0][11];
    const double c0_0_0_12 = w[0][12];
    const double c0_0_0_13 = w[0][13];
    const double c0_0_0_14 = w[0][14];
    const double c0_0_0_15 = w[0][15];
    const double c0_0_0_16 = w[0][16];
    const double c0_0_0_17 = w[0][17];
    const double c0_0_0_18 = w[0][18];
    const double c0_0_0_19 = w[0][19];
    
    // Compute geometry tensors
    const double G0_0_0_0 = det*c0_0_0_0*Jinv_00;
    const double G0_0_0_1 = det*c0_0_0_0*Jinv_10;
    const double G0_0_1_0 = det*c0_0_0_1*Jinv_00;
    const double G0_0_1_1 = det*c0_0_0_1*Jinv_10;
    const double G0_0_2_0 = det*c0_0_0_2*Jinv_00;
    const double G0_0_2_1 = det*c0_0_0_2*Jinv_10;
    const double G0_0_3_0 = det*c0_0_0_3*Jinv_00;
    const double G0_0_3_1 = det*c0_0_0_3*Jinv_10;
    const double G0_0_4_0 = det*c0_0_0_4*Jinv_00;
    const double G0_0_4_1 = det*c0_0_0_4*Jinv_10;
    const double G0_0_5_0 = det*c0_0_0_5*Jinv_00;
    const double G0_0_5_1 = det*c0_0_0_5*Jinv_10;
    const double G0_0_6_0 = det*c0_0_0_6*Jinv_00;
    const double G0_0_6_1 = det*c0_0_0_6*Jinv_10;
    const double G0_0_7_0 = det*c0_0_0_7*Jinv_00;
    const double G0_0_7_1 = det*c0_0_0_7*Jinv_10;
    const double G0_0_8_0 = det*c0_0_0_8*Jinv_00;
    const double G0_0_8_1 = det*c0_0_0_8*Jinv_10;
    const double G0_0_9_0 = det*c0_0_0_9*Jinv_00;
    const double G0_0_9_1 = det*c0_0_0_9*Jinv_10;
    const double G0_1_10_0 = det*c0_0_0_10*Jinv_01;
    const double G0_1_10_1 = det*c0_0_0_10*Jinv_11;
    const double G0_1_11_0 = det*c0_0_0_11*Jinv_01;
    const double G0_1_11_1 = det*c0_0_0_11*Jinv_11;
    const double G0_1_12_0 = det*c0_0_0_12*Jinv_01;
    const double G0_1_12_1 = det*c0_0_0_12*Jinv_11;
    const double G0_1_13_0 = det*c0_0_0_13*Jinv_01;
    const double G0_1_13_1 = det*c0_0_0_13*Jinv_11;
    const double G0_1_14_0 = det*c0_0_0_14*Jinv_01;
    const double G0_1_14_1 = det*c0_0_0_14*Jinv_11;
    const double G0_1_15_0 = det*c0_0_0_15*Jinv_01;
    const double G0_1_15_1 = det*c0_0_0_15*Jinv_11;
    const double G0_1_16_0 = det*c0_0_0_16*Jinv_01;
    const double G0_1_16_1 = det*c0_0_0_16*Jinv_11;
    const double G0_1_17_0 = det*c0_0_0_17*Jinv_01;
    const double G0_1_17_1 = det*c0_0_0_17*Jinv_11;
    const double G0_1_18_0 = det*c0_0_0_18*Jinv_01;
    const double G0_1_18_1 = det*c0_0_0_18*Jinv_11;
    const double G0_1_19_0 = det*c0_0_0_19*Jinv_01;
    const double G0_1_19_1 = det*c0_0_0_19*Jinv_11;
    
    // Compute element tensor
    A[0] = -0.0177083333333332*G0_0_0_0 - 0.0177083333333332*G0_0_0_1 - 0.00148809523809523*G0_0_1_0 - 0.00148809523809523*G0_0_1_1 - 0.00148809523809523*G0_0_2_0 - 0.00148809523809523*G0_0_2_1 - 0.0133928571428571*G0_0_5_0 - 0.0133928571428571*G0_0_5_1 + 0.00602678571428568*G0_0_6_0 + 0.00602678571428568*G0_0_6_1 - 0.0133928571428571*G0_0_7_0 - 0.0133928571428571*G0_0_7_1 + 0.00602678571428568*G0_0_8_0 + 0.00602678571428568*G0_0_8_1 - 0.00267857142857142*G0_0_9_0 - 0.00267857142857142*G0_0_9_1 - 0.0177083333333332*G0_1_10_0 - 0.0177083333333332*G0_1_10_1 - 0.00148809523809523*G0_1_11_0 - 0.00148809523809523*G0_1_11_1 - 0.00148809523809523*G0_1_12_0 - 0.00148809523809523*G0_1_12_1 - 0.0133928571428571*G0_1_15_0 - 0.0133928571428571*G0_1_15_1 + 0.00602678571428568*G0_1_16_0 + 0.00602678571428568*G0_1_16_1 - 0.0133928571428571*G0_1_17_0 - 0.0133928571428571*G0_1_17_1 + 0.00602678571428568*G0_1_18_0 + 0.00602678571428568*G0_1_18_1 - 0.00267857142857142*G0_1_19_0 - 0.00267857142857142*G0_1_19_1;
    A[1] = 0.00297619047619046*G0_0_0_0 + 0.00148809523809523*G0_0_1_0 + 0.000885416666666662*G0_0_2_0 + 0.00241071428571427*G0_0_3_0 - 0.00180803571428571*G0_0_4_0 + 0.00234374999999999*G0_0_5_0 - 0.00140624999999999*G0_0_6_0 + 0.000334821428571429*G0_0_7_0 + 0.00261160714285713*G0_0_8_0 + 0.00147321428571428*G0_0_9_0 + 0.00297619047619046*G0_1_10_0 + 0.00148809523809523*G0_1_11_0 + 0.000885416666666662*G0_1_12_0 + 0.00241071428571427*G0_1_13_0 - 0.00180803571428571*G0_1_14_0 + 0.00234374999999999*G0_1_15_0 - 0.00140624999999999*G0_1_16_0 + 0.000334821428571429*G0_1_17_0 + 0.00261160714285713*G0_1_18_0 + 0.00147321428571428*G0_1_19_0;
    A[2] = 0.00297619047619045*G0_0_0_1 + 0.000885416666666662*G0_0_1_1 + 0.00148809523809523*G0_0_2_1 - 0.00180803571428571*G0_0_3_1 + 0.00241071428571428*G0_0_4_1 + 0.000334821428571421*G0_0_5_1 + 0.00261160714285714*G0_0_6_1 + 0.00234374999999998*G0_0_7_1 - 0.00140624999999999*G0_0_8_1 + 0.00147321428571428*G0_0_9_1 + 0.00297619047619045*G0_1_10_1 + 0.000885416666666662*G0_1_11_1 + 0.00148809523809523*G0_1_12_1 - 0.00180803571428571*G0_1_13_1 + 0.00241071428571428*G0_1_14_1 + 0.000334821428571421*G0_1_15_1 + 0.00261160714285714*G0_1_16_1 + 0.00234374999999998*G0_1_17_1 - 0.00140624999999999*G0_1_18_1 + 0.00147321428571428*G0_1_19_1;
    A[3] = -6.69642857142867e-05*G0_0_1_0 + 0.00234374999999998*G0_0_1_1 - 0.00140624999999999*G0_0_2_0 + 0.000401785714285712*G0_0_2_1 + 0.00743303571428568*G0_0_3_0 + 0.00743303571428567*G0_0_3_1 + 0.00140625*G0_0_4_0 - 0.00281249999999999*G0_0_4_1 - 0.00200892857142856*G0_0_5_0 - 0.00100446428571428*G0_0_5_1 - 0.000200892857142856*G0_0_6_0 - 0.000401785714285713*G0_0_6_1 - 0.00401785714285713*G0_0_7_0 - 0.0050223214285714*G0_0_7_1 + 0.00381696428571427*G0_0_8_0 + 0.00763392857142852*G0_0_8_1 + 0.00843749999999997*G0_0_9_0 + 0.00482142857142855*G0_0_9_1 - 6.69642857142867e-05*G0_1_11_0 + 0.00234374999999998*G0_1_11_1 - 0.00140624999999999*G0_1_12_0 + 0.000401785714285712*G0_1_12_1 + 0.00743303571428568*G0_1_13_0 + 0.00743303571428567*G0_1_13_1 + 0.00140625*G0_1_14_0 - 0.00281249999999999*G0_1_14_1 - 0.00200892857142856*G0_1_15_0 - 0.00100446428571428*G0_1_15_1 - 0.000200892857142856*G0_1_16_0 - 0.000401785714285713*G0_1_16_1 - 0.00401785714285713*G0_1_17_0 - 0.0050223214285714*G0_1_17_1 + 0.00381696428571427*G0_1_18_0 + 0.00763392857142852*G0_1_18_1 + 0.00843749999999997*G0_1_19_0 + 0.00482142857142855*G0_1_19_1;
    A[4] = 0.000401785714285714*G0_0_1_0 - 0.00140624999999999*G0_0_1_1 + 0.00234374999999999*G0_0_2_0 - 6.69642857142862e-05*G0_0_2_1 - 0.00281249999999999*G0_0_3_0 + 0.00140624999999999*G0_0_3_1 + 0.00743303571428569*G0_0_4_0 + 0.0074330357142857*G0_0_4_1 - 0.00502232142857141*G0_0_5_0 - 0.00401785714285713*G0_0_5_1 + 0.00763392857142854*G0_0_6_0 + 0.00381696428571428*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 - 0.00200892857142857*G0_0_7_1 - 0.000401785714285711*G0_0_8_0 - 0.000200892857142848*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.00843749999999997*G0_0_9_1 + 0.000401785714285714*G0_1_11_0 - 0.00140624999999999*G0_1_11_1 + 0.00234374999999999*G0_1_12_0 - 6.69642857142862e-05*G0_1_12_1 - 0.00281249999999999*G0_1_13_0 + 0.00140624999999999*G0_1_13_1 + 0.00743303571428569*G0_1_14_0 + 0.0074330357142857*G0_1_14_1 - 0.00502232142857141*G0_1_15_0 - 0.00401785714285713*G0_1_15_1 + 0.00763392857142854*G0_1_16_0 + 0.00381696428571428*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 - 0.00200892857142857*G0_1_17_1 - 0.000401785714285711*G0_1_18_0 - 0.000200892857142848*G0_1_18_1 + 0.00482142857142856*G0_1_19_0 + 0.00843749999999997*G0_1_19_1;
    A[5] = -0.00535714285714282*G0_0_0_0 + 0.0267857142857141*G0_0_0_1 + 6.69642857142895e-05*G0_0_1_0 + 0.00241071428571427*G0_0_1_1 - 6.69642857142837e-05*G0_0_2_0 + 0.0022767857142857*G0_0_2_1 - 0.000200892857142856*G0_0_3_0 - 0.00120535714285714*G0_0_3_1 + 0.00220982142857142*G0_0_4_0 + 0.00120535714285714*G0_0_4_1 - 0.00401785714285709*G0_0_5_0 + 0.0200892857142856*G0_0_5_1 + 0.0050223214285714*G0_0_6_0 - 0.00703124999999995*G0_0_6_1 - 0.00200892857142855*G0_0_7_0 + 0.0220982142857142*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 - 0.0110491071428571*G0_0_8_1 + 0.00602678571428572*G0_0_9_0 + 0.00602678571428571*G0_0_9_1 - 0.00535714285714282*G0_1_10_0 + 0.0267857142857141*G0_1_10_1 + 6.69642857142895e-05*G0_1_11_0 + 0.00241071428571427*G0_1_11_1 - 6.69642857142837e-05*G0_1_12_0 + 0.0022767857142857*G0_1_12_1 - 0.000200892857142856*G0_1_13_0 - 0.00120535714285714*G0_1_13_1 + 0.00220982142857142*G0_1_14_0 + 0.00120535714285714*G0_1_14_1 - 0.00401785714285709*G0_1_15_0 + 0.0200892857142856*G0_1_15_1 + 0.0050223214285714*G0_1_16_0 - 0.00703124999999995*G0_1_16_1 - 0.00200892857142855*G0_1_17_0 + 0.0220982142857142*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 - 0.0110491071428571*G0_1_18_1 + 0.00602678571428572*G0_1_19_0 + 0.00602678571428571*G0_1_19_1;
    A[6] = -0.0120535714285714*G0_0_0_1 - 0.000401785714285714*G0_0_1_0 - 0.00180803571428571*G0_0_1_1 - 0.00234374999999999*G0_0_2_0 - 0.0022767857142857*G0_0_2_1 + 0.00281249999999999*G0_0_3_0 + 0.00301339285714284*G0_0_3_1 - 0.00743303571428569*G0_0_4_0 - 0.00361607142857141*G0_0_4_1 + 0.00502232142857141*G0_0_5_0 - 0.00703124999999997*G0_0_5_1 - 0.00763392857142855*G0_0_6_0 - 0.00160714285714286*G0_0_6_1 + 0.00100446428571429*G0_0_7_0 - 0.0110491071428571*G0_0_7_1 + 0.000401785714285709*G0_0_8_0 + 0.0064285714285714*G0_0_8_1 - 0.00482142857142856*G0_0_9_0 - 0.00482142857142857*G0_0_9_1 - 0.0120535714285714*G0_1_10_1 - 0.000401785714285714*G0_1_11_0 - 0.00180803571428571*G0_1_11_1 - 0.00234374999999999*G0_1_12_0 - 0.0022767857142857*G0_1_12_1 + 0.00281249999999999*G0_1_13_0 + 0.00301339285714284*G0_1_13_1 - 0.00743303571428569*G0_1_14_0 - 0.00361607142857141*G0_1_14_1 + 0.00502232142857141*G0_1_15_0 - 0.00703124999999997*G0_1_15_1 - 0.00763392857142855*G0_1_16_0 - 0.00160714285714286*G0_1_16_1 + 0.00100446428571429*G0_1_17_0 - 0.0110491071428571*G0_1_17_1 + 0.000401785714285709*G0_1_18_0 + 0.0064285714285714*G0_1_18_1 - 0.00482142857142856*G0_1_19_0 - 0.00482142857142857*G0_1_19_1;
    A[7] = 0.0267857142857141*G0_0_0_0 - 0.00535714285714283*G0_0_0_1 + 0.0022767857142857*G0_0_1_0 - 6.69642857142869e-05*G0_0_1_1 + 0.00241071428571427*G0_0_2_0 + 6.69642857142869e-05*G0_0_2_1 + 0.00120535714285714*G0_0_3_0 + 0.00220982142857142*G0_0_3_1 - 0.00120535714285714*G0_0_4_0 - 0.000200892857142856*G0_0_4_1 + 0.0220982142857142*G0_0_5_0 - 0.00200892857142855*G0_0_5_1 - 0.0110491071428571*G0_0_6_0 + 0.00100446428571427*G0_0_6_1 + 0.0200892857142856*G0_0_7_0 - 0.00401785714285711*G0_0_7_1 - 0.00703124999999996*G0_0_8_0 + 0.0050223214285714*G0_0_8_1 + 0.00602678571428571*G0_0_9_0 + 0.00602678571428571*G0_0_9_1 + 0.0267857142857141*G0_1_10_0 - 0.00535714285714283*G0_1_10_1 + 0.0022767857142857*G0_1_11_0 - 6.69642857142869e-05*G0_1_11_1 + 0.00241071428571427*G0_1_12_0 + 6.69642857142869e-05*G0_1_12_1 + 0.00120535714285714*G0_1_13_0 + 0.00220982142857142*G0_1_13_1 - 0.00120535714285714*G0_1_14_0 - 0.000200892857142856*G0_1_14_1 + 0.0220982142857142*G0_1_15_0 - 0.00200892857142855*G0_1_15_1 - 0.0110491071428571*G0_1_16_0 + 0.00100446428571427*G0_1_16_1 + 0.0200892857142856*G0_1_17_0 - 0.00401785714285711*G0_1_17_1 - 0.00703124999999996*G0_1_18_0 + 0.0050223214285714*G0_1_18_1 + 0.00602678571428571*G0_1_19_0 + 0.00602678571428571*G0_1_19_1;
    A[8] = -0.0120535714285714*G0_0_0_0 - 0.00227678571428569*G0_0_1_0 - 0.00234374999999998*G0_0_1_1 - 0.0018080357142857*G0_0_2_0 - 0.000401785714285712*G0_0_2_1 - 0.00361607142857141*G0_0_3_0 - 0.00743303571428567*G0_0_3_1 + 0.00301339285714284*G0_0_4_0 + 0.00281249999999998*G0_0_4_1 - 0.0110491071428571*G0_0_5_0 + 0.00100446428571428*G0_0_5_1 + 0.0064285714285714*G0_0_6_0 + 0.000401785714285714*G0_0_6_1 - 0.00703124999999997*G0_0_7_0 + 0.0050223214285714*G0_0_7_1 - 0.00160714285714285*G0_0_8_0 - 0.00763392857142852*G0_0_8_1 - 0.00482142857142857*G0_0_9_0 - 0.00482142857142855*G0_0_9_1 - 0.0120535714285714*G0_1_10_0 - 0.00227678571428569*G0_1_11_0 - 0.00234374999999998*G0_1_11_1 - 0.0018080357142857*G0_1_12_0 - 0.000401785714285712*G0_1_12_1 - 0.00361607142857141*G0_1_13_0 - 0.00743303571428567*G0_1_13_1 + 0.00301339285714284*G0_1_14_0 + 0.00281249999999998*G0_1_14_1 - 0.0110491071428571*G0_1_15_0 + 0.00100446428571428*G0_1_15_1 + 0.0064285714285714*G0_1_16_0 + 0.000401785714285714*G0_1_16_1 - 0.00703124999999997*G0_1_17_0 + 0.0050223214285714*G0_1_17_1 - 0.00160714285714285*G0_1_18_0 - 0.00763392857142852*G0_1_18_1 - 0.00482142857142857*G0_1_19_0 - 0.00482142857142855*G0_1_19_1;
    A[9] = 0.00535714285714282*G0_0_0_0 + 0.00535714285714285*G0_0_0_1 + 0.00147321428571428*G0_0_1_1 + 0.00147321428571428*G0_0_2_0 - 0.00723214285714282*G0_0_3_0 - 0.00361607142857141*G0_0_3_1 - 0.00361607142857142*G0_0_4_0 - 0.00723214285714284*G0_0_4_1 + 0.00602678571428565*G0_0_5_0 + 0.00602678571428569*G0_0_5_1 - 0.00482142857142855*G0_0_6_0 - 0.00482142857142855*G0_0_6_1 + 0.00602678571428567*G0_0_7_0 + 0.00602678571428568*G0_0_7_1 - 0.00482142857142854*G0_0_8_0 - 0.00482142857142856*G0_0_8_1 - 0.0144642857142857*G0_0_9_0 - 0.0144642857142857*G0_0_9_1 + 0.00535714285714282*G0_1_10_0 + 0.00535714285714285*G0_1_10_1 + 0.00147321428571428*G0_1_11_1 + 0.00147321428571428*G0_1_12_0 - 0.00723214285714282*G0_1_13_0 - 0.00361607142857141*G0_1_13_1 - 0.00361607142857142*G0_1_14_0 - 0.00723214285714284*G0_1_14_1 + 0.00602678571428565*G0_1_15_0 + 0.00602678571428569*G0_1_15_1 - 0.00482142857142855*G0_1_16_0 - 0.00482142857142855*G0_1_16_1 + 0.00602678571428567*G0_1_17_0 + 0.00602678571428568*G0_1_17_1 - 0.00482142857142854*G0_1_18_0 - 0.00482142857142856*G0_1_18_1 - 0.0144642857142857*G0_1_19_0 - 0.0144642857142857*G0_1_19_1;
    A[10] = 0;
    A[11] = 0;
    A[12] = 0;
    A[13] = 0;
    A[14] = 0;
    A[15] = 0;
    A[16] = 0;
    A[17] = 0;
    A[18] = 0;
    A[19] = 0;
    A[20] = -0.00148809523809523*G0_0_0_0 - 0.00148809523809523*G0_0_0_1 - 0.00297619047619045*G0_0_1_0 - 0.00297619047619046*G0_0_1_1 - 0.000885416666666662*G0_0_2_0 - 0.000885416666666662*G0_0_2_1 - 0.00234374999999998*G0_0_3_0 - 0.00234374999999999*G0_0_3_1 + 0.00140624999999999*G0_0_4_0 + 0.00140624999999999*G0_0_4_1 - 0.00241071428571427*G0_0_5_0 - 0.00241071428571427*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 + 0.00180803571428571*G0_0_6_1 - 0.00261160714285713*G0_0_7_0 - 0.00261160714285713*G0_0_7_1 - 0.000334821428571427*G0_0_8_0 - 0.000334821428571429*G0_0_8_1 - 0.00147321428571428*G0_0_9_0 - 0.00147321428571428*G0_0_9_1 - 0.00148809523809523*G0_1_10_0 - 0.00148809523809523*G0_1_10_1 - 0.00297619047619045*G0_1_11_0 - 0.00297619047619046*G0_1_11_1 - 0.000885416666666662*G0_1_12_0 - 0.000885416666666662*G0_1_12_1 - 0.00234374999999998*G0_1_13_0 - 0.00234374999999999*G0_1_13_1 + 0.00140624999999999*G0_1_14_0 + 0.00140624999999999*G0_1_14_1 - 0.00241071428571427*G0_1_15_0 - 0.00241071428571427*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 + 0.00180803571428571*G0_1_16_1 - 0.00261160714285713*G0_1_17_0 - 0.00261160714285713*G0_1_17_1 - 0.000334821428571427*G0_1_18_0 - 0.000334821428571429*G0_1_18_1 - 0.00147321428571428*G0_1_19_0 - 0.00147321428571428*G0_1_19_1;
    A[21] = 0.00148809523809523*G0_0_0_0 + 0.0177083333333332*G0_0_1_0 + 0.00148809523809523*G0_0_2_0 + 0.0133928571428571*G0_0_3_0 - 0.00602678571428568*G0_0_4_0 - 0.00602678571428568*G0_0_7_0 + 0.0133928571428571*G0_0_8_0 + 0.00267857142857142*G0_0_9_0 + 0.00148809523809523*G0_1_10_0 + 0.0177083333333332*G0_1_11_0 + 0.00148809523809523*G0_1_12_0 + 0.0133928571428571*G0_1_13_0 - 0.00602678571428568*G0_1_14_0 - 0.00602678571428568*G0_1_17_0 + 0.0133928571428571*G0_1_18_0 + 0.00267857142857142*G0_1_19_0;
    A[22] = 0.000885416666666662*G0_0_0_1 + 0.00297619047619046*G0_0_1_1 + 0.00148809523809523*G0_0_2_1 + 0.000334821428571422*G0_0_3_1 + 0.00261160714285714*G0_0_4_1 - 0.00180803571428571*G0_0_5_1 + 0.00241071428571428*G0_0_6_1 - 0.00140625*G0_0_7_1 + 0.00234374999999999*G0_0_8_1 + 0.00147321428571428*G0_0_9_1 + 0.000885416666666662*G0_1_10_1 + 0.00297619047619046*G0_1_11_1 + 0.00148809523809523*G0_1_12_1 + 0.000334821428571422*G0_1_13_1 + 0.00261160714285714*G0_1_14_1 - 0.00180803571428571*G0_1_15_1 + 0.00241071428571428*G0_1_16_1 - 0.00140625*G0_1_17_1 + 0.00234374999999999*G0_1_18_1 + 0.00147321428571428*G0_1_19_1;
    A[23] = -6.69642857142868e-05*G0_0_0_0 + 0.00234374999999998*G0_0_0_1 + 0.00535714285714285*G0_0_1_0 + 0.032142857142857*G0_0_1_1 + 6.69642857142847e-05*G0_0_2_0 + 0.00234374999999998*G0_0_2_1 + 0.00401785714285712*G0_0_3_0 + 0.0241071428571427*G0_0_3_1 - 0.0050223214285714*G0_0_4_0 - 0.0120535714285714*G0_0_4_1 + 0.000200892857142859*G0_0_5_0 - 0.00100446428571427*G0_0_5_1 - 0.00220982142857142*G0_0_6_0 - 0.00100446428571428*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 - 0.0120535714285714*G0_0_7_1 + 0.00200892857142856*G0_0_8_0 + 0.0241071428571427*G0_0_8_1 - 0.00602678571428571*G0_0_9_0 - 6.69642857142868e-05*G0_1_10_0 + 0.00234374999999998*G0_1_10_1 + 0.00535714285714285*G0_1_11_0 + 0.032142857142857*G0_1_11_1 + 6.69642857142847e-05*G0_1_12_0 + 0.00234374999999998*G0_1_12_1 + 0.00401785714285712*G0_1_13_0 + 0.0241071428571427*G0_1_13_1 - 0.0050223214285714*G0_1_14_0 - 0.0120535714285714*G0_1_14_1 + 0.000200892857142859*G0_1_15_0 - 0.00100446428571427*G0_1_15_1 - 0.00220982142857142*G0_1_16_0 - 0.00100446428571428*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 - 0.0120535714285714*G0_1_17_1 + 0.00200892857142856*G0_1_18_0 + 0.0241071428571427*G0_1_18_1 - 0.00602678571428571*G0_1_19_0;
    A[24] = 0.000401785714285714*G0_0_0_0 - 0.00140624999999999*G0_0_0_1 - 0.0120535714285714*G0_0_1_1 + 0.00234374999999999*G0_0_2_0 + 6.69642857142881e-05*G0_0_2_1 - 0.00502232142857141*G0_0_3_0 - 0.0120535714285714*G0_0_3_1 + 0.00763392857142855*G0_0_4_0 + 0.0060267857142857*G0_0_4_1 - 0.00281249999999999*G0_0_5_0 + 0.000200892857142853*G0_0_5_1 + 0.0074330357142857*G0_0_6_0 + 0.00381696428571428*G0_0_6_1 - 0.000401785714285715*G0_0_7_0 + 0.00602678571428569*G0_0_7_1 - 0.00100446428571428*G0_0_8_0 - 0.0120535714285714*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.000401785714285714*G0_1_10_0 - 0.00140624999999999*G0_1_10_1 - 0.0120535714285714*G0_1_11_1 + 0.00234374999999999*G0_1_12_0 + 6.69642857142881e-05*G0_1_12_1 - 0.00502232142857141*G0_1_13_0 - 0.0120535714285714*G0_1_13_1 + 0.00763392857142855*G0_1_14_0 + 0.0060267857142857*G0_1_14_1 - 0.00281249999999999*G0_1_15_0 + 0.000200892857142853*G0_1_15_1 + 0.0074330357142857*G0_1_16_0 + 0.00381696428571428*G0_1_16_1 - 0.000401785714285715*G0_1_17_0 + 0.00602678571428569*G0_1_17_1 - 0.00100446428571428*G0_1_18_0 - 0.0120535714285714*G0_1_18_1 + 0.00482142857142856*G0_1_19_0;
    A[25] = 6.69642857142895e-05*G0_0_0_0 + 0.00241071428571427*G0_0_0_1 + 0.00140625*G0_0_2_0 + 0.00180803571428571*G0_0_2_1 + 0.00200892857142858*G0_0_3_0 + 0.00100446428571429*G0_0_3_1 + 0.000200892857142852*G0_0_4_0 - 0.000200892857142857*G0_0_4_1 - 0.00743303571428569*G0_0_5_0 - 0.00140625*G0_0_6_0 - 0.00421874999999999*G0_0_6_1 - 0.00381696428571427*G0_0_7_0 + 0.00381696428571426*G0_0_7_1 + 0.00401785714285714*G0_0_8_0 - 0.00100446428571428*G0_0_8_1 - 0.00843749999999997*G0_0_9_0 - 0.00361607142857142*G0_0_9_1 + 6.69642857142895e-05*G0_1_10_0 + 0.00241071428571427*G0_1_10_1 + 0.00140625*G0_1_12_0 + 0.00180803571428571*G0_1_12_1 + 0.00200892857142858*G0_1_13_0 + 0.00100446428571429*G0_1_13_1 + 0.000200892857142852*G0_1_14_0 - 0.000200892857142857*G0_1_14_1 - 0.00743303571428569*G0_1_15_0 - 0.00140625*G0_1_16_0 - 0.00421874999999999*G0_1_16_1 - 0.00381696428571427*G0_1_17_0 + 0.00381696428571426*G0_1_17_1 + 0.00401785714285714*G0_1_18_0 - 0.00100446428571428*G0_1_18_1 - 0.00843749999999997*G0_1_19_0 - 0.00361607142857142*G0_1_19_1;
    A[26] = -0.000401785714285714*G0_0_0_0 - 0.00180803571428571*G0_0_0_1 - 0.00234374999999999*G0_0_2_0 - 0.00241071428571428*G0_0_2_1 + 0.00502232142857141*G0_0_3_0 + 0.00100446428571427*G0_0_3_1 - 0.00763392857142855*G0_0_4_0 - 0.00381696428571427*G0_0_4_1 + 0.00281249999999999*G0_0_5_0 + 0.00421874999999999*G0_0_5_1 - 0.0074330357142857*G0_0_6_0 + 0.000401785714285715*G0_0_7_0 + 0.000200892857142867*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 - 0.00100446428571429*G0_0_8_1 - 0.00482142857142856*G0_0_9_0 + 0.00361607142857141*G0_0_9_1 - 0.000401785714285714*G0_1_10_0 - 0.00180803571428571*G0_1_10_1 - 0.00234374999999999*G0_1_12_0 - 0.00241071428571428*G0_1_12_1 + 0.00502232142857141*G0_1_13_0 + 0.00100446428571427*G0_1_13_1 - 0.00763392857142855*G0_1_14_0 - 0.00381696428571427*G0_1_14_1 + 0.00281249999999999*G0_1_15_0 + 0.00421874999999999*G0_1_15_1 - 0.0074330357142857*G0_1_16_0 + 0.000401785714285715*G0_1_17_0 + 0.000200892857142867*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 - 0.00100446428571429*G0_1_18_1 - 0.00482142857142856*G0_1_19_0 + 0.00361607142857141*G0_1_19_1;
    A[27] = 0.0022767857142857*G0_0_0_0 - 6.69642857142869e-05*G0_0_0_1 + 0.0120535714285713*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.0018080357142857*G0_0_2_0 + 0.00140624999999999*G0_0_2_1 + 0.0110491071428571*G0_0_3_0 + 0.0120535714285714*G0_0_3_1 - 0.0064285714285714*G0_0_4_0 - 0.00602678571428569*G0_0_4_1 + 0.00361607142857142*G0_0_5_0 - 0.00381696428571427*G0_0_5_1 - 0.00301339285714285*G0_0_6_0 - 0.000200892857142861*G0_0_6_1 + 0.00160714285714286*G0_0_7_0 - 0.00602678571428568*G0_0_7_1 + 0.00703124999999996*G0_0_8_0 + 0.0120535714285714*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.0022767857142857*G0_1_10_0 - 6.69642857142869e-05*G0_1_10_1 + 0.0120535714285713*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.0018080357142857*G0_1_12_0 + 0.00140624999999999*G0_1_12_1 + 0.0110491071428571*G0_1_13_0 + 0.0120535714285714*G0_1_13_1 - 0.0064285714285714*G0_1_14_0 - 0.00602678571428569*G0_1_14_1 + 0.00361607142857142*G0_1_15_0 - 0.00381696428571427*G0_1_15_1 - 0.00301339285714285*G0_1_16_0 - 0.000200892857142861*G0_1_16_1 + 0.00160714285714286*G0_1_17_0 - 0.00602678571428568*G0_1_17_1 + 0.00703124999999996*G0_1_18_0 + 0.0120535714285714*G0_1_18_1 + 0.00482142857142856*G0_1_19_0;
    A[28] = -0.00227678571428569*G0_0_0_0 - 0.00234374999999998*G0_0_0_1 - 0.0267857142857141*G0_0_1_0 - 0.032142857142857*G0_0_1_1 - 0.00241071428571427*G0_0_2_0 - 0.00234374999999998*G0_0_2_1 - 0.0220982142857141*G0_0_3_0 - 0.0241071428571427*G0_0_3_1 + 0.0110491071428571*G0_0_4_0 + 0.0120535714285714*G0_0_4_1 - 0.00120535714285715*G0_0_5_0 + 0.00100446428571427*G0_0_5_1 + 0.00120535714285714*G0_0_6_0 + 0.00100446428571428*G0_0_6_1 + 0.00703124999999996*G0_0_7_0 + 0.0120535714285714*G0_0_7_1 - 0.0200892857142856*G0_0_8_0 - 0.0241071428571427*G0_0_8_1 - 0.0060267857142857*G0_0_9_0 - 0.00227678571428569*G0_1_10_0 - 0.00234374999999998*G0_1_10_1 - 0.0267857142857141*G0_1_11_0 - 0.032142857142857*G0_1_11_1 - 0.00241071428571427*G0_1_12_0 - 0.00234374999999998*G0_1_12_1 - 0.0220982142857141*G0_1_13_0 - 0.0241071428571427*G0_1_13_1 + 0.0110491071428571*G0_1_14_0 + 0.0120535714285714*G0_1_14_1 - 0.00120535714285715*G0_1_15_0 + 0.00100446428571427*G0_1_15_1 + 0.00120535714285714*G0_1_16_0 + 0.00100446428571428*G0_1_16_1 + 0.00703124999999996*G0_1_17_0 + 0.0120535714285714*G0_1_17_1 - 0.0200892857142856*G0_1_18_0 - 0.0241071428571427*G0_1_18_1 - 0.0060267857142857*G0_1_19_0;
    A[29] = 0.00147321428571428*G0_0_0_1 - 0.00535714285714286*G0_0_1_0 - 0.00147321428571428*G0_0_2_0 - 0.00147321428571428*G0_0_2_1 - 0.00602678571428569*G0_0_3_0 + 0.00482142857142855*G0_0_4_0 + 0.00723214285714283*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 + 0.00361607142857142*G0_0_6_0 - 0.00361607142857142*G0_0_6_1 + 0.00482142857142855*G0_0_7_0 - 0.0060267857142857*G0_0_8_0 + 0.0144642857142857*G0_0_9_0 + 0.00147321428571428*G0_1_10_1 - 0.00535714285714286*G0_1_11_0 - 0.00147321428571428*G0_1_12_0 - 0.00147321428571428*G0_1_12_1 - 0.00602678571428569*G0_1_13_0 + 0.00482142857142855*G0_1_14_0 + 0.00723214285714283*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 + 0.00361607142857142*G0_1_16_0 - 0.00361607142857142*G0_1_16_1 + 0.00482142857142855*G0_1_17_0 - 0.0060267857142857*G0_1_18_0 + 0.0144642857142857*G0_1_19_0;
    A[30] = 0;
    A[31] = 0;
    A[32] = 0;
    A[33] = 0;
    A[34] = 0;
    A[35] = 0;
    A[36] = 0;
    A[37] = 0;
    A[38] = 0;
    A[39] = 0;
    A[40] = -0.00148809523809523*G0_0_0_0 - 0.00148809523809523*G0_0_0_1 - 0.000885416666666662*G0_0_1_0 - 0.000885416666666662*G0_0_1_1 - 0.00297619047619046*G0_0_2_0 - 0.00297619047619046*G0_0_2_1 + 0.00140624999999999*G0_0_3_0 + 0.00140624999999999*G0_0_3_1 - 0.00234374999999999*G0_0_4_0 - 0.00234374999999999*G0_0_4_1 - 0.00261160714285713*G0_0_5_0 - 0.00261160714285713*G0_0_5_1 - 0.000334821428571434*G0_0_6_0 - 0.000334821428571434*G0_0_6_1 - 0.00241071428571427*G0_0_7_0 - 0.00241071428571427*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 + 0.0018080357142857*G0_0_8_1 - 0.00147321428571428*G0_0_9_0 - 0.00147321428571428*G0_0_9_1 - 0.00148809523809523*G0_1_10_0 - 0.00148809523809523*G0_1_10_1 - 0.000885416666666662*G0_1_11_0 - 0.000885416666666662*G0_1_11_1 - 0.00297619047619046*G0_1_12_0 - 0.00297619047619046*G0_1_12_1 + 0.00140624999999999*G0_1_13_0 + 0.00140624999999999*G0_1_13_1 - 0.00234374999999999*G0_1_14_0 - 0.00234374999999999*G0_1_14_1 - 0.00261160714285713*G0_1_15_0 - 0.00261160714285713*G0_1_15_1 - 0.000334821428571434*G0_1_16_0 - 0.000334821428571434*G0_1_16_1 - 0.00241071428571427*G0_1_17_0 - 0.00241071428571427*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 + 0.0018080357142857*G0_1_18_1 - 0.00147321428571428*G0_1_19_0 - 0.00147321428571428*G0_1_19_1;
    A[41] = 0.000885416666666662*G0_0_0_0 + 0.00148809523809523*G0_0_1_0 + 0.00297619047619047*G0_0_2_0 + 0.00261160714285713*G0_0_3_0 + 0.000334821428571433*G0_0_4_0 - 0.00140625*G0_0_5_0 + 0.00234374999999999*G0_0_6_0 - 0.0018080357142857*G0_0_7_0 + 0.00241071428571427*G0_0_8_0 + 0.00147321428571428*G0_0_9_0 + 0.000885416666666662*G0_1_10_0 + 0.00148809523809523*G0_1_11_0 + 0.00297619047619047*G0_1_12_0 + 0.00261160714285713*G0_1_13_0 + 0.000334821428571433*G0_1_14_0 - 0.00140625*G0_1_15_0 + 0.00234374999999999*G0_1_16_0 - 0.0018080357142857*G0_1_17_0 + 0.00241071428571427*G0_1_18_0 + 0.00147321428571428*G0_1_19_0;
    A[42] = 0.00148809523809523*G0_0_0_1 + 0.00148809523809523*G0_0_1_1 + 0.0177083333333332*G0_0_2_1 - 0.00602678571428568*G0_0_3_1 + 0.0133928571428571*G0_0_4_1 - 0.00602678571428568*G0_0_5_1 + 0.0133928571428571*G0_0_6_1 + 0.00267857142857141*G0_0_9_1 + 0.00148809523809523*G0_1_10_1 + 0.00148809523809523*G0_1_11_1 + 0.0177083333333332*G0_1_12_1 - 0.00602678571428568*G0_1_13_1 + 0.0133928571428571*G0_1_14_1 - 0.00602678571428568*G0_1_15_1 + 0.0133928571428571*G0_1_16_1 + 0.00267857142857141*G0_1_19_1;
    A[43] = -0.00140624999999999*G0_0_0_0 + 0.000401785714285712*G0_0_0_1 + 6.69642857142847e-05*G0_0_1_0 + 0.00234374999999998*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 + 0.00602678571428568*G0_0_3_0 + 0.00763392857142853*G0_0_3_1 - 0.0120535714285714*G0_0_4_0 - 0.0050223214285714*G0_0_4_1 + 0.00602678571428569*G0_0_5_0 - 0.000401785714285713*G0_0_5_1 - 0.0120535714285714*G0_0_6_0 - 0.00100446428571427*G0_0_6_1 + 0.000200892857142856*G0_0_7_0 - 0.00281249999999998*G0_0_7_1 + 0.00381696428571427*G0_0_8_0 + 0.00743303571428567*G0_0_8_1 + 0.00482142857142856*G0_0_9_1 - 0.00140624999999999*G0_1_10_0 + 0.000401785714285712*G0_1_10_1 + 6.69642857142847e-05*G0_1_11_0 + 0.00234374999999998*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 + 0.00602678571428568*G0_1_13_0 + 0.00763392857142853*G0_1_13_1 - 0.0120535714285714*G0_1_14_0 - 0.0050223214285714*G0_1_14_1 + 0.00602678571428569*G0_1_15_0 - 0.000401785714285713*G0_1_15_1 - 0.0120535714285714*G0_1_16_0 - 0.00100446428571427*G0_1_16_1 + 0.000200892857142856*G0_1_17_0 - 0.00281249999999998*G0_1_17_1 + 0.00381696428571427*G0_1_18_0 + 0.00743303571428567*G0_1_18_1 + 0.00482142857142856*G0_1_19_1;
    A[44] = 0.00234374999999999*G0_0_0_0 - 6.69642857142862e-05*G0_0_0_1 + 0.00234374999999999*G0_0_1_0 + 6.6964285714288e-05*G0_0_1_1 + 0.032142857142857*G0_0_2_0 + 0.00535714285714284*G0_0_2_1 - 0.0120535714285714*G0_0_3_0 - 0.0050223214285714*G0_0_3_1 + 0.0241071428571427*G0_0_4_0 + 0.00401785714285711*G0_0_4_1 - 0.0120535714285714*G0_0_5_0 - 0.00100446428571428*G0_0_5_1 + 0.0241071428571427*G0_0_6_0 + 0.00200892857142856*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 + 0.000200892857142858*G0_0_7_1 - 0.00100446428571428*G0_0_8_0 - 0.00220982142857141*G0_0_8_1 - 0.0060267857142857*G0_0_9_1 + 0.00234374999999999*G0_1_10_0 - 6.69642857142862e-05*G0_1_10_1 + 0.00234374999999999*G0_1_11_0 + 6.6964285714288e-05*G0_1_11_1 + 0.032142857142857*G0_1_12_0 + 0.00535714285714284*G0_1_12_1 - 0.0120535714285714*G0_1_13_0 - 0.0050223214285714*G0_1_13_1 + 0.0241071428571427*G0_1_14_0 + 0.00401785714285711*G0_1_14_1 - 0.0120535714285714*G0_1_15_0 - 0.00100446428571428*G0_1_15_1 + 0.0241071428571427*G0_1_16_0 + 0.00200892857142856*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 + 0.000200892857142858*G0_1_17_1 - 0.00100446428571428*G0_1_18_0 - 0.00220982142857141*G0_1_18_1 - 0.0060267857142857*G0_1_19_1;
    A[45] = -6.69642857142837e-05*G0_0_0_0 + 0.0022767857142857*G0_0_0_1 + 0.00140625*G0_0_1_0 + 0.00180803571428571*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0120535714285714*G0_0_2_1 - 0.00602678571428568*G0_0_3_0 - 0.0064285714285714*G0_0_3_1 + 0.0120535714285714*G0_0_4_0 + 0.0110491071428571*G0_0_4_1 - 0.00602678571428567*G0_0_5_0 + 0.00160714285714285*G0_0_5_1 + 0.0120535714285714*G0_0_6_0 + 0.00703124999999999*G0_0_6_1 - 0.00381696428571426*G0_0_7_0 + 0.0036160714285714*G0_0_7_1 - 0.000200892857142856*G0_0_8_0 - 0.00301339285714284*G0_0_8_1 + 0.00482142857142855*G0_0_9_1 - 6.69642857142837e-05*G0_1_10_0 + 0.0022767857142857*G0_1_10_1 + 0.00140625*G0_1_11_0 + 0.00180803571428571*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0120535714285714*G0_1_12_1 - 0.00602678571428568*G0_1_13_0 - 0.0064285714285714*G0_1_13_1 + 0.0120535714285714*G0_1_14_0 + 0.0110491071428571*G0_1_14_1 - 0.00602678571428567*G0_1_15_0 + 0.00160714285714285*G0_1_15_1 + 0.0120535714285714*G0_1_16_0 + 0.00703124999999999*G0_1_16_1 - 0.00381696428571426*G0_1_17_0 + 0.0036160714285714*G0_1_17_1 - 0.000200892857142856*G0_1_18_0 - 0.00301339285714284*G0_1_18_1 + 0.00482142857142855*G0_1_19_1;
    A[46] = -0.00234374999999999*G0_0_0_0 - 0.0022767857142857*G0_0_0_1 - 0.00234374999999999*G0_0_1_0 - 0.00241071428571428*G0_0_1_1 - 0.032142857142857*G0_0_2_0 - 0.0267857142857141*G0_0_2_1 + 0.0120535714285714*G0_0_3_0 + 0.0110491071428571*G0_0_3_1 - 0.0241071428571427*G0_0_4_0 - 0.0220982142857142*G0_0_4_1 + 0.0120535714285714*G0_0_5_0 + 0.00703124999999996*G0_0_5_1 - 0.0241071428571427*G0_0_6_0 - 0.0200892857142856*G0_0_6_1 + 0.00100446428571428*G0_0_7_0 - 0.00120535714285713*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 + 0.00120535714285714*G0_0_8_1 - 0.00602678571428569*G0_0_9_1 - 0.00234374999999999*G0_1_10_0 - 0.0022767857142857*G0_1_10_1 - 0.00234374999999999*G0_1_11_0 - 0.00241071428571428*G0_1_11_1 - 0.032142857142857*G0_1_12_0 - 0.0267857142857141*G0_1_12_1 + 0.0120535714285714*G0_1_13_0 + 0.0110491071428571*G0_1_13_1 - 0.0241071428571427*G0_1_14_0 - 0.0220982142857142*G0_1_14_1 + 0.0120535714285714*G0_1_15_0 + 0.00703124999999996*G0_1_15_1 - 0.0241071428571427*G0_1_16_0 - 0.0200892857142856*G0_1_16_1 + 0.00100446428571428*G0_1_17_0 - 0.00120535714285713*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 + 0.00120535714285714*G0_1_18_1 - 0.00602678571428569*G0_1_19_1;
    A[47] = 0.00241071428571427*G0_0_0_0 + 6.69642857142869e-05*G0_0_0_1 + 0.0018080357142857*G0_0_1_0 + 0.00140624999999999*G0_0_1_1 - 0.000200892857142854*G0_0_3_0 + 0.000200892857142858*G0_0_3_1 + 0.00100446428571427*G0_0_4_0 + 0.00200892857142856*G0_0_4_1 + 0.00381696428571426*G0_0_5_0 - 0.00381696428571426*G0_0_5_1 - 0.00100446428571429*G0_0_6_0 + 0.00401785714285712*G0_0_6_1 - 0.00743303571428566*G0_0_7_1 - 0.00421874999999998*G0_0_8_0 - 0.00140624999999999*G0_0_8_1 - 0.00361607142857141*G0_0_9_0 - 0.00843749999999996*G0_0_9_1 + 0.00241071428571427*G0_1_10_0 + 6.69642857142869e-05*G0_1_10_1 + 0.0018080357142857*G0_1_11_0 + 0.00140624999999999*G0_1_11_1 - 0.000200892857142854*G0_1_13_0 + 0.000200892857142858*G0_1_13_1 + 0.00100446428571427*G0_1_14_0 + 0.00200892857142856*G0_1_14_1 + 0.00381696428571426*G0_1_15_0 - 0.00381696428571426*G0_1_15_1 - 0.00100446428571429*G0_1_16_0 + 0.00401785714285712*G0_1_16_1 - 0.00743303571428566*G0_1_17_1 - 0.00421874999999998*G0_1_18_0 - 0.00140624999999999*G0_1_18_1 - 0.00361607142857141*G0_1_19_0 - 0.00843749999999996*G0_1_19_1;
    A[48] = -0.0018080357142857*G0_0_0_0 - 0.000401785714285712*G0_0_0_1 - 0.00241071428571427*G0_0_1_0 - 0.00234374999999998*G0_0_1_1 - 0.00381696428571426*G0_0_3_0 - 0.00763392857142853*G0_0_3_1 + 0.00100446428571428*G0_0_4_0 + 0.0050223214285714*G0_0_4_1 + 0.000200892857142856*G0_0_5_0 + 0.000401785714285712*G0_0_5_1 - 0.00100446428571427*G0_0_6_0 + 0.00100446428571428*G0_0_6_1 + 0.00421874999999997*G0_0_7_0 + 0.00281249999999999*G0_0_7_1 - 0.00743303571428567*G0_0_8_1 + 0.00361607142857141*G0_0_9_0 - 0.00482142857142856*G0_0_9_1 - 0.0018080357142857*G0_1_10_0 - 0.000401785714285712*G0_1_10_1 - 0.00241071428571427*G0_1_11_0 - 0.00234374999999998*G0_1_11_1 - 0.00381696428571426*G0_1_13_0 - 0.00763392857142853*G0_1_13_1 + 0.00100446428571428*G0_1_14_0 + 0.0050223214285714*G0_1_14_1 + 0.000200892857142856*G0_1_15_0 + 0.000401785714285712*G0_1_15_1 - 0.00100446428571427*G0_1_16_0 + 0.00100446428571428*G0_1_16_1 + 0.00421874999999997*G0_1_17_0 + 0.00281249999999999*G0_1_17_1 - 0.00743303571428567*G0_1_18_1 + 0.00361607142857141*G0_1_19_0 - 0.00482142857142856*G0_1_19_1;
    A[49] = 0.00147321428571428*G0_0_0_0 - 0.00147321428571428*G0_0_1_0 - 0.00147321428571428*G0_0_1_1 - 0.00535714285714284*G0_0_2_1 + 0.00482142857142855*G0_0_3_1 - 0.00602678571428567*G0_0_4_1 + 0.00482142857142854*G0_0_5_1 - 0.00602678571428568*G0_0_6_1 + 0.0036160714285714*G0_0_7_0 + 0.0072321428571428*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 + 0.00361607142857141*G0_0_8_1 + 0.0144642857142857*G0_0_9_1 + 0.00147321428571428*G0_1_10_0 - 0.00147321428571428*G0_1_11_0 - 0.00147321428571428*G0_1_11_1 - 0.00535714285714284*G0_1_12_1 + 0.00482142857142855*G0_1_13_1 - 0.00602678571428567*G0_1_14_1 + 0.00482142857142854*G0_1_15_1 - 0.00602678571428568*G0_1_16_1 + 0.0036160714285714*G0_1_17_0 + 0.0072321428571428*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 + 0.00361607142857141*G0_1_18_1 + 0.0144642857142857*G0_1_19_1;
    A[50] = 0;
    A[51] = 0;
    A[52] = 0;
    A[53] = 0;
    A[54] = 0;
    A[55] = 0;
    A[56] = 0;
    A[57] = 0;
    A[58] = 0;
    A[59] = 0;
    A[60] = -0.00234374999999998*G0_0_1_0 - 0.00234374999999999*G0_0_1_1 + 0.00140624999999999*G0_0_2_0 + 0.00140624999999999*G0_0_2_1 - 0.0148660714285713*G0_0_3_0 - 0.0148660714285713*G0_0_3_1 + 0.00140625*G0_0_4_0 + 0.00140625*G0_0_4_1 + 0.00220982142857142*G0_0_5_0 + 0.00220982142857142*G0_0_5_1 - 0.00261160714285713*G0_0_6_0 - 0.00261160714285713*G0_0_6_1 + 0.00281249999999998*G0_0_7_0 + 0.00281249999999999*G0_0_7_1 - 0.000200892857142849*G0_0_8_0 - 0.000200892857142852*G0_0_8_1 - 0.00120535714285715*G0_0_9_0 - 0.00120535714285715*G0_0_9_1 - 0.00234374999999998*G0_1_11_0 - 0.00234374999999999*G0_1_11_1 + 0.00140624999999999*G0_1_12_0 + 0.00140624999999999*G0_1_12_1 - 0.0148660714285713*G0_1_13_0 - 0.0148660714285713*G0_1_13_1 + 0.00140625*G0_1_14_0 + 0.00140625*G0_1_14_1 + 0.00220982142857142*G0_1_15_0 + 0.00220982142857142*G0_1_15_1 - 0.00261160714285713*G0_1_16_0 - 0.00261160714285713*G0_1_16_1 + 0.00281249999999998*G0_1_17_0 + 0.00281249999999999*G0_1_17_1 - 0.000200892857142849*G0_1_18_0 - 0.000200892857142852*G0_1_18_1 - 0.00120535714285715*G0_1_19_0 - 0.00120535714285715*G0_1_19_1;
    A[61] = 0.00241071428571427*G0_0_0_0 + 0.0133928571428571*G0_0_1_0 + 0.00261160714285713*G0_0_2_0 + 0.0401785714285712*G0_0_3_0 - 0.0140624999999999*G0_0_4_0 - 0.00220982142857141*G0_0_5_0 - 0.00281249999999999*G0_0_6_0 - 0.0100446428571428*G0_0_7_0 + 0.0200892857142856*G0_0_8_0 + 0.0120535714285714*G0_0_9_0 + 0.00241071428571427*G0_1_10_0 + 0.0133928571428571*G0_1_11_0 + 0.00261160714285713*G0_1_12_0 + 0.0401785714285712*G0_1_13_0 - 0.0140624999999999*G0_1_14_0 - 0.00220982142857141*G0_1_15_0 - 0.00281249999999999*G0_1_16_0 - 0.0100446428571428*G0_1_17_0 + 0.0200892857142856*G0_1_18_0 + 0.0120535714285714*G0_1_19_0;
    A[62] = -0.00180803571428571*G0_0_0_1 + 0.000334821428571422*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 - 0.0032142857142857*G0_0_3_1 - 0.0140624999999999*G0_0_4_1 + 0.00683035714285711*G0_0_5_1 - 0.0100446428571428*G0_0_6_1 + 0.00261160714285714*G0_0_7_1 + 0.000200892857142846*G0_0_8_1 - 0.00964285714285711*G0_0_9_1 - 0.00180803571428571*G0_1_10_1 + 0.000334821428571422*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 - 0.0032142857142857*G0_1_13_1 - 0.0140624999999999*G0_1_14_1 + 0.00683035714285711*G0_1_15_1 - 0.0100446428571428*G0_1_16_1 + 0.00261160714285714*G0_1_17_1 + 0.000200892857142846*G0_1_18_1 - 0.00964285714285711*G0_1_19_1;
    A[63] = 0.00743303571428568*G0_0_0_0 + 0.00743303571428567*G0_0_0_1 + 0.00401785714285712*G0_0_1_0 + 0.0241071428571427*G0_0_1_1 + 0.00602678571428568*G0_0_2_0 + 0.00763392857142853*G0_0_2_1 + 0.108482142857142*G0_0_3_0 + 0.108482142857142*G0_0_3_1 - 0.00542410714285719*G0_0_4_0 - 0.0271205357142856*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 - 0.0072321428571428*G0_0_5_1 + 0.0054241071428571*G0_0_6_0 - 0.00180803571428572*G0_0_6_1 - 0.0235044642857142*G0_0_7_0 - 0.0271205357142856*G0_0_7_1 + 0.0361607142857141*G0_0_8_0 + 0.0542410714285711*G0_0_8_1 + 0.0650892857142855*G0_0_9_0 + 0.0542410714285712*G0_0_9_1 + 0.00743303571428568*G0_1_10_0 + 0.00743303571428567*G0_1_10_1 + 0.00401785714285712*G0_1_11_0 + 0.0241071428571427*G0_1_11_1 + 0.00602678571428568*G0_1_12_0 + 0.00763392857142853*G0_1_12_1 + 0.108482142857142*G0_1_13_0 + 0.108482142857142*G0_1_13_1 - 0.00542410714285719*G0_1_14_0 - 0.0271205357142856*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 - 0.0072321428571428*G0_1_15_1 + 0.0054241071428571*G0_1_16_0 - 0.00180803571428572*G0_1_16_1 - 0.0235044642857142*G0_1_17_0 - 0.0271205357142856*G0_1_17_1 + 0.0361607142857141*G0_1_18_0 + 0.0542410714285711*G0_1_18_1 + 0.0650892857142855*G0_1_19_0 + 0.0542410714285712*G0_1_19_1;
    A[64] = -0.00281249999999999*G0_0_0_0 + 0.00140624999999999*G0_0_0_1 - 0.00502232142857141*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.0050223214285714*G0_0_2_1 + 0.0108482142857142*G0_0_3_0 + 0.0542410714285711*G0_0_3_1 - 0.0271205357142856*G0_0_4_0 - 0.0054241071428572*G0_0_4_1 + 0.0108482142857142*G0_0_5_0 - 0.00180803571428569*G0_0_5_1 - 0.0271205357142856*G0_0_6_0 - 0.01265625*G0_0_6_1 + 0.00361607142857142*G0_0_7_0 - 0.00542410714285711*G0_0_7_1 - 0.00180803571428572*G0_0_8_0 - 0.0216964285714285*G0_0_9_0 + 0.0108482142857142*G0_0_9_1 - 0.00281249999999999*G0_1_10_0 + 0.00140624999999999*G0_1_10_1 - 0.00502232142857141*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.0050223214285714*G0_1_12_1 + 0.0108482142857142*G0_1_13_0 + 0.0542410714285711*G0_1_13_1 - 0.0271205357142856*G0_1_14_0 - 0.0054241071428572*G0_1_14_1 + 0.0108482142857142*G0_1_15_0 - 0.00180803571428569*G0_1_15_1 - 0.0271205357142856*G0_1_16_0 - 0.01265625*G0_1_16_1 + 0.00361607142857142*G0_1_17_0 - 0.00542410714285711*G0_1_17_1 - 0.00180803571428572*G0_1_18_0 - 0.0216964285714285*G0_1_19_0 + 0.0108482142857142*G0_1_19_1;
    A[65] = -0.000200892857142856*G0_0_0_0 - 0.00120535714285714*G0_0_0_1 + 0.00200892857142858*G0_0_1_0 + 0.00100446428571429*G0_0_1_1 - 0.00602678571428568*G0_0_2_0 - 0.0064285714285714*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0144642857142856*G0_0_3_1 - 0.00542410714285715*G0_0_4_0 - 0.00180803571428573*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 + 0.00542410714285713*G0_0_6_0 + 0.00904017857142854*G0_0_6_1 + 0.0018080357142857*G0_0_7_0 - 0.00361607142857139*G0_0_8_0 - 0.00542410714285711*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 - 0.000200892857142856*G0_1_10_0 - 0.00120535714285714*G0_1_10_1 + 0.00200892857142858*G0_1_11_0 + 0.00100446428571429*G0_1_11_1 - 0.00602678571428568*G0_1_12_0 - 0.0064285714285714*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0144642857142856*G0_1_13_1 - 0.00542410714285715*G0_1_14_0 - 0.00180803571428573*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 + 0.00542410714285713*G0_1_16_0 + 0.00904017857142854*G0_1_16_1 + 0.0018080357142857*G0_1_17_0 - 0.00361607142857139*G0_1_18_0 - 0.00542410714285711*G0_1_18_1 + 0.0216964285714285*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[66] = 0.00281249999999999*G0_0_0_0 + 0.00301339285714284*G0_0_0_1 + 0.00502232142857141*G0_0_1_0 + 0.00100446428571427*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0110491071428571*G0_0_2_1 - 0.0108482142857143*G0_0_3_0 + 0.00361607142857138*G0_0_3_1 + 0.0271205357142856*G0_0_4_0 + 0.0144642857142857*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 - 0.01265625*G0_0_5_1 + 0.0271205357142856*G0_0_6_0 + 0.0036160714285714*G0_0_6_1 - 0.00361607142857141*G0_0_7_0 - 0.00542410714285711*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.00281249999999999*G0_1_10_0 + 0.00301339285714284*G0_1_10_1 + 0.00502232142857141*G0_1_11_0 + 0.00100446428571427*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0110491071428571*G0_1_12_1 - 0.0108482142857143*G0_1_13_0 + 0.00361607142857138*G0_1_13_1 + 0.0271205357142856*G0_1_14_0 + 0.0144642857142857*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 - 0.01265625*G0_1_15_1 + 0.0271205357142856*G0_1_16_0 + 0.0036160714285714*G0_1_16_1 - 0.00361607142857141*G0_1_17_0 - 0.00542410714285711*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0216964285714285*G0_1_19_0;
    A[67] = 0.00120535714285714*G0_0_0_0 + 0.00220982142857142*G0_0_0_1 + 0.0110491071428571*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 - 0.000200892857142854*G0_0_2_0 + 0.000200892857142858*G0_0_2_1 + 0.0470089285714283*G0_0_3_0 + 0.0542410714285712*G0_0_3_1 - 0.00180803571428572*G0_0_4_0 - 0.00542410714285715*G0_0_4_1 - 0.00542410714285712*G0_0_5_0 + 0.00180803571428572*G0_0_5_1 + 0.00542410714285712*G0_0_6_0 + 0.0018080357142857*G0_0_6_1 - 0.00723214285714282*G0_0_7_0 - 0.00542410714285712*G0_0_7_1 - 0.00180803571428571*G0_0_8_0 + 0.0108482142857143*G0_0_9_1 + 0.00120535714285714*G0_1_10_0 + 0.00220982142857142*G0_1_10_1 + 0.0110491071428571*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 - 0.000200892857142854*G0_1_12_0 + 0.000200892857142858*G0_1_12_1 + 0.0470089285714283*G0_1_13_0 + 0.0542410714285712*G0_1_13_1 - 0.00180803571428572*G0_1_14_0 - 0.00542410714285715*G0_1_14_1 - 0.00542410714285712*G0_1_15_0 + 0.00180803571428572*G0_1_15_1 + 0.00542410714285712*G0_1_16_0 + 0.0018080357142857*G0_1_16_1 - 0.00723214285714282*G0_1_17_0 - 0.00542410714285712*G0_1_17_1 - 0.00180803571428571*G0_1_18_0 + 0.0108482142857143*G0_1_19_1;
    A[68] = -0.00361607142857141*G0_0_0_0 - 0.00743303571428567*G0_0_0_1 - 0.0220982142857141*G0_0_1_0 - 0.0241071428571427*G0_0_1_1 - 0.00381696428571426*G0_0_2_0 - 0.00763392857142853*G0_0_2_1 - 0.0723214285714282*G0_0_3_0 - 0.108482142857142*G0_0_3_1 + 0.0144642857142857*G0_0_4_0 + 0.0271205357142856*G0_0_4_1 + 0.00542410714285711*G0_0_5_0 + 0.00723214285714281*G0_0_5_1 + 0.00180803571428572*G0_0_6_1 + 0.0144642857142856*G0_0_7_0 + 0.0271205357142856*G0_0_7_1 - 0.018080357142857*G0_0_8_0 - 0.0542410714285711*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0542410714285713*G0_0_9_1 - 0.00361607142857141*G0_1_10_0 - 0.00743303571428567*G0_1_10_1 - 0.0220982142857141*G0_1_11_0 - 0.0241071428571427*G0_1_11_1 - 0.00381696428571426*G0_1_12_0 - 0.00763392857142853*G0_1_12_1 - 0.0723214285714282*G0_1_13_0 - 0.108482142857142*G0_1_13_1 + 0.0144642857142857*G0_1_14_0 + 0.0271205357142856*G0_1_14_1 + 0.00542410714285711*G0_1_15_0 + 0.00723214285714281*G0_1_15_1 + 0.00180803571428572*G0_1_16_1 + 0.0144642857142856*G0_1_17_0 + 0.0271205357142856*G0_1_17_1 - 0.018080357142857*G0_1_18_0 - 0.0542410714285711*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0542410714285713*G0_1_19_1;
    A[69] = -0.00723214285714282*G0_0_0_0 - 0.00361607142857141*G0_0_0_1 - 0.00602678571428569*G0_0_1_0 + 0.00482142857142855*G0_0_2_1 - 0.130178571428571*G0_0_3_0 - 0.108482142857142*G0_0_3_1 + 0.0108482142857143*G0_0_4_0 + 0.0108482142857143*G0_0_4_1 - 0.0108482142857142*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 - 0.0325446428571427*G0_0_8_0 - 0.086785714285714*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00723214285714282*G0_1_10_0 - 0.00361607142857141*G0_1_10_1 - 0.00602678571428569*G0_1_11_0 + 0.00482142857142855*G0_1_12_1 - 0.130178571428571*G0_1_13_0 - 0.108482142857142*G0_1_13_1 + 0.0108482142857143*G0_1_14_0 + 0.0108482142857143*G0_1_14_1 - 0.0108482142857142*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 - 0.0325446428571427*G0_1_18_0 - 0.086785714285714*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[70] = 0;
    A[71] = 0;
    A[72] = 0;
    A[73] = 0;
    A[74] = 0;
    A[75] = 0;
    A[76] = 0;
    A[77] = 0;
    A[78] = 0;
    A[79] = 0;
    A[80] = 0.00140624999999999*G0_0_1_0 + 0.00140624999999999*G0_0_1_1 - 0.00234374999999999*G0_0_2_0 - 0.00234374999999999*G0_0_2_1 + 0.00140625*G0_0_3_0 + 0.00140625*G0_0_3_1 - 0.0148660714285713*G0_0_4_0 - 0.0148660714285713*G0_0_4_1 + 0.00281249999999999*G0_0_5_0 + 0.00281249999999999*G0_0_5_1 - 0.00020089285714285*G0_0_6_0 - 0.000200892857142851*G0_0_6_1 + 0.00220982142857142*G0_0_7_0 + 0.00220982142857142*G0_0_7_1 - 0.00261160714285713*G0_0_8_0 - 0.00261160714285713*G0_0_8_1 - 0.00120535714285714*G0_0_9_0 - 0.00120535714285714*G0_0_9_1 + 0.00140624999999999*G0_1_11_0 + 0.00140624999999999*G0_1_11_1 - 0.00234374999999999*G0_1_12_0 - 0.00234374999999999*G0_1_12_1 + 0.00140625*G0_1_13_0 + 0.00140625*G0_1_13_1 - 0.0148660714285713*G0_1_14_0 - 0.0148660714285713*G0_1_14_1 + 0.00281249999999999*G0_1_15_0 + 0.00281249999999999*G0_1_15_1 - 0.00020089285714285*G0_1_16_0 - 0.000200892857142851*G0_1_16_1 + 0.00220982142857142*G0_1_17_0 + 0.00220982142857142*G0_1_17_1 - 0.00261160714285713*G0_1_18_0 - 0.00261160714285713*G0_1_18_1 - 0.00120535714285714*G0_1_19_0 - 0.00120535714285714*G0_1_19_1;
    A[81] = -0.00180803571428571*G0_0_0_0 - 0.00602678571428568*G0_0_1_0 + 0.000334821428571432*G0_0_2_0 - 0.0140624999999999*G0_0_3_0 - 0.00321428571428571*G0_0_4_0 + 0.00261160714285713*G0_0_5_0 + 0.000200892857142853*G0_0_6_0 + 0.00683035714285711*G0_0_7_0 - 0.0100446428571428*G0_0_8_0 - 0.00964285714285712*G0_0_9_0 - 0.00180803571428571*G0_1_10_0 - 0.00602678571428568*G0_1_11_0 + 0.000334821428571432*G0_1_12_0 - 0.0140624999999999*G0_1_13_0 - 0.00321428571428571*G0_1_14_0 + 0.00261160714285713*G0_1_15_0 + 0.000200892857142853*G0_1_16_0 + 0.00683035714285711*G0_1_17_0 - 0.0100446428571428*G0_1_18_0 - 0.00964285714285712*G0_1_19_0;
    A[82] = 0.00241071428571428*G0_0_0_1 + 0.00261160714285714*G0_0_1_1 + 0.0133928571428571*G0_0_2_1 - 0.0140624999999999*G0_0_3_1 + 0.0401785714285712*G0_0_4_1 - 0.0100446428571428*G0_0_5_1 + 0.0200892857142856*G0_0_6_1 - 0.00220982142857142*G0_0_7_1 - 0.00281249999999998*G0_0_8_1 + 0.0120535714285714*G0_0_9_1 + 0.00241071428571428*G0_1_10_1 + 0.00261160714285714*G0_1_11_1 + 0.0133928571428571*G0_1_12_1 - 0.0140624999999999*G0_1_13_1 + 0.0401785714285712*G0_1_14_1 - 0.0100446428571428*G0_1_15_1 + 0.0200892857142856*G0_1_16_1 - 0.00220982142857142*G0_1_17_1 - 0.00281249999999998*G0_1_18_1 + 0.0120535714285714*G0_1_19_1;
    A[83] = 0.00140625*G0_0_0_0 - 0.00281249999999999*G0_0_0_1 - 0.0050223214285714*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.0050223214285714*G0_0_2_1 - 0.0054241071428572*G0_0_3_0 - 0.0271205357142856*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 - 0.00542410714285714*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 - 0.00180803571428571*G0_0_6_1 - 0.0018080357142857*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 - 0.01265625*G0_0_8_0 - 0.0271205357142856*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 + 0.00140625*G0_1_10_0 - 0.00281249999999999*G0_1_10_1 - 0.0050223214285714*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.0050223214285714*G0_1_12_1 - 0.0054241071428572*G0_1_13_0 - 0.0271205357142856*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 - 0.00542410714285714*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 - 0.00180803571428571*G0_1_16_1 - 0.0018080357142857*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 - 0.01265625*G0_1_18_0 - 0.0271205357142856*G0_1_18_1 + 0.0108482142857142*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[84] = 0.00743303571428569*G0_0_0_0 + 0.0074330357142857*G0_0_0_1 + 0.00763392857142855*G0_0_1_0 + 0.0060267857142857*G0_0_1_1 + 0.0241071428571427*G0_0_2_0 + 0.00401785714285711*G0_0_2_1 - 0.0271205357142856*G0_0_3_0 - 0.0054241071428572*G0_0_3_1 + 0.108482142857142*G0_0_4_0 + 0.108482142857142*G0_0_4_1 - 0.0271205357142856*G0_0_5_0 - 0.0235044642857142*G0_0_5_1 + 0.0542410714285712*G0_0_6_0 + 0.0361607142857142*G0_0_6_1 - 0.00723214285714284*G0_0_7_0 - 0.0108482142857143*G0_0_7_1 - 0.0018080357142857*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0542410714285712*G0_0_9_0 + 0.0650892857142855*G0_0_9_1 + 0.00743303571428569*G0_1_10_0 + 0.0074330357142857*G0_1_10_1 + 0.00763392857142855*G0_1_11_0 + 0.0060267857142857*G0_1_11_1 + 0.0241071428571427*G0_1_12_0 + 0.00401785714285711*G0_1_12_1 - 0.0271205357142856*G0_1_13_0 - 0.0054241071428572*G0_1_13_1 + 0.108482142857142*G0_1_14_0 + 0.108482142857142*G0_1_14_1 - 0.0271205357142856*G0_1_15_0 - 0.0235044642857142*G0_1_15_1 + 0.0542410714285712*G0_1_16_0 + 0.0361607142857142*G0_1_16_1 - 0.00723214285714284*G0_1_17_0 - 0.0108482142857143*G0_1_17_1 - 0.0018080357142857*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0542410714285712*G0_1_19_0 + 0.0650892857142855*G0_1_19_1;
    A[85] = 0.00220982142857142*G0_0_0_0 + 0.00120535714285714*G0_0_0_1 + 0.000200892857142852*G0_0_1_0 - 0.000200892857142857*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0110491071428571*G0_0_2_1 - 0.00542410714285715*G0_0_3_0 - 0.00180803571428573*G0_0_3_1 + 0.0542410714285711*G0_0_4_0 + 0.0470089285714283*G0_0_4_1 - 0.00542410714285712*G0_0_5_0 - 0.00723214285714283*G0_0_5_1 - 0.00180803571428572*G0_0_6_1 + 0.00180803571428571*G0_0_7_0 - 0.00542410714285712*G0_0_7_1 + 0.00180803571428569*G0_0_8_0 + 0.00542410714285712*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 + 0.00220982142857142*G0_1_10_0 + 0.00120535714285714*G0_1_10_1 + 0.000200892857142852*G0_1_11_0 - 0.000200892857142857*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0110491071428571*G0_1_12_1 - 0.00542410714285715*G0_1_13_0 - 0.00180803571428573*G0_1_13_1 + 0.0542410714285711*G0_1_14_0 + 0.0470089285714283*G0_1_14_1 - 0.00542410714285712*G0_1_15_0 - 0.00723214285714283*G0_1_15_1 - 0.00180803571428572*G0_1_16_1 + 0.00180803571428571*G0_1_17_0 - 0.00542410714285712*G0_1_17_1 + 0.00180803571428569*G0_1_18_0 + 0.00542410714285712*G0_1_18_1 + 0.0108482142857142*G0_1_19_0;
    A[86] = -0.00743303571428569*G0_0_0_0 - 0.00361607142857142*G0_0_0_1 - 0.00763392857142855*G0_0_1_0 - 0.00381696428571427*G0_0_1_1 - 0.0241071428571427*G0_0_2_0 - 0.0220982142857142*G0_0_2_1 + 0.0271205357142856*G0_0_3_0 + 0.0144642857142857*G0_0_3_1 - 0.108482142857142*G0_0_4_0 - 0.0723214285714282*G0_0_4_1 + 0.0271205357142856*G0_0_5_0 + 0.0144642857142856*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 - 0.0180803571428571*G0_0_6_1 + 0.00723214285714284*G0_0_7_0 + 0.00542410714285711*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 - 0.0542410714285712*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00743303571428569*G0_1_10_0 - 0.00361607142857142*G0_1_10_1 - 0.00763392857142855*G0_1_11_0 - 0.00381696428571427*G0_1_11_1 - 0.0241071428571427*G0_1_12_0 - 0.0220982142857142*G0_1_12_1 + 0.0271205357142856*G0_1_13_0 + 0.0144642857142857*G0_1_13_1 - 0.108482142857142*G0_1_14_0 - 0.0723214285714282*G0_1_14_1 + 0.0271205357142856*G0_1_15_0 + 0.0144642857142856*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 - 0.0180803571428571*G0_1_16_1 + 0.00723214285714284*G0_1_17_0 + 0.00542410714285711*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 - 0.0542410714285712*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[87] = -0.00120535714285714*G0_0_0_0 - 0.000200892857142856*G0_0_0_1 - 0.0064285714285714*G0_0_1_0 - 0.00602678571428569*G0_0_1_1 + 0.00100446428571427*G0_0_2_0 + 0.00200892857142856*G0_0_2_1 - 0.00180803571428572*G0_0_3_0 - 0.00542410714285716*G0_0_3_1 + 0.0144642857142856*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.0018080357142857*G0_0_5_1 - 0.00542410714285713*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 + 0.00361607142857141*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 + 0.00904017857142853*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00120535714285714*G0_1_10_0 - 0.000200892857142856*G0_1_10_1 - 0.0064285714285714*G0_1_11_0 - 0.00602678571428569*G0_1_11_1 + 0.00100446428571427*G0_1_12_0 + 0.00200892857142856*G0_1_12_1 - 0.00180803571428572*G0_1_13_0 - 0.00542410714285716*G0_1_13_1 + 0.0144642857142856*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.0018080357142857*G0_1_15_1 - 0.00542410714285713*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 + 0.00361607142857141*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 + 0.00904017857142853*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[88] = 0.00301339285714284*G0_0_0_0 + 0.00281249999999998*G0_0_0_1 + 0.0110491071428571*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 + 0.0050223214285714*G0_0_2_1 + 0.0144642857142857*G0_0_3_0 + 0.0271205357142856*G0_0_3_1 + 0.0036160714285714*G0_0_4_0 - 0.0108482142857143*G0_0_4_1 - 0.00542410714285711*G0_0_5_0 - 0.0036160714285714*G0_0_5_1 + 0.00542410714285712*G0_0_6_0 + 0.0018080357142857*G0_0_6_1 - 0.0126562499999999*G0_0_7_0 - 0.0108482142857142*G0_0_7_1 + 0.00361607142857141*G0_0_8_0 + 0.0271205357142856*G0_0_8_1 + 0.0216964285714285*G0_0_9_1 + 0.00301339285714284*G0_1_10_0 + 0.00281249999999998*G0_1_10_1 + 0.0110491071428571*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 + 0.0050223214285714*G0_1_12_1 + 0.0144642857142857*G0_1_13_0 + 0.0271205357142856*G0_1_13_1 + 0.0036160714285714*G0_1_14_0 - 0.0108482142857143*G0_1_14_1 - 0.00542410714285711*G0_1_15_0 - 0.0036160714285714*G0_1_15_1 + 0.00542410714285712*G0_1_16_0 + 0.0018080357142857*G0_1_16_1 - 0.0126562499999999*G0_1_17_0 - 0.0108482142857142*G0_1_17_1 + 0.00361607142857141*G0_1_18_0 + 0.0271205357142856*G0_1_18_1 + 0.0216964285714285*G0_1_19_1;
    A[89] = -0.00361607142857142*G0_0_0_0 - 0.00723214285714284*G0_0_0_1 + 0.00482142857142855*G0_0_1_0 - 0.00602678571428567*G0_0_2_1 + 0.0108482142857144*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 - 0.108482142857142*G0_0_4_0 - 0.130178571428571*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.0325446428571428*G0_0_6_1 + 0.0108482142857143*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.086785714285714*G0_0_9_1 - 0.00361607142857142*G0_1_10_0 - 0.00723214285714284*G0_1_10_1 + 0.00482142857142855*G0_1_11_0 - 0.00602678571428567*G0_1_12_1 + 0.0108482142857144*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 - 0.108482142857142*G0_1_14_0 - 0.130178571428571*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.0325446428571428*G0_1_16_1 + 0.0108482142857143*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.086785714285714*G0_1_19_1;
    A[90] = 0;
    A[91] = 0;
    A[92] = 0;
    A[93] = 0;
    A[94] = 0;
    A[95] = 0;
    A[96] = 0;
    A[97] = 0;
    A[98] = 0;
    A[99] = 0;
    A[100] = -0.0133928571428571*G0_0_0_0 - 0.0133928571428571*G0_0_0_1 - 0.00241071428571427*G0_0_1_0 - 0.00241071428571427*G0_0_1_1 - 0.00261160714285713*G0_0_2_0 - 0.00261160714285713*G0_0_2_1 + 0.00220982142857142*G0_0_3_0 + 0.00220982142857142*G0_0_3_1 + 0.00281249999999999*G0_0_4_0 + 0.00281249999999999*G0_0_4_1 - 0.0401785714285712*G0_0_5_0 - 0.0401785714285712*G0_0_5_1 + 0.0140624999999999*G0_0_6_0 + 0.0140624999999999*G0_0_6_1 - 0.0200892857142856*G0_0_7_0 - 0.0200892857142856*G0_0_7_1 + 0.0100446428571428*G0_0_8_0 + 0.0100446428571428*G0_0_8_1 - 0.0120535714285714*G0_0_9_0 - 0.0120535714285714*G0_0_9_1 - 0.0133928571428571*G0_1_10_0 - 0.0133928571428571*G0_1_10_1 - 0.00241071428571427*G0_1_11_0 - 0.00241071428571427*G0_1_11_1 - 0.00261160714285713*G0_1_12_0 - 0.00261160714285713*G0_1_12_1 + 0.00220982142857142*G0_1_13_0 + 0.00220982142857142*G0_1_13_1 + 0.00281249999999999*G0_1_14_0 + 0.00281249999999999*G0_1_14_1 - 0.0401785714285712*G0_1_15_0 - 0.0401785714285712*G0_1_15_1 + 0.0140624999999999*G0_1_16_0 + 0.0140624999999999*G0_1_16_1 - 0.0200892857142856*G0_1_17_0 - 0.0200892857142856*G0_1_17_1 + 0.0100446428571428*G0_1_18_0 + 0.0100446428571428*G0_1_18_1 - 0.0120535714285714*G0_1_19_0 - 0.0120535714285714*G0_1_19_1;
    A[101] = 0.00234374999999999*G0_0_0_0 - 0.00140625*G0_0_2_0 - 0.00220982142857141*G0_0_3_0 + 0.00261160714285713*G0_0_4_0 + 0.0148660714285714*G0_0_5_0 - 0.00140625*G0_0_6_0 + 0.000200892857142853*G0_0_7_0 - 0.00281249999999998*G0_0_8_0 + 0.00120535714285716*G0_0_9_0 + 0.00234374999999999*G0_1_10_0 - 0.00140625*G0_1_12_0 - 0.00220982142857141*G0_1_13_0 + 0.00261160714285713*G0_1_14_0 + 0.0148660714285714*G0_1_15_0 - 0.00140625*G0_1_16_0 + 0.000200892857142853*G0_1_17_0 - 0.00281249999999998*G0_1_18_0 + 0.00120535714285716*G0_1_19_0;
    A[102] = 0.000334821428571421*G0_0_0_1 - 0.00180803571428571*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 + 0.00683035714285711*G0_0_3_1 - 0.0100446428571428*G0_0_4_1 - 0.00321428571428571*G0_0_5_1 - 0.0140624999999999*G0_0_6_1 + 0.000200892857142842*G0_0_7_1 + 0.00261160714285714*G0_0_8_1 - 0.0096428571428571*G0_0_9_1 + 0.000334821428571421*G0_1_10_1 - 0.00180803571428571*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 + 0.00683035714285711*G0_1_13_1 - 0.0100446428571428*G0_1_14_1 - 0.00321428571428571*G0_1_15_1 - 0.0140624999999999*G0_1_16_1 + 0.000200892857142842*G0_1_17_1 + 0.00261160714285714*G0_1_18_1 - 0.0096428571428571*G0_1_19_1;
    A[103] = -0.00200892857142856*G0_0_0_0 - 0.00100446428571428*G0_0_0_1 + 0.000200892857142859*G0_0_1_0 - 0.00100446428571427*G0_0_1_1 + 0.00602678571428569*G0_0_2_0 - 0.000401785714285713*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 - 0.0072321428571428*G0_0_3_1 - 0.00542410714285714*G0_0_4_0 + 0.00361607142857141*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.00723214285714284*G0_0_5_1 + 0.00542410714285711*G0_0_6_0 + 0.00361607142857141*G0_0_6_1 + 0.00361607142857141*G0_0_7_0 - 0.00180803571428571*G0_0_7_1 - 0.0018080357142857*G0_0_8_0 - 0.00180803571428569*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00200892857142856*G0_1_10_0 - 0.00100446428571428*G0_1_10_1 + 0.000200892857142859*G0_1_11_0 - 0.00100446428571427*G0_1_11_1 + 0.00602678571428569*G0_1_12_0 - 0.000401785714285713*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 - 0.0072321428571428*G0_1_13_1 - 0.00542410714285714*G0_1_14_0 + 0.00361607142857141*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.00723214285714284*G0_1_15_1 + 0.00542410714285711*G0_1_16_0 + 0.00361607142857141*G0_1_16_1 + 0.00361607142857141*G0_1_17_0 - 0.00180803571428571*G0_1_17_1 - 0.0018080357142857*G0_1_18_0 - 0.00180803571428569*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[104] = -0.00502232142857141*G0_0_0_0 - 0.00401785714285713*G0_0_0_1 - 0.00281249999999999*G0_0_1_0 + 0.000200892857142853*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.00100446428571428*G0_0_2_1 + 0.0108482142857142*G0_0_3_0 - 0.0018080357142857*G0_0_3_1 - 0.0271205357142856*G0_0_4_0 - 0.0235044642857142*G0_0_4_1 + 0.0108482142857142*G0_0_5_0 + 0.0144642857142857*G0_0_5_1 - 0.0271205357142856*G0_0_6_0 - 0.01265625*G0_0_6_1 - 0.00180803571428571*G0_0_7_0 + 0.00361607142857142*G0_0_7_1 + 0.00361607142857141*G0_0_8_0 - 0.00180803571428571*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00502232142857141*G0_1_10_0 - 0.00401785714285713*G0_1_10_1 - 0.00281249999999999*G0_1_11_0 + 0.000200892857142853*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.00100446428571428*G0_1_12_1 + 0.0108482142857142*G0_1_13_0 - 0.0018080357142857*G0_1_13_1 - 0.0271205357142856*G0_1_14_0 - 0.0235044642857142*G0_1_14_1 + 0.0108482142857142*G0_1_15_0 + 0.0144642857142857*G0_1_15_1 - 0.0271205357142856*G0_1_16_0 - 0.01265625*G0_1_16_1 - 0.00180803571428571*G0_1_17_0 + 0.00361607142857142*G0_1_17_1 + 0.00361607142857141*G0_1_18_0 - 0.00180803571428571*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[105] = -0.00401785714285709*G0_0_0_0 + 0.0200892857142856*G0_0_0_1 - 0.00743303571428569*G0_0_1_0 - 0.00602678571428567*G0_0_2_0 + 0.00160714285714285*G0_0_2_1 + 0.0108482142857143*G0_0_3_0 + 0.00361607142857141*G0_0_3_1 - 0.00542410714285712*G0_0_4_0 - 0.00723214285714283*G0_0_4_1 - 0.108482142857142*G0_0_5_0 + 0.00542410714285713*G0_0_6_0 - 0.0216964285714285*G0_0_6_1 - 0.0361607142857141*G0_0_7_0 + 0.018080357142857*G0_0_7_1 + 0.0235044642857142*G0_0_8_0 - 0.0036160714285714*G0_0_8_1 - 0.0650892857142855*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00401785714285709*G0_1_10_0 + 0.0200892857142856*G0_1_10_1 - 0.00743303571428569*G0_1_11_0 - 0.00602678571428567*G0_1_12_0 + 0.00160714285714285*G0_1_12_1 + 0.0108482142857143*G0_1_13_0 + 0.00361607142857141*G0_1_13_1 - 0.00542410714285712*G0_1_14_0 - 0.00723214285714283*G0_1_14_1 - 0.108482142857142*G0_1_15_0 + 0.00542410714285713*G0_1_16_0 - 0.0216964285714285*G0_1_16_1 - 0.0361607142857141*G0_1_17_0 + 0.018080357142857*G0_1_17_1 + 0.0235044642857142*G0_1_18_0 - 0.0036160714285714*G0_1_18_1 - 0.0650892857142855*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[106] = 0.00502232142857141*G0_0_0_0 - 0.00703124999999997*G0_0_0_1 + 0.00281249999999999*G0_0_1_0 + 0.00421874999999999*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.00703124999999996*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 - 0.01265625*G0_0_3_1 + 0.0271205357142856*G0_0_4_0 + 0.0144642857142856*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 + 0.043392857142857*G0_0_5_1 + 0.0271205357142856*G0_0_6_0 + 0.0216964285714285*G0_0_6_1 + 0.00180803571428571*G0_0_7_0 + 0.00180803571428574*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 - 0.00904017857142854*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.0325446428571428*G0_0_9_1 + 0.00502232142857141*G0_1_10_0 - 0.00703124999999997*G0_1_10_1 + 0.00281249999999999*G0_1_11_0 + 0.00421874999999999*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.00703124999999996*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 - 0.01265625*G0_1_13_1 + 0.0271205357142856*G0_1_14_0 + 0.0144642857142856*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 + 0.043392857142857*G0_1_15_1 + 0.0271205357142856*G0_1_16_0 + 0.0216964285714285*G0_1_16_1 + 0.00180803571428571*G0_1_17_0 + 0.00180803571428574*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 - 0.00904017857142854*G0_1_18_1 + 0.0216964285714285*G0_1_19_0 + 0.0325446428571428*G0_1_19_1;
    A[107] = 0.0220982142857142*G0_0_0_0 - 0.00200892857142855*G0_0_0_1 + 0.00361607142857142*G0_0_1_0 - 0.00381696428571427*G0_0_1_1 + 0.00381696428571427*G0_0_2_0 - 0.00381696428571426*G0_0_2_1 - 0.00542410714285712*G0_0_3_0 + 0.00180803571428572*G0_0_3_1 + 0.0018080357142857*G0_0_4_1 + 0.0723214285714283*G0_0_5_0 - 0.0361607142857142*G0_0_5_1 - 0.0144642857142857*G0_0_6_0 + 0.0126562499999999*G0_0_6_1 + 0.0180803571428571*G0_0_7_0 - 0.0361607142857141*G0_0_7_1 - 0.0144642857142856*G0_0_8_0 + 0.0126562499999999*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 - 0.043392857142857*G0_0_9_1 + 0.0220982142857142*G0_1_10_0 - 0.00200892857142855*G0_1_10_1 + 0.00361607142857142*G0_1_11_0 - 0.00381696428571427*G0_1_11_1 + 0.00381696428571427*G0_1_12_0 - 0.00381696428571426*G0_1_12_1 - 0.00542410714285712*G0_1_13_0 + 0.00180803571428572*G0_1_13_1 + 0.0018080357142857*G0_1_14_1 + 0.0723214285714283*G0_1_15_0 - 0.0361607142857142*G0_1_15_1 - 0.0144642857142857*G0_1_16_0 + 0.0126562499999999*G0_1_16_1 + 0.0180803571428571*G0_1_17_0 - 0.0361607142857141*G0_1_17_1 - 0.0144642857142856*G0_1_18_0 + 0.0126562499999999*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 - 0.043392857142857*G0_1_19_1;
    A[108] = -0.0110491071428571*G0_0_0_0 + 0.00100446428571428*G0_0_0_1 - 0.00120535714285715*G0_0_1_0 + 0.00100446428571427*G0_0_1_1 + 0.000200892857142856*G0_0_2_0 + 0.000401785714285712*G0_0_2_1 + 0.00542410714285711*G0_0_3_0 + 0.00723214285714281*G0_0_3_1 - 0.00542410714285711*G0_0_4_0 - 0.0036160714285714*G0_0_4_1 - 0.0470089285714284*G0_0_5_0 + 0.00723214285714282*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 + 0.0018080357142857*G0_0_7_0 + 0.00180803571428571*G0_0_7_1 + 0.00723214285714282*G0_0_8_0 + 0.00180803571428569*G0_0_8_1 + 0.0108482142857142*G0_0_9_1 - 0.0110491071428571*G0_1_10_0 + 0.00100446428571428*G0_1_10_1 - 0.00120535714285715*G0_1_11_0 + 0.00100446428571427*G0_1_11_1 + 0.000200892857142856*G0_1_12_0 + 0.000401785714285712*G0_1_12_1 + 0.00542410714285711*G0_1_13_0 + 0.00723214285714281*G0_1_13_1 - 0.00542410714285711*G0_1_14_0 - 0.0036160714285714*G0_1_14_1 - 0.0470089285714284*G0_1_15_0 + 0.00723214285714282*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 + 0.0018080357142857*G0_1_17_0 + 0.00180803571428571*G0_1_17_1 + 0.00723214285714282*G0_1_18_0 + 0.00180803571428569*G0_1_18_1 + 0.0108482142857142*G0_1_19_1;
    A[109] = 0.00602678571428565*G0_0_0_0 + 0.00602678571428569*G0_0_0_1 + 0.00723214285714283*G0_0_1_0 + 0.00361607142857141*G0_0_1_1 + 0.00482142857142854*G0_0_2_1 + 0.0108482142857143*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.130178571428571*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 + 0.0325446428571427*G0_0_7_0 + 0.0325446428571427*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 + 0.086785714285714*G0_0_9_0 + 0.0650892857142855*G0_0_9_1 + 0.00602678571428565*G0_1_10_0 + 0.00602678571428569*G0_1_10_1 + 0.00723214285714283*G0_1_11_0 + 0.00361607142857141*G0_1_11_1 + 0.00482142857142854*G0_1_12_1 + 0.0108482142857143*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.130178571428571*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 + 0.0325446428571427*G0_1_17_0 + 0.0325446428571427*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 + 0.086785714285714*G0_1_19_0 + 0.0650892857142855*G0_1_19_1;
    A[110] = 0;
    A[111] = 0;
    A[112] = 0;
    A[113] = 0;
    A[114] = 0;
    A[115] = 0;
    A[116] = 0;
    A[117] = 0;
    A[118] = 0;
    A[119] = 0;
    A[120] = 0.00602678571428568*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 + 0.00180803571428571*G0_0_1_0 + 0.00180803571428571*G0_0_1_1 - 0.000334821428571433*G0_0_2_0 - 0.000334821428571433*G0_0_2_1 - 0.00261160714285713*G0_0_3_0 - 0.00261160714285713*G0_0_3_1 - 0.00020089285714285*G0_0_4_0 - 0.000200892857142851*G0_0_4_1 + 0.0140624999999999*G0_0_5_0 + 0.0140624999999999*G0_0_5_1 + 0.00321428571428572*G0_0_6_0 + 0.00321428571428573*G0_0_6_1 + 0.0100446428571428*G0_0_7_0 + 0.0100446428571428*G0_0_7_1 - 0.00683035714285711*G0_0_8_0 - 0.00683035714285711*G0_0_8_1 + 0.00964285714285711*G0_0_9_0 + 0.00964285714285712*G0_0_9_1 + 0.00602678571428568*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 + 0.00180803571428571*G0_1_11_0 + 0.00180803571428571*G0_1_11_1 - 0.000334821428571433*G0_1_12_0 - 0.000334821428571433*G0_1_12_1 - 0.00261160714285713*G0_1_13_0 - 0.00261160714285713*G0_1_13_1 - 0.00020089285714285*G0_1_14_0 - 0.000200892857142851*G0_1_14_1 + 0.0140624999999999*G0_1_15_0 + 0.0140624999999999*G0_1_15_1 + 0.00321428571428572*G0_1_16_0 + 0.00321428571428573*G0_1_16_1 + 0.0100446428571428*G0_1_17_0 + 0.0100446428571428*G0_1_17_1 - 0.00683035714285711*G0_1_18_0 - 0.00683035714285711*G0_1_18_1 + 0.00964285714285711*G0_1_19_0 + 0.00964285714285712*G0_1_19_1;
    A[121] = -0.00140624999999999*G0_0_0_0 + 0.00234374999999999*G0_0_2_0 - 0.00281249999999999*G0_0_3_0 + 0.000200892857142853*G0_0_4_0 - 0.00140624999999999*G0_0_5_0 + 0.0148660714285714*G0_0_6_0 + 0.00261160714285713*G0_0_7_0 - 0.00220982142857142*G0_0_8_0 + 0.00120535714285713*G0_0_9_0 - 0.00140624999999999*G0_1_10_0 + 0.00234374999999999*G0_1_12_0 - 0.00281249999999999*G0_1_13_0 + 0.000200892857142853*G0_1_14_0 - 0.00140624999999999*G0_1_15_0 + 0.0148660714285714*G0_1_16_0 + 0.00261160714285713*G0_1_17_0 - 0.00220982142857142*G0_1_18_0 + 0.00120535714285713*G0_1_19_0;
    A[122] = 0.00261160714285714*G0_0_0_1 + 0.00241071428571428*G0_0_1_1 + 0.0133928571428571*G0_0_2_1 - 0.0100446428571428*G0_0_3_1 + 0.0200892857142856*G0_0_4_1 - 0.0140624999999999*G0_0_5_1 + 0.0401785714285713*G0_0_6_1 - 0.00281249999999998*G0_0_7_1 - 0.00220982142857142*G0_0_8_1 + 0.0120535714285714*G0_0_9_1 + 0.00261160714285714*G0_1_10_1 + 0.00241071428571428*G0_1_11_1 + 0.0133928571428571*G0_1_12_1 - 0.0100446428571428*G0_1_13_1 + 0.0200892857142856*G0_1_14_1 - 0.0140624999999999*G0_1_15_1 + 0.0401785714285713*G0_1_16_1 - 0.00281249999999998*G0_1_17_1 - 0.00220982142857142*G0_1_18_1 + 0.0120535714285714*G0_1_19_1;
    A[123] = -0.000200892857142856*G0_0_0_0 - 0.000401785714285713*G0_0_0_1 - 0.00220982142857142*G0_0_1_0 - 0.00100446428571428*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.00100446428571427*G0_0_2_1 + 0.0054241071428571*G0_0_3_0 - 0.00180803571428572*G0_0_3_1 - 0.00180803571428571*G0_0_4_1 + 0.00542410714285711*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 - 0.00723214285714284*G0_0_6_1 - 0.00180803571428571*G0_0_7_0 + 0.00361607142857141*G0_0_7_1 - 0.00180803571428571*G0_0_8_0 - 0.00723214285714283*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0108482142857143*G0_0_9_1 - 0.000200892857142856*G0_1_10_0 - 0.000401785714285713*G0_1_10_1 - 0.00220982142857142*G0_1_11_0 - 0.00100446428571428*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.00100446428571427*G0_1_12_1 + 0.0054241071428571*G0_1_13_0 - 0.00180803571428572*G0_1_13_1 - 0.00180803571428571*G0_1_14_1 + 0.00542410714285711*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 - 0.00723214285714284*G0_1_16_1 - 0.00180803571428571*G0_1_17_0 + 0.00361607142857141*G0_1_17_1 - 0.00180803571428571*G0_1_18_0 - 0.00723214285714283*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0108482142857143*G0_1_19_1;
    A[124] = 0.00763392857142854*G0_0_0_0 + 0.00381696428571428*G0_0_0_1 + 0.0074330357142857*G0_0_1_0 + 0.00381696428571428*G0_0_1_1 + 0.0241071428571427*G0_0_2_0 + 0.00200892857142856*G0_0_2_1 - 0.0271205357142856*G0_0_3_0 - 0.01265625*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0361607142857142*G0_0_4_1 - 0.0271205357142856*G0_0_5_0 - 0.01265625*G0_0_5_1 + 0.108482142857142*G0_0_6_0 + 0.0361607142857142*G0_0_6_1 - 0.0018080357142857*G0_0_7_0 - 0.00180803571428571*G0_0_7_1 - 0.00723214285714282*G0_0_8_0 - 0.00180803571428571*G0_0_8_1 + 0.0542410714285712*G0_0_9_0 + 0.043392857142857*G0_0_9_1 + 0.00763392857142854*G0_1_10_0 + 0.00381696428571428*G0_1_10_1 + 0.0074330357142857*G0_1_11_0 + 0.00381696428571428*G0_1_11_1 + 0.0241071428571427*G0_1_12_0 + 0.00200892857142856*G0_1_12_1 - 0.0271205357142856*G0_1_13_0 - 0.01265625*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0361607142857142*G0_1_14_1 - 0.0271205357142856*G0_1_15_0 - 0.01265625*G0_1_15_1 + 0.108482142857142*G0_1_16_0 + 0.0361607142857142*G0_1_16_1 - 0.0018080357142857*G0_1_17_0 - 0.00180803571428571*G0_1_17_1 - 0.00723214285714282*G0_1_18_0 - 0.00180803571428571*G0_1_18_1 + 0.0542410714285712*G0_1_19_0 + 0.043392857142857*G0_1_19_1;
    A[125] = 0.0050223214285714*G0_0_0_0 - 0.00703124999999995*G0_0_0_1 - 0.00140625*G0_0_1_0 - 0.00421874999999999*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.00703124999999999*G0_0_2_1 + 0.00542410714285713*G0_0_3_0 + 0.00904017857142854*G0_0_3_1 - 0.00180803571428572*G0_0_4_1 + 0.00542410714285713*G0_0_5_0 - 0.0216964285714285*G0_0_5_1 - 0.0542410714285713*G0_0_6_0 - 0.043392857142857*G0_0_6_1 + 0.0126562499999999*G0_0_7_0 - 0.0144642857142856*G0_0_7_1 + 0.00180803571428571*G0_0_8_0 + 0.0126562499999999*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0325446428571427*G0_0_9_1 + 0.0050223214285714*G0_1_10_0 - 0.00703124999999995*G0_1_10_1 - 0.00140625*G0_1_11_0 - 0.00421874999999999*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.00703124999999999*G0_1_12_1 + 0.00542410714285713*G0_1_13_0 + 0.00904017857142854*G0_1_13_1 - 0.00180803571428572*G0_1_14_1 + 0.00542410714285713*G0_1_15_0 - 0.0216964285714285*G0_1_15_1 - 0.0542410714285713*G0_1_16_0 - 0.043392857142857*G0_1_16_1 + 0.0126562499999999*G0_1_17_0 - 0.0144642857142856*G0_1_17_1 + 0.00180803571428571*G0_1_18_0 + 0.0126562499999999*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0325446428571427*G0_1_19_1;
    A[126] = -0.00763392857142855*G0_0_0_0 - 0.00160714285714286*G0_0_0_1 - 0.0074330357142857*G0_0_1_0 - 0.0241071428571427*G0_0_2_0 - 0.0200892857142856*G0_0_2_1 + 0.0271205357142856*G0_0_3_0 + 0.0036160714285714*G0_0_3_1 - 0.0542410714285712*G0_0_4_0 - 0.0180803571428571*G0_0_4_1 + 0.0271205357142856*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.108482142857142*G0_0_6_0 + 0.0018080357142857*G0_0_7_0 + 0.0072321428571428*G0_0_7_1 + 0.00723214285714282*G0_0_8_0 - 0.00361607142857141*G0_0_8_1 - 0.0542410714285712*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 - 0.00763392857142855*G0_1_10_0 - 0.00160714285714286*G0_1_10_1 - 0.0074330357142857*G0_1_11_0 - 0.0241071428571427*G0_1_12_0 - 0.0200892857142856*G0_1_12_1 + 0.0271205357142856*G0_1_13_0 + 0.0036160714285714*G0_1_13_1 - 0.0542410714285712*G0_1_14_0 - 0.0180803571428571*G0_1_14_1 + 0.0271205357142856*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.108482142857142*G0_1_16_0 + 0.0018080357142857*G0_1_17_0 + 0.0072321428571428*G0_1_17_1 + 0.00723214285714282*G0_1_18_0 - 0.00361607142857141*G0_1_18_1 - 0.0542410714285712*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[127] = -0.0110491071428571*G0_0_0_0 + 0.00100446428571427*G0_0_0_1 - 0.00301339285714285*G0_0_1_0 - 0.000200892857142861*G0_0_1_1 - 0.00100446428571429*G0_0_2_0 + 0.00401785714285712*G0_0_2_1 + 0.00542410714285712*G0_0_3_0 + 0.0018080357142857*G0_0_3_1 - 0.00542410714285713*G0_0_4_0 - 0.00361607142857141*G0_0_4_1 - 0.0144642857142857*G0_0_5_0 + 0.0126562499999999*G0_0_5_1 - 0.00361607142857146*G0_0_6_0 - 0.0144642857142857*G0_0_6_1 - 0.00361607142857142*G0_0_7_0 + 0.0235044642857142*G0_0_7_1 + 0.0126562499999999*G0_0_8_0 + 0.00180803571428571*G0_0_8_1 + 0.0216964285714285*G0_0_9_1 - 0.0110491071428571*G0_1_10_0 + 0.00100446428571427*G0_1_10_1 - 0.00301339285714285*G0_1_11_0 - 0.000200892857142861*G0_1_11_1 - 0.00100446428571429*G0_1_12_0 + 0.00401785714285712*G0_1_12_1 + 0.00542410714285712*G0_1_13_0 + 0.0018080357142857*G0_1_13_1 - 0.00542410714285713*G0_1_14_0 - 0.00361607142857141*G0_1_14_1 - 0.0144642857142857*G0_1_15_0 + 0.0126562499999999*G0_1_15_1 - 0.00361607142857146*G0_1_16_0 - 0.0144642857142857*G0_1_16_1 - 0.00361607142857142*G0_1_17_0 + 0.0235044642857142*G0_1_17_1 + 0.0126562499999999*G0_1_18_0 + 0.00180803571428571*G0_1_18_1 + 0.0216964285714285*G0_1_19_1;
    A[128] = 0.0064285714285714*G0_0_0_0 + 0.000401785714285714*G0_0_0_1 + 0.00120535714285714*G0_0_1_0 + 0.00100446428571428*G0_0_1_1 - 0.00100446428571427*G0_0_2_0 + 0.00100446428571428*G0_0_2_1 + 0.00180803571428572*G0_0_3_1 + 0.00542410714285712*G0_0_4_0 + 0.0018080357142857*G0_0_4_1 + 0.00180803571428571*G0_0_5_0 - 0.00361607142857141*G0_0_5_1 - 0.0144642857142856*G0_0_6_0 + 0.00723214285714284*G0_0_6_1 - 0.00904017857142852*G0_0_7_0 - 0.00361607142857142*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 + 0.00723214285714283*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 + 0.0064285714285714*G0_1_10_0 + 0.000401785714285714*G0_1_10_1 + 0.00120535714285714*G0_1_11_0 + 0.00100446428571428*G0_1_11_1 - 0.00100446428571427*G0_1_12_0 + 0.00100446428571428*G0_1_12_1 + 0.00180803571428572*G0_1_13_1 + 0.00542410714285712*G0_1_14_0 + 0.0018080357142857*G0_1_14_1 + 0.00180803571428571*G0_1_15_0 - 0.00361607142857141*G0_1_15_1 - 0.0144642857142856*G0_1_16_0 + 0.00723214285714284*G0_1_16_1 - 0.00904017857142852*G0_1_17_0 - 0.00361607142857142*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 + 0.00723214285714283*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[129] = -0.00482142857142855*G0_0_0_0 - 0.00482142857142855*G0_0_0_1 + 0.00361607142857142*G0_0_1_0 - 0.00361607142857142*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 - 0.0325446428571428*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 + 0.108482142857142*G0_0_6_0 - 0.0216964285714285*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0216964285714284*G0_0_7_1 + 0.0216964285714285*G0_0_9_0 - 0.0650892857142855*G0_0_9_1 - 0.00482142857142855*G0_1_10_0 - 0.00482142857142855*G0_1_10_1 + 0.00361607142857142*G0_1_11_0 - 0.00361607142857142*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 - 0.0325446428571428*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 + 0.108482142857142*G0_1_16_0 - 0.0216964285714285*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0216964285714284*G0_1_17_1 + 0.0216964285714285*G0_1_19_0 - 0.0650892857142855*G0_1_19_1;
    A[130] = 0;
    A[131] = 0;
    A[132] = 0;
    A[133] = 0;
    A[134] = 0;
    A[135] = 0;
    A[136] = 0;
    A[137] = 0;
    A[138] = 0;
    A[139] = 0;
    A[140] = -0.0133928571428571*G0_0_0_0 - 0.0133928571428571*G0_0_0_1 - 0.00261160714285713*G0_0_1_0 - 0.00261160714285713*G0_0_1_1 - 0.00241071428571427*G0_0_2_0 - 0.00241071428571427*G0_0_2_1 + 0.00281249999999998*G0_0_3_0 + 0.00281249999999999*G0_0_3_1 + 0.00220982142857142*G0_0_4_0 + 0.00220982142857142*G0_0_4_1 - 0.0200892857142856*G0_0_5_0 - 0.0200892857142856*G0_0_5_1 + 0.0100446428571428*G0_0_6_0 + 0.0100446428571428*G0_0_6_1 - 0.0401785714285712*G0_0_7_0 - 0.0401785714285712*G0_0_7_1 + 0.0140624999999999*G0_0_8_0 + 0.0140624999999999*G0_0_8_1 - 0.0120535714285714*G0_0_9_0 - 0.0120535714285714*G0_0_9_1 - 0.0133928571428571*G0_1_10_0 - 0.0133928571428571*G0_1_10_1 - 0.00261160714285713*G0_1_11_0 - 0.00261160714285713*G0_1_11_1 - 0.00241071428571427*G0_1_12_0 - 0.00241071428571427*G0_1_12_1 + 0.00281249999999998*G0_1_13_0 + 0.00281249999999999*G0_1_13_1 + 0.00220982142857142*G0_1_14_0 + 0.00220982142857142*G0_1_14_1 - 0.0200892857142856*G0_1_15_0 - 0.0200892857142856*G0_1_15_1 + 0.0100446428571428*G0_1_16_0 + 0.0100446428571428*G0_1_16_1 - 0.0401785714285712*G0_1_17_0 - 0.0401785714285712*G0_1_17_1 + 0.0140624999999999*G0_1_18_0 + 0.0140624999999999*G0_1_18_1 - 0.0120535714285714*G0_1_19_0 - 0.0120535714285714*G0_1_19_1;
    A[141] = 0.000334821428571429*G0_0_0_0 - 0.00602678571428568*G0_0_1_0 - 0.0018080357142857*G0_0_2_0 - 0.0100446428571428*G0_0_3_0 + 0.00683035714285711*G0_0_4_0 + 0.000200892857142854*G0_0_5_0 + 0.00261160714285713*G0_0_6_0 - 0.0032142857142857*G0_0_7_0 - 0.0140624999999999*G0_0_8_0 - 0.00964285714285709*G0_0_9_0 + 0.000334821428571429*G0_1_10_0 - 0.00602678571428568*G0_1_11_0 - 0.0018080357142857*G0_1_12_0 - 0.0100446428571428*G0_1_13_0 + 0.00683035714285711*G0_1_14_0 + 0.000200892857142854*G0_1_15_0 + 0.00261160714285713*G0_1_16_0 - 0.0032142857142857*G0_1_17_0 - 0.0140624999999999*G0_1_18_0 - 0.00964285714285709*G0_1_19_0;
    A[142] = 0.00234374999999998*G0_0_0_1 - 0.00140625*G0_0_1_1 + 0.00261160714285714*G0_0_3_1 - 0.00220982142857142*G0_0_4_1 + 0.000200892857142842*G0_0_5_1 - 0.00281249999999998*G0_0_6_1 + 0.0148660714285713*G0_0_7_1 - 0.00140624999999998*G0_0_8_1 + 0.00120535714285713*G0_0_9_1 + 0.00234374999999998*G0_1_10_1 - 0.00140625*G0_1_11_1 + 0.00261160714285714*G0_1_13_1 - 0.00220982142857142*G0_1_14_1 + 0.000200892857142842*G0_1_15_1 - 0.00281249999999998*G0_1_16_1 + 0.0148660714285713*G0_1_17_1 - 0.00140624999999998*G0_1_18_1 + 0.00120535714285713*G0_1_19_1;
    A[143] = -0.00401785714285713*G0_0_0_0 - 0.0050223214285714*G0_0_0_1 - 0.00100446428571428*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 + 0.000200892857142856*G0_0_2_0 - 0.00281249999999998*G0_0_2_1 - 0.0235044642857142*G0_0_3_0 - 0.0271205357142856*G0_0_3_1 - 0.0018080357142857*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 + 0.00361607142857141*G0_0_5_0 - 0.00180803571428571*G0_0_5_1 - 0.00180803571428571*G0_0_6_0 + 0.00361607142857141*G0_0_6_1 + 0.0144642857142856*G0_0_7_0 + 0.0108482142857143*G0_0_7_1 - 0.01265625*G0_0_8_0 - 0.0271205357142856*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00401785714285713*G0_1_10_0 - 0.0050223214285714*G0_1_10_1 - 0.00100446428571428*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 + 0.000200892857142856*G0_1_12_0 - 0.00281249999999998*G0_1_12_1 - 0.0235044642857142*G0_1_13_0 - 0.0271205357142856*G0_1_13_1 - 0.0018080357142857*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 + 0.00361607142857141*G0_1_15_0 - 0.00180803571428571*G0_1_15_1 - 0.00180803571428571*G0_1_16_0 + 0.00361607142857141*G0_1_16_1 + 0.0144642857142856*G0_1_17_0 + 0.0108482142857143*G0_1_17_1 - 0.01265625*G0_1_18_0 - 0.0271205357142856*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[144] = -0.00100446428571428*G0_0_0_0 - 0.00200892857142857*G0_0_0_1 - 0.000401785714285714*G0_0_1_0 + 0.00602678571428569*G0_0_1_1 - 0.00100446428571428*G0_0_2_0 + 0.000200892857142858*G0_0_2_1 + 0.00361607142857142*G0_0_3_0 - 0.00542410714285712*G0_0_3_1 - 0.00723214285714284*G0_0_4_0 - 0.0108482142857143*G0_0_4_1 - 0.00180803571428571*G0_0_5_0 + 0.00361607142857142*G0_0_5_1 - 0.0018080357142857*G0_0_6_0 - 0.00180803571428571*G0_0_6_1 - 0.00723214285714285*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 + 0.00361607142857142*G0_0_8_0 + 0.00542410714285712*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00100446428571428*G0_1_10_0 - 0.00200892857142857*G0_1_10_1 - 0.000401785714285714*G0_1_11_0 + 0.00602678571428569*G0_1_11_1 - 0.00100446428571428*G0_1_12_0 + 0.000200892857142858*G0_1_12_1 + 0.00361607142857142*G0_1_13_0 - 0.00542410714285712*G0_1_13_1 - 0.00723214285714284*G0_1_14_0 - 0.0108482142857143*G0_1_14_1 - 0.00180803571428571*G0_1_15_0 + 0.00361607142857142*G0_1_15_1 - 0.0018080357142857*G0_1_16_0 - 0.00180803571428571*G0_1_16_1 - 0.00723214285714285*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 + 0.00361607142857142*G0_1_18_0 + 0.00542410714285712*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[145] = -0.00200892857142855*G0_0_0_0 + 0.0220982142857142*G0_0_0_1 - 0.00381696428571427*G0_0_1_0 + 0.00381696428571426*G0_0_1_1 - 0.00381696428571426*G0_0_2_0 + 0.0036160714285714*G0_0_2_1 + 0.0018080357142857*G0_0_3_0 + 0.00180803571428571*G0_0_4_0 - 0.00542410714285712*G0_0_4_1 - 0.0361607142857141*G0_0_5_0 + 0.018080357142857*G0_0_5_1 + 0.0126562499999999*G0_0_6_0 - 0.0144642857142856*G0_0_6_1 - 0.0361607142857141*G0_0_7_0 + 0.0723214285714282*G0_0_7_1 + 0.0126562499999999*G0_0_8_0 - 0.0144642857142856*G0_0_8_1 - 0.043392857142857*G0_0_9_0 + 0.0108482142857142*G0_0_9_1 - 0.00200892857142855*G0_1_10_0 + 0.0220982142857142*G0_1_10_1 - 0.00381696428571427*G0_1_11_0 + 0.00381696428571426*G0_1_11_1 - 0.00381696428571426*G0_1_12_0 + 0.0036160714285714*G0_1_12_1 + 0.0018080357142857*G0_1_13_0 + 0.00180803571428571*G0_1_14_0 - 0.00542410714285712*G0_1_14_1 - 0.0361607142857141*G0_1_15_0 + 0.018080357142857*G0_1_15_1 + 0.0126562499999999*G0_1_16_0 - 0.0144642857142856*G0_1_16_1 - 0.0361607142857141*G0_1_17_0 + 0.0723214285714282*G0_1_17_1 + 0.0126562499999999*G0_1_18_0 - 0.0144642857142856*G0_1_18_1 - 0.043392857142857*G0_1_19_0 + 0.0108482142857142*G0_1_19_1;
    A[146] = 0.00100446428571429*G0_0_0_0 - 0.0110491071428571*G0_0_0_1 + 0.000401785714285715*G0_0_1_0 + 0.000200892857142867*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 - 0.00120535714285713*G0_0_2_1 - 0.00361607142857141*G0_0_3_0 - 0.00542410714285711*G0_0_3_1 + 0.00723214285714284*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 + 0.00180803571428571*G0_0_5_0 + 0.00180803571428574*G0_0_5_1 + 0.0018080357142857*G0_0_6_0 + 0.0072321428571428*G0_0_6_1 + 0.00723214285714284*G0_0_7_0 - 0.0470089285714283*G0_0_7_1 - 0.00361607142857142*G0_0_8_0 + 0.0018080357142857*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 + 0.00100446428571429*G0_1_10_0 - 0.0110491071428571*G0_1_10_1 + 0.000401785714285715*G0_1_11_0 + 0.000200892857142867*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 - 0.00120535714285713*G0_1_12_1 - 0.00361607142857141*G0_1_13_0 - 0.00542410714285711*G0_1_13_1 + 0.00723214285714284*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 + 0.00180803571428571*G0_1_15_0 + 0.00180803571428574*G0_1_15_1 + 0.0018080357142857*G0_1_16_0 + 0.0072321428571428*G0_1_16_1 + 0.00723214285714284*G0_1_17_0 - 0.0470089285714283*G0_1_17_1 - 0.00361607142857142*G0_1_18_0 + 0.0018080357142857*G0_1_18_1 + 0.0108482142857143*G0_1_19_0;
    A[147] = 0.0200892857142856*G0_0_0_0 - 0.00401785714285711*G0_0_0_1 + 0.00160714285714286*G0_0_1_0 - 0.00602678571428568*G0_0_1_1 - 0.00743303571428566*G0_0_2_1 - 0.00723214285714282*G0_0_3_0 - 0.00542410714285712*G0_0_3_1 + 0.00361607142857141*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 + 0.0180803571428571*G0_0_5_0 - 0.0361607142857141*G0_0_5_1 - 0.00361607142857142*G0_0_6_0 + 0.0235044642857141*G0_0_6_1 - 0.108482142857142*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 - 0.0650892857142854*G0_0_9_1 + 0.0200892857142856*G0_1_10_0 - 0.00401785714285711*G0_1_10_1 + 0.00160714285714286*G0_1_11_0 - 0.00602678571428568*G0_1_11_1 - 0.00743303571428566*G0_1_12_1 - 0.00723214285714282*G0_1_13_0 - 0.00542410714285712*G0_1_13_1 + 0.00361607142857141*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 + 0.0180803571428571*G0_1_15_0 - 0.0361607142857141*G0_1_15_1 - 0.00361607142857142*G0_1_16_0 + 0.0235044642857141*G0_1_16_1 - 0.108482142857142*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 - 0.0650892857142854*G0_1_19_1;
    A[148] = -0.00703124999999997*G0_0_0_0 + 0.0050223214285714*G0_0_0_1 + 0.00703124999999996*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.00421874999999997*G0_0_2_0 + 0.00281249999999999*G0_0_2_1 + 0.0144642857142856*G0_0_3_0 + 0.0271205357142856*G0_0_3_1 - 0.0126562499999999*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 + 0.0018080357142857*G0_0_5_0 + 0.00180803571428571*G0_0_5_1 - 0.00904017857142852*G0_0_6_0 - 0.00361607142857142*G0_0_6_1 + 0.0433928571428569*G0_0_7_0 - 0.0108482142857142*G0_0_7_1 + 0.0216964285714285*G0_0_8_0 + 0.0271205357142856*G0_0_8_1 + 0.0325446428571427*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00703124999999997*G0_1_10_0 + 0.0050223214285714*G0_1_10_1 + 0.00703124999999996*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.00421874999999997*G0_1_12_0 + 0.00281249999999999*G0_1_12_1 + 0.0144642857142856*G0_1_13_0 + 0.0271205357142856*G0_1_13_1 - 0.0126562499999999*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 + 0.0018080357142857*G0_1_15_0 + 0.00180803571428571*G0_1_15_1 - 0.00904017857142852*G0_1_16_0 - 0.00361607142857142*G0_1_16_1 + 0.0433928571428569*G0_1_17_0 - 0.0108482142857142*G0_1_17_1 + 0.0216964285714285*G0_1_18_0 + 0.0271205357142856*G0_1_18_1 + 0.0325446428571427*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[149] = 0.00602678571428567*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 + 0.00482142857142855*G0_0_1_0 + 0.0036160714285714*G0_0_2_0 + 0.00723214285714281*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0108482142857142*G0_0_3_1 + 0.0325446428571427*G0_0_5_0 + 0.0325446428571427*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 - 0.0216964285714284*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.130178571428571*G0_0_7_1 - 0.0108482142857142*G0_0_8_1 + 0.0650892857142855*G0_0_9_0 + 0.0867857142857139*G0_0_9_1 + 0.00602678571428567*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 + 0.00482142857142855*G0_1_11_0 + 0.0036160714285714*G0_1_12_0 + 0.00723214285714281*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0108482142857142*G0_1_13_1 + 0.0325446428571427*G0_1_15_0 + 0.0325446428571427*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 - 0.0216964285714284*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.130178571428571*G0_1_17_1 - 0.0108482142857142*G0_1_18_1 + 0.0650892857142855*G0_1_19_0 + 0.0867857142857139*G0_1_19_1;
    A[150] = 0;
    A[151] = 0;
    A[152] = 0;
    A[153] = 0;
    A[154] = 0;
    A[155] = 0;
    A[156] = 0;
    A[157] = 0;
    A[158] = 0;
    A[159] = 0;
    A[160] = 0.00602678571428568*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 - 0.000334821428571427*G0_0_1_0 - 0.000334821428571429*G0_0_1_1 + 0.0018080357142857*G0_0_2_0 + 0.0018080357142857*G0_0_2_1 - 0.000200892857142849*G0_0_3_0 - 0.000200892857142852*G0_0_3_1 - 0.00261160714285713*G0_0_4_0 - 0.00261160714285713*G0_0_4_1 + 0.0100446428571428*G0_0_5_0 + 0.0100446428571428*G0_0_5_1 - 0.00683035714285711*G0_0_6_0 - 0.00683035714285711*G0_0_6_1 + 0.0140624999999999*G0_0_7_0 + 0.0140624999999999*G0_0_7_1 + 0.00321428571428571*G0_0_8_0 + 0.0032142857142857*G0_0_8_1 + 0.00964285714285712*G0_0_9_0 + 0.00964285714285712*G0_0_9_1 + 0.00602678571428568*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 - 0.000334821428571427*G0_1_11_0 - 0.000334821428571429*G0_1_11_1 + 0.0018080357142857*G0_1_12_0 + 0.0018080357142857*G0_1_12_1 - 0.000200892857142849*G0_1_13_0 - 0.000200892857142852*G0_1_13_1 - 0.00261160714285713*G0_1_14_0 - 0.00261160714285713*G0_1_14_1 + 0.0100446428571428*G0_1_15_0 + 0.0100446428571428*G0_1_15_1 - 0.00683035714285711*G0_1_16_0 - 0.00683035714285711*G0_1_16_1 + 0.0140624999999999*G0_1_17_0 + 0.0140624999999999*G0_1_17_1 + 0.00321428571428571*G0_1_18_0 + 0.0032142857142857*G0_1_18_1 + 0.00964285714285712*G0_1_19_0 + 0.00964285714285712*G0_1_19_1;
    A[161] = 0.00261160714285713*G0_0_0_0 + 0.0133928571428571*G0_0_1_0 + 0.00241071428571427*G0_0_2_0 + 0.0200892857142856*G0_0_3_0 - 0.0100446428571428*G0_0_4_0 - 0.00281249999999998*G0_0_5_0 - 0.00220982142857142*G0_0_6_0 - 0.0140624999999999*G0_0_7_0 + 0.0401785714285712*G0_0_8_0 + 0.0120535714285714*G0_0_9_0 + 0.00261160714285713*G0_1_10_0 + 0.0133928571428571*G0_1_11_0 + 0.00241071428571427*G0_1_12_0 + 0.0200892857142856*G0_1_13_0 - 0.0100446428571428*G0_1_14_0 - 0.00281249999999998*G0_1_15_0 - 0.00220982142857142*G0_1_16_0 - 0.0140624999999999*G0_1_17_0 + 0.0401785714285712*G0_1_18_0 + 0.0120535714285714*G0_1_19_0;
    A[162] = -0.00140624999999999*G0_0_0_1 + 0.00234374999999999*G0_0_1_1 + 0.000200892857142846*G0_0_3_1 - 0.00281249999999998*G0_0_4_1 + 0.00261160714285714*G0_0_5_1 - 0.00220982142857142*G0_0_6_1 - 0.00140624999999998*G0_0_7_1 + 0.0148660714285713*G0_0_8_1 + 0.00120535714285712*G0_0_9_1 - 0.00140624999999999*G0_1_10_1 + 0.00234374999999999*G0_1_11_1 + 0.000200892857142846*G0_1_13_1 - 0.00281249999999998*G0_1_14_1 + 0.00261160714285714*G0_1_15_1 - 0.00220982142857142*G0_1_16_1 - 0.00140624999999998*G0_1_17_1 + 0.0148660714285713*G0_1_18_1 + 0.00120535714285712*G0_1_19_1;
    A[163] = 0.00381696428571427*G0_0_0_0 + 0.00763392857142852*G0_0_0_1 + 0.00200892857142856*G0_0_1_0 + 0.0241071428571427*G0_0_1_1 + 0.00381696428571427*G0_0_2_0 + 0.00743303571428567*G0_0_2_1 + 0.0361607142857141*G0_0_3_0 + 0.0542410714285711*G0_0_3_1 - 0.01265625*G0_0_4_0 - 0.0271205357142856*G0_0_4_1 - 0.0018080357142857*G0_0_5_0 - 0.00180803571428569*G0_0_5_1 - 0.00180803571428571*G0_0_6_0 - 0.00723214285714283*G0_0_6_1 - 0.01265625*G0_0_7_0 - 0.0271205357142856*G0_0_7_1 + 0.0361607142857141*G0_0_8_0 + 0.108482142857142*G0_0_8_1 + 0.043392857142857*G0_0_9_0 + 0.0542410714285712*G0_0_9_1 + 0.00381696428571427*G0_1_10_0 + 0.00763392857142852*G0_1_10_1 + 0.00200892857142856*G0_1_11_0 + 0.0241071428571427*G0_1_11_1 + 0.00381696428571427*G0_1_12_0 + 0.00743303571428567*G0_1_12_1 + 0.0361607142857141*G0_1_13_0 + 0.0542410714285711*G0_1_13_1 - 0.01265625*G0_1_14_0 - 0.0271205357142856*G0_1_14_1 - 0.0018080357142857*G0_1_15_0 - 0.00180803571428569*G0_1_15_1 - 0.00180803571428571*G0_1_16_0 - 0.00723214285714283*G0_1_16_1 - 0.01265625*G0_1_17_0 - 0.0271205357142856*G0_1_17_1 + 0.0361607142857141*G0_1_18_0 + 0.108482142857142*G0_1_18_1 + 0.043392857142857*G0_1_19_0 + 0.0542410714285712*G0_1_19_1;
    A[164] = -0.000401785714285711*G0_0_0_0 - 0.000200892857142846*G0_0_0_1 - 0.00100446428571428*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.00100446428571428*G0_0_2_0 - 0.00220982142857141*G0_0_2_1 - 0.00180803571428572*G0_0_3_0 - 0.0018080357142857*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 + 0.00361607142857141*G0_0_5_0 - 0.00180803571428571*G0_0_5_1 - 0.00723214285714282*G0_0_6_0 - 0.00180803571428571*G0_0_6_1 + 0.00361607142857142*G0_0_7_0 + 0.00542410714285712*G0_0_7_1 - 0.00723214285714284*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.000401785714285711*G0_1_10_0 - 0.000200892857142846*G0_1_10_1 - 0.00100446428571428*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.00100446428571428*G0_1_12_0 - 0.00220982142857141*G0_1_12_1 - 0.00180803571428572*G0_1_13_0 - 0.0018080357142857*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 + 0.00361607142857141*G0_1_15_0 - 0.00180803571428571*G0_1_15_1 - 0.00723214285714282*G0_1_16_0 - 0.00180803571428571*G0_1_16_1 + 0.00361607142857142*G0_1_17_0 + 0.00542410714285712*G0_1_17_1 - 0.00723214285714284*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[165] = 0.00100446428571428*G0_0_0_0 - 0.0110491071428571*G0_0_0_1 + 0.00401785714285714*G0_0_1_0 - 0.00100446428571428*G0_0_1_1 - 0.000200892857142856*G0_0_2_0 - 0.00301339285714284*G0_0_2_1 - 0.00361607142857139*G0_0_3_0 - 0.00542410714285711*G0_0_3_1 + 0.00180803571428569*G0_0_4_0 + 0.00542410714285712*G0_0_4_1 + 0.0235044642857142*G0_0_5_0 - 0.0036160714285714*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 + 0.0126562499999999*G0_0_6_1 + 0.0126562499999999*G0_0_7_0 - 0.0144642857142856*G0_0_7_1 - 0.0144642857142856*G0_0_8_0 - 0.00361607142857141*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.00100446428571428*G0_1_10_0 - 0.0110491071428571*G0_1_10_1 + 0.00401785714285714*G0_1_11_0 - 0.00100446428571428*G0_1_11_1 - 0.000200892857142856*G0_1_12_0 - 0.00301339285714284*G0_1_12_1 - 0.00361607142857139*G0_1_13_0 - 0.00542410714285711*G0_1_13_1 + 0.00180803571428569*G0_1_14_0 + 0.00542410714285712*G0_1_14_1 + 0.0235044642857142*G0_1_15_0 - 0.0036160714285714*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 + 0.0126562499999999*G0_1_16_1 + 0.0126562499999999*G0_1_17_0 - 0.0144642857142856*G0_1_17_1 - 0.0144642857142856*G0_1_18_0 - 0.00361607142857141*G0_1_18_1 + 0.0216964285714285*G0_1_19_0;
    A[166] = 0.000401785714285709*G0_0_0_0 + 0.0064285714285714*G0_0_0_1 + 0.00100446428571428*G0_0_1_0 - 0.00100446428571429*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 + 0.00120535714285713*G0_0_2_1 + 0.0018080357142857*G0_0_3_0 + 0.00542410714285711*G0_0_3_1 + 0.0018080357142857*G0_0_4_0 - 0.00361607142857141*G0_0_5_0 - 0.00904017857142854*G0_0_5_1 + 0.00723214285714282*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 - 0.00361607142857142*G0_0_7_0 + 0.0018080357142857*G0_0_7_1 + 0.00723214285714283*G0_0_8_0 - 0.0144642857142857*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 + 0.000401785714285709*G0_1_10_0 + 0.0064285714285714*G0_1_10_1 + 0.00100446428571428*G0_1_11_0 - 0.00100446428571429*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 + 0.00120535714285713*G0_1_12_1 + 0.0018080357142857*G0_1_13_0 + 0.00542410714285711*G0_1_13_1 + 0.0018080357142857*G0_1_14_0 - 0.00361607142857141*G0_1_15_0 - 0.00904017857142854*G0_1_15_1 + 0.00723214285714282*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 - 0.00361607142857142*G0_1_17_0 + 0.0018080357142857*G0_1_17_1 + 0.00723214285714283*G0_1_18_0 - 0.0144642857142857*G0_1_18_1 + 0.0108482142857142*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[167] = -0.00703124999999996*G0_0_0_0 + 0.00502232142857141*G0_0_0_1 + 0.00703124999999996*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 - 0.00421874999999998*G0_0_2_0 - 0.00140624999999999*G0_0_2_1 - 0.00180803571428571*G0_0_3_0 + 0.00904017857142853*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 - 0.0144642857142856*G0_0_5_0 + 0.0126562499999999*G0_0_5_1 + 0.0126562499999999*G0_0_6_0 + 0.00180803571428571*G0_0_6_1 - 0.0216964285714285*G0_0_7_0 + 0.00542410714285711*G0_0_7_1 - 0.0433928571428569*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 - 0.0325446428571428*G0_0_9_0 - 0.0108482142857143*G0_0_9_1 - 0.00703124999999996*G0_1_10_0 + 0.00502232142857141*G0_1_10_1 + 0.00703124999999996*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 - 0.00421874999999998*G0_1_12_0 - 0.00140624999999999*G0_1_12_1 - 0.00180803571428571*G0_1_13_0 + 0.00904017857142853*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 - 0.0144642857142856*G0_1_15_0 + 0.0126562499999999*G0_1_15_1 + 0.0126562499999999*G0_1_16_0 + 0.00180803571428571*G0_1_16_1 - 0.0216964285714285*G0_1_17_0 + 0.00542410714285711*G0_1_17_1 - 0.0433928571428569*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 - 0.0325446428571428*G0_1_19_0 - 0.0108482142857143*G0_1_19_1;
    A[168] = -0.00160714285714285*G0_0_0_0 - 0.00763392857142852*G0_0_0_1 - 0.0200892857142856*G0_0_1_0 - 0.0241071428571427*G0_0_1_1 - 0.00743303571428567*G0_0_2_1 - 0.018080357142857*G0_0_3_0 - 0.0542410714285711*G0_0_3_1 + 0.00361607142857141*G0_0_4_0 + 0.0271205357142856*G0_0_4_1 + 0.00723214285714282*G0_0_5_0 + 0.00180803571428569*G0_0_5_1 - 0.00361607142857141*G0_0_6_0 + 0.00723214285714283*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.0271205357142856*G0_0_7_1 - 0.108482142857142*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 - 0.0542410714285712*G0_0_9_1 - 0.00160714285714285*G0_1_10_0 - 0.00763392857142852*G0_1_10_1 - 0.0200892857142856*G0_1_11_0 - 0.0241071428571427*G0_1_11_1 - 0.00743303571428567*G0_1_12_1 - 0.018080357142857*G0_1_13_0 - 0.0542410714285711*G0_1_13_1 + 0.00361607142857141*G0_1_14_0 + 0.0271205357142856*G0_1_14_1 + 0.00723214285714282*G0_1_15_0 + 0.00180803571428569*G0_1_15_1 - 0.00361607142857141*G0_1_16_0 + 0.00723214285714283*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.0271205357142856*G0_1_17_1 - 0.108482142857142*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 - 0.0542410714285712*G0_1_19_1;
    A[169] = -0.00482142857142854*G0_0_0_0 - 0.00482142857142856*G0_0_0_1 - 0.0060267857142857*G0_0_1_0 - 0.00361607142857141*G0_0_2_0 + 0.00361607142857141*G0_0_2_1 - 0.0325446428571427*G0_0_3_0 + 0.0108482142857143*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857142*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 + 0.108482142857142*G0_0_8_1 - 0.0650892857142855*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00482142857142854*G0_1_10_0 - 0.00482142857142856*G0_1_10_1 - 0.0060267857142857*G0_1_11_0 - 0.00361607142857141*G0_1_12_0 + 0.00361607142857141*G0_1_12_1 - 0.0325446428571427*G0_1_13_0 + 0.0108482142857143*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857142*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 + 0.108482142857142*G0_1_18_1 - 0.0650892857142855*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[170] = 0;
    A[171] = 0;
    A[172] = 0;
    A[173] = 0;
    A[174] = 0;
    A[175] = 0;
    A[176] = 0;
    A[177] = 0;
    A[178] = 0;
    A[179] = 0;
    A[180] = -0.00267857142857142*G0_0_0_0 - 0.00267857142857142*G0_0_0_1 - 0.00147321428571428*G0_0_1_0 - 0.00147321428571428*G0_0_1_1 - 0.00147321428571428*G0_0_2_0 - 0.00147321428571428*G0_0_2_1 - 0.00120535714285714*G0_0_3_0 - 0.00120535714285714*G0_0_3_1 - 0.00120535714285714*G0_0_4_0 - 0.00120535714285714*G0_0_4_1 - 0.0120535714285714*G0_0_5_0 - 0.0120535714285714*G0_0_5_1 + 0.00964285714285711*G0_0_6_0 + 0.00964285714285712*G0_0_6_1 - 0.0120535714285714*G0_0_7_0 - 0.0120535714285714*G0_0_7_1 + 0.00964285714285712*G0_0_8_0 + 0.00964285714285712*G0_0_8_1 + 0.0289285714285714*G0_0_9_0 + 0.0289285714285714*G0_0_9_1 - 0.00267857142857142*G0_1_10_0 - 0.00267857142857142*G0_1_10_1 - 0.00147321428571428*G0_1_11_0 - 0.00147321428571428*G0_1_11_1 - 0.00147321428571428*G0_1_12_0 - 0.00147321428571428*G0_1_12_1 - 0.00120535714285714*G0_1_13_0 - 0.00120535714285714*G0_1_13_1 - 0.00120535714285714*G0_1_14_0 - 0.00120535714285714*G0_1_14_1 - 0.0120535714285714*G0_1_15_0 - 0.0120535714285714*G0_1_15_1 + 0.00964285714285711*G0_1_16_0 + 0.00964285714285712*G0_1_16_1 - 0.0120535714285714*G0_1_17_0 - 0.0120535714285714*G0_1_17_1 + 0.00964285714285712*G0_1_18_0 + 0.00964285714285712*G0_1_18_1 + 0.0289285714285714*G0_1_19_0 + 0.0289285714285714*G0_1_19_1;
    A[181] = 0.00147321428571428*G0_0_0_0 + 0.00267857142857142*G0_0_1_0 + 0.00147321428571428*G0_0_2_0 + 0.0120535714285714*G0_0_3_0 - 0.00964285714285712*G0_0_4_0 + 0.00120535714285716*G0_0_5_0 + 0.00120535714285713*G0_0_6_0 - 0.00964285714285709*G0_0_7_0 + 0.0120535714285714*G0_0_8_0 - 0.0289285714285713*G0_0_9_0 + 0.00147321428571428*G0_1_10_0 + 0.00267857142857142*G0_1_11_0 + 0.00147321428571428*G0_1_12_0 + 0.0120535714285714*G0_1_13_0 - 0.00964285714285712*G0_1_14_0 + 0.00120535714285716*G0_1_15_0 + 0.00120535714285713*G0_1_16_0 - 0.00964285714285709*G0_1_17_0 + 0.0120535714285714*G0_1_18_0 - 0.0289285714285713*G0_1_19_0;
    A[182] = 0.00147321428571428*G0_0_0_1 + 0.00147321428571428*G0_0_1_1 + 0.00267857142857141*G0_0_2_1 - 0.00964285714285711*G0_0_3_1 + 0.0120535714285714*G0_0_4_1 - 0.0096428571428571*G0_0_5_1 + 0.0120535714285714*G0_0_6_1 + 0.00120535714285713*G0_0_7_1 + 0.00120535714285712*G0_0_8_1 - 0.0289285714285713*G0_0_9_1 + 0.00147321428571428*G0_1_10_1 + 0.00147321428571428*G0_1_11_1 + 0.00267857142857141*G0_1_12_1 - 0.00964285714285711*G0_1_13_1 + 0.0120535714285714*G0_1_14_1 - 0.0096428571428571*G0_1_15_1 + 0.0120535714285714*G0_1_16_1 + 0.00120535714285713*G0_1_17_1 + 0.00120535714285712*G0_1_18_1 - 0.0289285714285713*G0_1_19_1;
    A[183] = 0.00843749999999997*G0_0_0_0 + 0.00482142857142855*G0_0_0_1 - 0.00602678571428571*G0_0_1_0 + 0.00482142857142856*G0_0_2_1 + 0.0650892857142855*G0_0_3_0 + 0.0542410714285712*G0_0_3_1 + 0.0108482142857142*G0_0_4_0 - 0.0216964285714285*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857143*G0_0_6_0 - 0.0108482142857143*G0_0_6_1 - 0.0216964285714285*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 + 0.043392857142857*G0_0_8_0 + 0.0542410714285712*G0_0_8_1 + 0.173571428571428*G0_0_9_0 + 0.043392857142857*G0_0_9_1 + 0.00843749999999997*G0_1_10_0 + 0.00482142857142855*G0_1_10_1 - 0.00602678571428571*G0_1_11_0 + 0.00482142857142856*G0_1_12_1 + 0.0650892857142855*G0_1_13_0 + 0.0542410714285712*G0_1_13_1 + 0.0108482142857142*G0_1_14_0 - 0.0216964285714285*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857143*G0_1_16_0 - 0.0108482142857143*G0_1_16_1 - 0.0216964285714285*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 + 0.043392857142857*G0_1_18_0 + 0.0542410714285712*G0_1_18_1 + 0.173571428571428*G0_1_19_0 + 0.043392857142857*G0_1_19_1;
    A[184] = 0.00482142857142855*G0_0_0_0 + 0.00843749999999997*G0_0_0_1 + 0.00482142857142856*G0_0_1_0 - 0.0060267857142857*G0_0_2_1 - 0.0216964285714285*G0_0_3_0 + 0.0108482142857142*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0650892857142855*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0216964285714285*G0_0_5_1 + 0.0542410714285712*G0_0_6_0 + 0.043392857142857*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 - 0.0108482142857143*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 + 0.0433928571428569*G0_0_9_0 + 0.173571428571428*G0_0_9_1 + 0.00482142857142855*G0_1_10_0 + 0.00843749999999997*G0_1_10_1 + 0.00482142857142856*G0_1_11_0 - 0.0060267857142857*G0_1_12_1 - 0.0216964285714285*G0_1_13_0 + 0.0108482142857142*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0650892857142855*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0216964285714285*G0_1_15_1 + 0.0542410714285712*G0_1_16_0 + 0.043392857142857*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 - 0.0108482142857143*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 + 0.0433928571428569*G0_1_19_0 + 0.173571428571428*G0_1_19_1;
    A[185] = 0.00602678571428572*G0_0_0_0 + 0.00602678571428571*G0_0_0_1 - 0.00843749999999997*G0_0_1_0 - 0.00361607142857142*G0_0_1_1 + 0.00482142857142855*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 + 0.0108482142857142*G0_0_4_0 - 0.0650892857142855*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857143*G0_0_6_0 - 0.0325446428571427*G0_0_6_1 - 0.043392857142857*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 + 0.0216964285714285*G0_0_8_0 - 0.173571428571428*G0_0_9_0 - 0.130178571428571*G0_0_9_1 + 0.00602678571428572*G0_1_10_0 + 0.00602678571428571*G0_1_10_1 - 0.00843749999999997*G0_1_11_0 - 0.00361607142857142*G0_1_11_1 + 0.00482142857142855*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 + 0.0108482142857142*G0_1_14_0 - 0.0650892857142855*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857143*G0_1_16_0 - 0.0325446428571427*G0_1_16_1 - 0.043392857142857*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 + 0.0216964285714285*G0_1_18_0 - 0.173571428571428*G0_1_19_0 - 0.130178571428571*G0_1_19_1;
    A[186] = -0.00482142857142856*G0_0_0_0 - 0.00482142857142857*G0_0_0_1 - 0.00482142857142856*G0_0_1_0 + 0.00361607142857142*G0_0_1_1 - 0.00602678571428569*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 - 0.0542410714285712*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 + 0.0216964285714285*G0_0_5_0 + 0.0325446428571428*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0108482142857143*G0_0_7_0 + 0.0108482142857142*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 - 0.043392857142857*G0_0_9_0 + 0.130178571428571*G0_0_9_1 - 0.00482142857142856*G0_1_10_0 - 0.00482142857142857*G0_1_10_1 - 0.00482142857142856*G0_1_11_0 + 0.00361607142857142*G0_1_11_1 - 0.00602678571428569*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 - 0.0542410714285712*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 + 0.0216964285714285*G0_1_15_0 + 0.0325446428571428*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0108482142857143*G0_1_17_0 + 0.0108482142857142*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 - 0.043392857142857*G0_1_19_0 + 0.130178571428571*G0_1_19_1;
    A[187] = 0.00602678571428571*G0_0_0_0 + 0.00602678571428572*G0_0_0_1 + 0.00482142857142857*G0_0_1_0 - 0.00361607142857141*G0_0_2_0 - 0.00843749999999996*G0_0_2_1 + 0.0108482142857143*G0_0_3_1 + 0.0108482142857143*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 - 0.043392857142857*G0_0_5_1 + 0.0216964285714285*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0650892857142854*G0_0_7_1 - 0.0325446428571427*G0_0_8_0 - 0.0108482142857143*G0_0_8_1 - 0.130178571428571*G0_0_9_0 - 0.173571428571428*G0_0_9_1 + 0.00602678571428571*G0_1_10_0 + 0.00602678571428572*G0_1_10_1 + 0.00482142857142857*G0_1_11_0 - 0.00361607142857141*G0_1_12_0 - 0.00843749999999996*G0_1_12_1 + 0.0108482142857143*G0_1_13_1 + 0.0108482142857143*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 - 0.043392857142857*G0_1_15_1 + 0.0216964285714285*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0650892857142854*G0_1_17_1 - 0.0325446428571427*G0_1_18_0 - 0.0108482142857143*G0_1_18_1 - 0.130178571428571*G0_1_19_0 - 0.173571428571428*G0_1_19_1;
    A[188] = -0.00482142857142857*G0_0_0_0 - 0.00482142857142856*G0_0_0_1 - 0.0060267857142857*G0_0_1_0 + 0.00361607142857141*G0_0_2_0 - 0.00482142857142856*G0_0_2_1 - 0.0108482142857143*G0_0_3_0 - 0.0542410714285713*G0_0_3_1 + 0.0216964285714285*G0_0_4_1 + 0.0108482142857142*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0325446428571427*G0_0_7_0 + 0.0216964285714285*G0_0_7_1 + 0.0108482142857143*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 + 0.130178571428571*G0_0_9_0 - 0.0433928571428571*G0_0_9_1 - 0.00482142857142857*G0_1_10_0 - 0.00482142857142856*G0_1_10_1 - 0.0060267857142857*G0_1_11_0 + 0.00361607142857141*G0_1_12_0 - 0.00482142857142856*G0_1_12_1 - 0.0108482142857143*G0_1_13_0 - 0.0542410714285713*G0_1_13_1 + 0.0216964285714285*G0_1_14_1 + 0.0108482142857142*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0325446428571427*G0_1_17_0 + 0.0216964285714285*G0_1_17_1 + 0.0108482142857143*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 + 0.130178571428571*G0_1_19_0 - 0.0433928571428571*G0_1_19_1;
    A[189] = -0.0144642857142857*G0_0_0_0 - 0.0144642857142857*G0_0_0_1 + 0.0144642857142857*G0_0_1_0 + 0.0144642857142857*G0_0_2_1 - 0.086785714285714*G0_0_3_0 - 0.0216964285714285*G0_0_3_1 - 0.0216964285714285*G0_0_4_0 - 0.086785714285714*G0_0_4_1 + 0.086785714285714*G0_0_5_0 + 0.0650892857142855*G0_0_5_1 + 0.0216964285714285*G0_0_6_0 - 0.0650892857142855*G0_0_6_1 + 0.0650892857142855*G0_0_7_0 + 0.0867857142857139*G0_0_7_1 - 0.0650892857142855*G0_0_8_0 + 0.0216964285714285*G0_0_8_1 - 0.0144642857142857*G0_1_10_0 - 0.0144642857142857*G0_1_10_1 + 0.0144642857142857*G0_1_11_0 + 0.0144642857142857*G0_1_12_1 - 0.086785714285714*G0_1_13_0 - 0.0216964285714285*G0_1_13_1 - 0.0216964285714285*G0_1_14_0 - 0.086785714285714*G0_1_14_1 + 0.086785714285714*G0_1_15_0 + 0.0650892857142855*G0_1_15_1 + 0.0216964285714285*G0_1_16_0 - 0.0650892857142855*G0_1_16_1 + 0.0650892857142855*G0_1_17_0 + 0.0867857142857139*G0_1_17_1 - 0.0650892857142855*G0_1_18_0 + 0.0216964285714285*G0_1_18_1;
    A[190] = 0;
    A[191] = 0;
    A[192] = 0;
    A[193] = 0;
    A[194] = 0;
    A[195] = 0;
    A[196] = 0;
    A[197] = 0;
    A[198] = 0;
    A[199] = 0;
    A[200] = 0;
    A[201] = 0;
    A[202] = 0;
    A[203] = 0;
    A[204] = 0;
    A[205] = 0;
    A[206] = 0;
    A[207] = 0;
    A[208] = 0;
    A[209] = 0;
    A[210] = -0.0177083333333332*G0_0_0_0 - 0.0177083333333332*G0_0_0_1 - 0.00148809523809523*G0_0_1_0 - 0.00148809523809523*G0_0_1_1 - 0.00148809523809523*G0_0_2_0 - 0.00148809523809523*G0_0_2_1 - 0.0133928571428571*G0_0_5_0 - 0.0133928571428571*G0_0_5_1 + 0.00602678571428568*G0_0_6_0 + 0.00602678571428568*G0_0_6_1 - 0.0133928571428571*G0_0_7_0 - 0.0133928571428571*G0_0_7_1 + 0.00602678571428568*G0_0_8_0 + 0.00602678571428568*G0_0_8_1 - 0.00267857142857142*G0_0_9_0 - 0.00267857142857142*G0_0_9_1 - 0.0177083333333332*G0_1_10_0 - 0.0177083333333332*G0_1_10_1 - 0.00148809523809523*G0_1_11_0 - 0.00148809523809523*G0_1_11_1 - 0.00148809523809523*G0_1_12_0 - 0.00148809523809523*G0_1_12_1 - 0.0133928571428571*G0_1_15_0 - 0.0133928571428571*G0_1_15_1 + 0.00602678571428568*G0_1_16_0 + 0.00602678571428568*G0_1_16_1 - 0.0133928571428571*G0_1_17_0 - 0.0133928571428571*G0_1_17_1 + 0.00602678571428568*G0_1_18_0 + 0.00602678571428568*G0_1_18_1 - 0.00267857142857142*G0_1_19_0 - 0.00267857142857142*G0_1_19_1;
    A[211] = 0.00297619047619046*G0_0_0_0 + 0.00148809523809523*G0_0_1_0 + 0.000885416666666662*G0_0_2_0 + 0.00241071428571427*G0_0_3_0 - 0.00180803571428571*G0_0_4_0 + 0.00234374999999999*G0_0_5_0 - 0.00140624999999999*G0_0_6_0 + 0.000334821428571429*G0_0_7_0 + 0.00261160714285713*G0_0_8_0 + 0.00147321428571428*G0_0_9_0 + 0.00297619047619046*G0_1_10_0 + 0.00148809523809523*G0_1_11_0 + 0.000885416666666662*G0_1_12_0 + 0.00241071428571427*G0_1_13_0 - 0.00180803571428571*G0_1_14_0 + 0.00234374999999999*G0_1_15_0 - 0.00140624999999999*G0_1_16_0 + 0.000334821428571429*G0_1_17_0 + 0.00261160714285713*G0_1_18_0 + 0.00147321428571428*G0_1_19_0;
    A[212] = 0.00297619047619045*G0_0_0_1 + 0.000885416666666662*G0_0_1_1 + 0.00148809523809523*G0_0_2_1 - 0.00180803571428571*G0_0_3_1 + 0.00241071428571428*G0_0_4_1 + 0.000334821428571421*G0_0_5_1 + 0.00261160714285714*G0_0_6_1 + 0.00234374999999998*G0_0_7_1 - 0.00140624999999999*G0_0_8_1 + 0.00147321428571428*G0_0_9_1 + 0.00297619047619045*G0_1_10_1 + 0.000885416666666662*G0_1_11_1 + 0.00148809523809523*G0_1_12_1 - 0.00180803571428571*G0_1_13_1 + 0.00241071428571428*G0_1_14_1 + 0.000334821428571421*G0_1_15_1 + 0.00261160714285714*G0_1_16_1 + 0.00234374999999998*G0_1_17_1 - 0.00140624999999999*G0_1_18_1 + 0.00147321428571428*G0_1_19_1;
    A[213] = -6.69642857142867e-05*G0_0_1_0 + 0.00234374999999998*G0_0_1_1 - 0.00140624999999999*G0_0_2_0 + 0.000401785714285712*G0_0_2_1 + 0.00743303571428568*G0_0_3_0 + 0.00743303571428567*G0_0_3_1 + 0.00140625*G0_0_4_0 - 0.00281249999999999*G0_0_4_1 - 0.00200892857142856*G0_0_5_0 - 0.00100446428571428*G0_0_5_1 - 0.000200892857142856*G0_0_6_0 - 0.000401785714285713*G0_0_6_1 - 0.00401785714285713*G0_0_7_0 - 0.0050223214285714*G0_0_7_1 + 0.00381696428571427*G0_0_8_0 + 0.00763392857142852*G0_0_8_1 + 0.00843749999999997*G0_0_9_0 + 0.00482142857142855*G0_0_9_1 - 6.69642857142867e-05*G0_1_11_0 + 0.00234374999999998*G0_1_11_1 - 0.00140624999999999*G0_1_12_0 + 0.000401785714285712*G0_1_12_1 + 0.00743303571428568*G0_1_13_0 + 0.00743303571428567*G0_1_13_1 + 0.00140625*G0_1_14_0 - 0.00281249999999999*G0_1_14_1 - 0.00200892857142856*G0_1_15_0 - 0.00100446428571428*G0_1_15_1 - 0.000200892857142856*G0_1_16_0 - 0.000401785714285713*G0_1_16_1 - 0.00401785714285713*G0_1_17_0 - 0.0050223214285714*G0_1_17_1 + 0.00381696428571427*G0_1_18_0 + 0.00763392857142852*G0_1_18_1 + 0.00843749999999997*G0_1_19_0 + 0.00482142857142855*G0_1_19_1;
    A[214] = 0.000401785714285714*G0_0_1_0 - 0.00140624999999999*G0_0_1_1 + 0.00234374999999999*G0_0_2_0 - 6.69642857142862e-05*G0_0_2_1 - 0.00281249999999999*G0_0_3_0 + 0.00140624999999999*G0_0_3_1 + 0.00743303571428569*G0_0_4_0 + 0.0074330357142857*G0_0_4_1 - 0.00502232142857141*G0_0_5_0 - 0.00401785714285713*G0_0_5_1 + 0.00763392857142854*G0_0_6_0 + 0.00381696428571428*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 - 0.00200892857142857*G0_0_7_1 - 0.000401785714285711*G0_0_8_0 - 0.000200892857142848*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.00843749999999997*G0_0_9_1 + 0.000401785714285714*G0_1_11_0 - 0.00140624999999999*G0_1_11_1 + 0.00234374999999999*G0_1_12_0 - 6.69642857142862e-05*G0_1_12_1 - 0.00281249999999999*G0_1_13_0 + 0.00140624999999999*G0_1_13_1 + 0.00743303571428569*G0_1_14_0 + 0.0074330357142857*G0_1_14_1 - 0.00502232142857141*G0_1_15_0 - 0.00401785714285713*G0_1_15_1 + 0.00763392857142854*G0_1_16_0 + 0.00381696428571428*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 - 0.00200892857142857*G0_1_17_1 - 0.000401785714285711*G0_1_18_0 - 0.000200892857142848*G0_1_18_1 + 0.00482142857142856*G0_1_19_0 + 0.00843749999999997*G0_1_19_1;
    A[215] = -0.00535714285714282*G0_0_0_0 + 0.0267857142857141*G0_0_0_1 + 6.69642857142895e-05*G0_0_1_0 + 0.00241071428571427*G0_0_1_1 - 6.69642857142837e-05*G0_0_2_0 + 0.0022767857142857*G0_0_2_1 - 0.000200892857142856*G0_0_3_0 - 0.00120535714285714*G0_0_3_1 + 0.00220982142857142*G0_0_4_0 + 0.00120535714285714*G0_0_4_1 - 0.00401785714285709*G0_0_5_0 + 0.0200892857142856*G0_0_5_1 + 0.0050223214285714*G0_0_6_0 - 0.00703124999999995*G0_0_6_1 - 0.00200892857142855*G0_0_7_0 + 0.0220982142857142*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 - 0.0110491071428571*G0_0_8_1 + 0.00602678571428572*G0_0_9_0 + 0.00602678571428571*G0_0_9_1 - 0.00535714285714282*G0_1_10_0 + 0.0267857142857141*G0_1_10_1 + 6.69642857142895e-05*G0_1_11_0 + 0.00241071428571427*G0_1_11_1 - 6.69642857142837e-05*G0_1_12_0 + 0.0022767857142857*G0_1_12_1 - 0.000200892857142856*G0_1_13_0 - 0.00120535714285714*G0_1_13_1 + 0.00220982142857142*G0_1_14_0 + 0.00120535714285714*G0_1_14_1 - 0.00401785714285709*G0_1_15_0 + 0.0200892857142856*G0_1_15_1 + 0.0050223214285714*G0_1_16_0 - 0.00703124999999995*G0_1_16_1 - 0.00200892857142855*G0_1_17_0 + 0.0220982142857142*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 - 0.0110491071428571*G0_1_18_1 + 0.00602678571428572*G0_1_19_0 + 0.00602678571428571*G0_1_19_1;
    A[216] = -0.0120535714285714*G0_0_0_1 - 0.000401785714285714*G0_0_1_0 - 0.00180803571428571*G0_0_1_1 - 0.00234374999999999*G0_0_2_0 - 0.0022767857142857*G0_0_2_1 + 0.00281249999999999*G0_0_3_0 + 0.00301339285714284*G0_0_3_1 - 0.00743303571428569*G0_0_4_0 - 0.00361607142857141*G0_0_4_1 + 0.00502232142857141*G0_0_5_0 - 0.00703124999999997*G0_0_5_1 - 0.00763392857142855*G0_0_6_0 - 0.00160714285714286*G0_0_6_1 + 0.00100446428571429*G0_0_7_0 - 0.0110491071428571*G0_0_7_1 + 0.000401785714285709*G0_0_8_0 + 0.0064285714285714*G0_0_8_1 - 0.00482142857142856*G0_0_9_0 - 0.00482142857142857*G0_0_9_1 - 0.0120535714285714*G0_1_10_1 - 0.000401785714285714*G0_1_11_0 - 0.00180803571428571*G0_1_11_1 - 0.00234374999999999*G0_1_12_0 - 0.0022767857142857*G0_1_12_1 + 0.00281249999999999*G0_1_13_0 + 0.00301339285714284*G0_1_13_1 - 0.00743303571428569*G0_1_14_0 - 0.00361607142857141*G0_1_14_1 + 0.00502232142857141*G0_1_15_0 - 0.00703124999999997*G0_1_15_1 - 0.00763392857142855*G0_1_16_0 - 0.00160714285714286*G0_1_16_1 + 0.00100446428571429*G0_1_17_0 - 0.0110491071428571*G0_1_17_1 + 0.000401785714285709*G0_1_18_0 + 0.0064285714285714*G0_1_18_1 - 0.00482142857142856*G0_1_19_0 - 0.00482142857142857*G0_1_19_1;
    A[217] = 0.0267857142857141*G0_0_0_0 - 0.00535714285714283*G0_0_0_1 + 0.0022767857142857*G0_0_1_0 - 6.69642857142869e-05*G0_0_1_1 + 0.00241071428571427*G0_0_2_0 + 6.69642857142869e-05*G0_0_2_1 + 0.00120535714285714*G0_0_3_0 + 0.00220982142857142*G0_0_3_1 - 0.00120535714285714*G0_0_4_0 - 0.000200892857142856*G0_0_4_1 + 0.0220982142857142*G0_0_5_0 - 0.00200892857142855*G0_0_5_1 - 0.0110491071428571*G0_0_6_0 + 0.00100446428571427*G0_0_6_1 + 0.0200892857142856*G0_0_7_0 - 0.00401785714285711*G0_0_7_1 - 0.00703124999999996*G0_0_8_0 + 0.0050223214285714*G0_0_8_1 + 0.00602678571428571*G0_0_9_0 + 0.00602678571428571*G0_0_9_1 + 0.0267857142857141*G0_1_10_0 - 0.00535714285714283*G0_1_10_1 + 0.0022767857142857*G0_1_11_0 - 6.69642857142869e-05*G0_1_11_1 + 0.00241071428571427*G0_1_12_0 + 6.69642857142869e-05*G0_1_12_1 + 0.00120535714285714*G0_1_13_0 + 0.00220982142857142*G0_1_13_1 - 0.00120535714285714*G0_1_14_0 - 0.000200892857142856*G0_1_14_1 + 0.0220982142857142*G0_1_15_0 - 0.00200892857142855*G0_1_15_1 - 0.0110491071428571*G0_1_16_0 + 0.00100446428571427*G0_1_16_1 + 0.0200892857142856*G0_1_17_0 - 0.00401785714285711*G0_1_17_1 - 0.00703124999999996*G0_1_18_0 + 0.0050223214285714*G0_1_18_1 + 0.00602678571428571*G0_1_19_0 + 0.00602678571428571*G0_1_19_1;
    A[218] = -0.0120535714285714*G0_0_0_0 - 0.00227678571428569*G0_0_1_0 - 0.00234374999999998*G0_0_1_1 - 0.0018080357142857*G0_0_2_0 - 0.000401785714285712*G0_0_2_1 - 0.00361607142857141*G0_0_3_0 - 0.00743303571428567*G0_0_3_1 + 0.00301339285714284*G0_0_4_0 + 0.00281249999999998*G0_0_4_1 - 0.0110491071428571*G0_0_5_0 + 0.00100446428571428*G0_0_5_1 + 0.0064285714285714*G0_0_6_0 + 0.000401785714285714*G0_0_6_1 - 0.00703124999999997*G0_0_7_0 + 0.0050223214285714*G0_0_7_1 - 0.00160714285714285*G0_0_8_0 - 0.00763392857142852*G0_0_8_1 - 0.00482142857142857*G0_0_9_0 - 0.00482142857142855*G0_0_9_1 - 0.0120535714285714*G0_1_10_0 - 0.00227678571428569*G0_1_11_0 - 0.00234374999999998*G0_1_11_1 - 0.0018080357142857*G0_1_12_0 - 0.000401785714285712*G0_1_12_1 - 0.00361607142857141*G0_1_13_0 - 0.00743303571428567*G0_1_13_1 + 0.00301339285714284*G0_1_14_0 + 0.00281249999999998*G0_1_14_1 - 0.0110491071428571*G0_1_15_0 + 0.00100446428571428*G0_1_15_1 + 0.0064285714285714*G0_1_16_0 + 0.000401785714285714*G0_1_16_1 - 0.00703124999999997*G0_1_17_0 + 0.0050223214285714*G0_1_17_1 - 0.00160714285714285*G0_1_18_0 - 0.00763392857142852*G0_1_18_1 - 0.00482142857142857*G0_1_19_0 - 0.00482142857142855*G0_1_19_1;
    A[219] = 0.00535714285714282*G0_0_0_0 + 0.00535714285714285*G0_0_0_1 + 0.00147321428571428*G0_0_1_1 + 0.00147321428571428*G0_0_2_0 - 0.00723214285714282*G0_0_3_0 - 0.00361607142857141*G0_0_3_1 - 0.00361607142857142*G0_0_4_0 - 0.00723214285714284*G0_0_4_1 + 0.00602678571428565*G0_0_5_0 + 0.00602678571428569*G0_0_5_1 - 0.00482142857142855*G0_0_6_0 - 0.00482142857142855*G0_0_6_1 + 0.00602678571428567*G0_0_7_0 + 0.00602678571428568*G0_0_7_1 - 0.00482142857142854*G0_0_8_0 - 0.00482142857142856*G0_0_8_1 - 0.0144642857142857*G0_0_9_0 - 0.0144642857142857*G0_0_9_1 + 0.00535714285714282*G0_1_10_0 + 0.00535714285714285*G0_1_10_1 + 0.00147321428571428*G0_1_11_1 + 0.00147321428571428*G0_1_12_0 - 0.00723214285714282*G0_1_13_0 - 0.00361607142857141*G0_1_13_1 - 0.00361607142857142*G0_1_14_0 - 0.00723214285714284*G0_1_14_1 + 0.00602678571428565*G0_1_15_0 + 0.00602678571428569*G0_1_15_1 - 0.00482142857142855*G0_1_16_0 - 0.00482142857142855*G0_1_16_1 + 0.00602678571428567*G0_1_17_0 + 0.00602678571428568*G0_1_17_1 - 0.00482142857142854*G0_1_18_0 - 0.00482142857142856*G0_1_18_1 - 0.0144642857142857*G0_1_19_0 - 0.0144642857142857*G0_1_19_1;
    A[220] = 0;
    A[221] = 0;
    A[222] = 0;
    A[223] = 0;
    A[224] = 0;
    A[225] = 0;
    A[226] = 0;
    A[227] = 0;
    A[228] = 0;
    A[229] = 0;
    A[230] = -0.00148809523809523*G0_0_0_0 - 0.00148809523809523*G0_0_0_1 - 0.00297619047619045*G0_0_1_0 - 0.00297619047619046*G0_0_1_1 - 0.000885416666666662*G0_0_2_0 - 0.000885416666666662*G0_0_2_1 - 0.00234374999999998*G0_0_3_0 - 0.00234374999999999*G0_0_3_1 + 0.00140624999999999*G0_0_4_0 + 0.00140624999999999*G0_0_4_1 - 0.00241071428571427*G0_0_5_0 - 0.00241071428571427*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 + 0.00180803571428571*G0_0_6_1 - 0.00261160714285713*G0_0_7_0 - 0.00261160714285713*G0_0_7_1 - 0.000334821428571427*G0_0_8_0 - 0.000334821428571429*G0_0_8_1 - 0.00147321428571428*G0_0_9_0 - 0.00147321428571428*G0_0_9_1 - 0.00148809523809523*G0_1_10_0 - 0.00148809523809523*G0_1_10_1 - 0.00297619047619045*G0_1_11_0 - 0.00297619047619046*G0_1_11_1 - 0.000885416666666662*G0_1_12_0 - 0.000885416666666662*G0_1_12_1 - 0.00234374999999998*G0_1_13_0 - 0.00234374999999999*G0_1_13_1 + 0.00140624999999999*G0_1_14_0 + 0.00140624999999999*G0_1_14_1 - 0.00241071428571427*G0_1_15_0 - 0.00241071428571427*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 + 0.00180803571428571*G0_1_16_1 - 0.00261160714285713*G0_1_17_0 - 0.00261160714285713*G0_1_17_1 - 0.000334821428571427*G0_1_18_0 - 0.000334821428571429*G0_1_18_1 - 0.00147321428571428*G0_1_19_0 - 0.00147321428571428*G0_1_19_1;
    A[231] = 0.00148809523809523*G0_0_0_0 + 0.0177083333333332*G0_0_1_0 + 0.00148809523809523*G0_0_2_0 + 0.0133928571428571*G0_0_3_0 - 0.00602678571428568*G0_0_4_0 - 0.00602678571428568*G0_0_7_0 + 0.0133928571428571*G0_0_8_0 + 0.00267857142857142*G0_0_9_0 + 0.00148809523809523*G0_1_10_0 + 0.0177083333333332*G0_1_11_0 + 0.00148809523809523*G0_1_12_0 + 0.0133928571428571*G0_1_13_0 - 0.00602678571428568*G0_1_14_0 - 0.00602678571428568*G0_1_17_0 + 0.0133928571428571*G0_1_18_0 + 0.00267857142857142*G0_1_19_0;
    A[232] = 0.000885416666666662*G0_0_0_1 + 0.00297619047619046*G0_0_1_1 + 0.00148809523809523*G0_0_2_1 + 0.000334821428571422*G0_0_3_1 + 0.00261160714285714*G0_0_4_1 - 0.00180803571428571*G0_0_5_1 + 0.00241071428571428*G0_0_6_1 - 0.00140625*G0_0_7_1 + 0.00234374999999999*G0_0_8_1 + 0.00147321428571428*G0_0_9_1 + 0.000885416666666662*G0_1_10_1 + 0.00297619047619046*G0_1_11_1 + 0.00148809523809523*G0_1_12_1 + 0.000334821428571422*G0_1_13_1 + 0.00261160714285714*G0_1_14_1 - 0.00180803571428571*G0_1_15_1 + 0.00241071428571428*G0_1_16_1 - 0.00140625*G0_1_17_1 + 0.00234374999999999*G0_1_18_1 + 0.00147321428571428*G0_1_19_1;
    A[233] = -6.69642857142868e-05*G0_0_0_0 + 0.00234374999999998*G0_0_0_1 + 0.00535714285714285*G0_0_1_0 + 0.032142857142857*G0_0_1_1 + 6.69642857142847e-05*G0_0_2_0 + 0.00234374999999998*G0_0_2_1 + 0.00401785714285712*G0_0_3_0 + 0.0241071428571427*G0_0_3_1 - 0.0050223214285714*G0_0_4_0 - 0.0120535714285714*G0_0_4_1 + 0.000200892857142859*G0_0_5_0 - 0.00100446428571427*G0_0_5_1 - 0.00220982142857142*G0_0_6_0 - 0.00100446428571428*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 - 0.0120535714285714*G0_0_7_1 + 0.00200892857142856*G0_0_8_0 + 0.0241071428571427*G0_0_8_1 - 0.00602678571428571*G0_0_9_0 - 6.69642857142868e-05*G0_1_10_0 + 0.00234374999999998*G0_1_10_1 + 0.00535714285714285*G0_1_11_0 + 0.032142857142857*G0_1_11_1 + 6.69642857142847e-05*G0_1_12_0 + 0.00234374999999998*G0_1_12_1 + 0.00401785714285712*G0_1_13_0 + 0.0241071428571427*G0_1_13_1 - 0.0050223214285714*G0_1_14_0 - 0.0120535714285714*G0_1_14_1 + 0.000200892857142859*G0_1_15_0 - 0.00100446428571427*G0_1_15_1 - 0.00220982142857142*G0_1_16_0 - 0.00100446428571428*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 - 0.0120535714285714*G0_1_17_1 + 0.00200892857142856*G0_1_18_0 + 0.0241071428571427*G0_1_18_1 - 0.00602678571428571*G0_1_19_0;
    A[234] = 0.000401785714285714*G0_0_0_0 - 0.00140624999999999*G0_0_0_1 - 0.0120535714285714*G0_0_1_1 + 0.00234374999999999*G0_0_2_0 + 6.69642857142881e-05*G0_0_2_1 - 0.00502232142857141*G0_0_3_0 - 0.0120535714285714*G0_0_3_1 + 0.00763392857142855*G0_0_4_0 + 0.0060267857142857*G0_0_4_1 - 0.00281249999999999*G0_0_5_0 + 0.000200892857142853*G0_0_5_1 + 0.0074330357142857*G0_0_6_0 + 0.00381696428571428*G0_0_6_1 - 0.000401785714285715*G0_0_7_0 + 0.00602678571428569*G0_0_7_1 - 0.00100446428571428*G0_0_8_0 - 0.0120535714285714*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.000401785714285714*G0_1_10_0 - 0.00140624999999999*G0_1_10_1 - 0.0120535714285714*G0_1_11_1 + 0.00234374999999999*G0_1_12_0 + 6.69642857142881e-05*G0_1_12_1 - 0.00502232142857141*G0_1_13_0 - 0.0120535714285714*G0_1_13_1 + 0.00763392857142855*G0_1_14_0 + 0.0060267857142857*G0_1_14_1 - 0.00281249999999999*G0_1_15_0 + 0.000200892857142853*G0_1_15_1 + 0.0074330357142857*G0_1_16_0 + 0.00381696428571428*G0_1_16_1 - 0.000401785714285715*G0_1_17_0 + 0.00602678571428569*G0_1_17_1 - 0.00100446428571428*G0_1_18_0 - 0.0120535714285714*G0_1_18_1 + 0.00482142857142856*G0_1_19_0;
    A[235] = 6.69642857142895e-05*G0_0_0_0 + 0.00241071428571427*G0_0_0_1 + 0.00140625*G0_0_2_0 + 0.00180803571428571*G0_0_2_1 + 0.00200892857142858*G0_0_3_0 + 0.00100446428571429*G0_0_3_1 + 0.000200892857142852*G0_0_4_0 - 0.000200892857142857*G0_0_4_1 - 0.00743303571428569*G0_0_5_0 - 0.00140625*G0_0_6_0 - 0.00421874999999999*G0_0_6_1 - 0.00381696428571427*G0_0_7_0 + 0.00381696428571426*G0_0_7_1 + 0.00401785714285714*G0_0_8_0 - 0.00100446428571428*G0_0_8_1 - 0.00843749999999997*G0_0_9_0 - 0.00361607142857142*G0_0_9_1 + 6.69642857142895e-05*G0_1_10_0 + 0.00241071428571427*G0_1_10_1 + 0.00140625*G0_1_12_0 + 0.00180803571428571*G0_1_12_1 + 0.00200892857142858*G0_1_13_0 + 0.00100446428571429*G0_1_13_1 + 0.000200892857142852*G0_1_14_0 - 0.000200892857142857*G0_1_14_1 - 0.00743303571428569*G0_1_15_0 - 0.00140625*G0_1_16_0 - 0.00421874999999999*G0_1_16_1 - 0.00381696428571427*G0_1_17_0 + 0.00381696428571426*G0_1_17_1 + 0.00401785714285714*G0_1_18_0 - 0.00100446428571428*G0_1_18_1 - 0.00843749999999997*G0_1_19_0 - 0.00361607142857142*G0_1_19_1;
    A[236] = -0.000401785714285714*G0_0_0_0 - 0.00180803571428571*G0_0_0_1 - 0.00234374999999999*G0_0_2_0 - 0.00241071428571428*G0_0_2_1 + 0.00502232142857141*G0_0_3_0 + 0.00100446428571427*G0_0_3_1 - 0.00763392857142855*G0_0_4_0 - 0.00381696428571427*G0_0_4_1 + 0.00281249999999999*G0_0_5_0 + 0.00421874999999999*G0_0_5_1 - 0.0074330357142857*G0_0_6_0 + 0.000401785714285715*G0_0_7_0 + 0.000200892857142867*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 - 0.00100446428571429*G0_0_8_1 - 0.00482142857142856*G0_0_9_0 + 0.00361607142857141*G0_0_9_1 - 0.000401785714285714*G0_1_10_0 - 0.00180803571428571*G0_1_10_1 - 0.00234374999999999*G0_1_12_0 - 0.00241071428571428*G0_1_12_1 + 0.00502232142857141*G0_1_13_0 + 0.00100446428571427*G0_1_13_1 - 0.00763392857142855*G0_1_14_0 - 0.00381696428571427*G0_1_14_1 + 0.00281249999999999*G0_1_15_0 + 0.00421874999999999*G0_1_15_1 - 0.0074330357142857*G0_1_16_0 + 0.000401785714285715*G0_1_17_0 + 0.000200892857142867*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 - 0.00100446428571429*G0_1_18_1 - 0.00482142857142856*G0_1_19_0 + 0.00361607142857141*G0_1_19_1;
    A[237] = 0.0022767857142857*G0_0_0_0 - 6.69642857142869e-05*G0_0_0_1 + 0.0120535714285713*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.0018080357142857*G0_0_2_0 + 0.00140624999999999*G0_0_2_1 + 0.0110491071428571*G0_0_3_0 + 0.0120535714285714*G0_0_3_1 - 0.0064285714285714*G0_0_4_0 - 0.00602678571428569*G0_0_4_1 + 0.00361607142857142*G0_0_5_0 - 0.00381696428571427*G0_0_5_1 - 0.00301339285714285*G0_0_6_0 - 0.000200892857142861*G0_0_6_1 + 0.00160714285714286*G0_0_7_0 - 0.00602678571428568*G0_0_7_1 + 0.00703124999999996*G0_0_8_0 + 0.0120535714285714*G0_0_8_1 + 0.00482142857142856*G0_0_9_0 + 0.0022767857142857*G0_1_10_0 - 6.69642857142869e-05*G0_1_10_1 + 0.0120535714285713*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.0018080357142857*G0_1_12_0 + 0.00140624999999999*G0_1_12_1 + 0.0110491071428571*G0_1_13_0 + 0.0120535714285714*G0_1_13_1 - 0.0064285714285714*G0_1_14_0 - 0.00602678571428569*G0_1_14_1 + 0.00361607142857142*G0_1_15_0 - 0.00381696428571427*G0_1_15_1 - 0.00301339285714285*G0_1_16_0 - 0.000200892857142861*G0_1_16_1 + 0.00160714285714286*G0_1_17_0 - 0.00602678571428568*G0_1_17_1 + 0.00703124999999996*G0_1_18_0 + 0.0120535714285714*G0_1_18_1 + 0.00482142857142856*G0_1_19_0;
    A[238] = -0.00227678571428569*G0_0_0_0 - 0.00234374999999998*G0_0_0_1 - 0.0267857142857141*G0_0_1_0 - 0.032142857142857*G0_0_1_1 - 0.00241071428571427*G0_0_2_0 - 0.00234374999999998*G0_0_2_1 - 0.0220982142857141*G0_0_3_0 - 0.0241071428571427*G0_0_3_1 + 0.0110491071428571*G0_0_4_0 + 0.0120535714285714*G0_0_4_1 - 0.00120535714285715*G0_0_5_0 + 0.00100446428571427*G0_0_5_1 + 0.00120535714285714*G0_0_6_0 + 0.00100446428571428*G0_0_6_1 + 0.00703124999999996*G0_0_7_0 + 0.0120535714285714*G0_0_7_1 - 0.0200892857142856*G0_0_8_0 - 0.0241071428571427*G0_0_8_1 - 0.0060267857142857*G0_0_9_0 - 0.00227678571428569*G0_1_10_0 - 0.00234374999999998*G0_1_10_1 - 0.0267857142857141*G0_1_11_0 - 0.032142857142857*G0_1_11_1 - 0.00241071428571427*G0_1_12_0 - 0.00234374999999998*G0_1_12_1 - 0.0220982142857141*G0_1_13_0 - 0.0241071428571427*G0_1_13_1 + 0.0110491071428571*G0_1_14_0 + 0.0120535714285714*G0_1_14_1 - 0.00120535714285715*G0_1_15_0 + 0.00100446428571427*G0_1_15_1 + 0.00120535714285714*G0_1_16_0 + 0.00100446428571428*G0_1_16_1 + 0.00703124999999996*G0_1_17_0 + 0.0120535714285714*G0_1_17_1 - 0.0200892857142856*G0_1_18_0 - 0.0241071428571427*G0_1_18_1 - 0.0060267857142857*G0_1_19_0;
    A[239] = 0.00147321428571428*G0_0_0_1 - 0.00535714285714286*G0_0_1_0 - 0.00147321428571428*G0_0_2_0 - 0.00147321428571428*G0_0_2_1 - 0.00602678571428569*G0_0_3_0 + 0.00482142857142855*G0_0_4_0 + 0.00723214285714283*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 + 0.00361607142857142*G0_0_6_0 - 0.00361607142857142*G0_0_6_1 + 0.00482142857142855*G0_0_7_0 - 0.0060267857142857*G0_0_8_0 + 0.0144642857142857*G0_0_9_0 + 0.00147321428571428*G0_1_10_1 - 0.00535714285714286*G0_1_11_0 - 0.00147321428571428*G0_1_12_0 - 0.00147321428571428*G0_1_12_1 - 0.00602678571428569*G0_1_13_0 + 0.00482142857142855*G0_1_14_0 + 0.00723214285714283*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 + 0.00361607142857142*G0_1_16_0 - 0.00361607142857142*G0_1_16_1 + 0.00482142857142855*G0_1_17_0 - 0.0060267857142857*G0_1_18_0 + 0.0144642857142857*G0_1_19_0;
    A[240] = 0;
    A[241] = 0;
    A[242] = 0;
    A[243] = 0;
    A[244] = 0;
    A[245] = 0;
    A[246] = 0;
    A[247] = 0;
    A[248] = 0;
    A[249] = 0;
    A[250] = -0.00148809523809523*G0_0_0_0 - 0.00148809523809523*G0_0_0_1 - 0.000885416666666662*G0_0_1_0 - 0.000885416666666662*G0_0_1_1 - 0.00297619047619046*G0_0_2_0 - 0.00297619047619046*G0_0_2_1 + 0.00140624999999999*G0_0_3_0 + 0.00140624999999999*G0_0_3_1 - 0.00234374999999999*G0_0_4_0 - 0.00234374999999999*G0_0_4_1 - 0.00261160714285713*G0_0_5_0 - 0.00261160714285713*G0_0_5_1 - 0.000334821428571434*G0_0_6_0 - 0.000334821428571434*G0_0_6_1 - 0.00241071428571427*G0_0_7_0 - 0.00241071428571427*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 + 0.0018080357142857*G0_0_8_1 - 0.00147321428571428*G0_0_9_0 - 0.00147321428571428*G0_0_9_1 - 0.00148809523809523*G0_1_10_0 - 0.00148809523809523*G0_1_10_1 - 0.000885416666666662*G0_1_11_0 - 0.000885416666666662*G0_1_11_1 - 0.00297619047619046*G0_1_12_0 - 0.00297619047619046*G0_1_12_1 + 0.00140624999999999*G0_1_13_0 + 0.00140624999999999*G0_1_13_1 - 0.00234374999999999*G0_1_14_0 - 0.00234374999999999*G0_1_14_1 - 0.00261160714285713*G0_1_15_0 - 0.00261160714285713*G0_1_15_1 - 0.000334821428571434*G0_1_16_0 - 0.000334821428571434*G0_1_16_1 - 0.00241071428571427*G0_1_17_0 - 0.00241071428571427*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 + 0.0018080357142857*G0_1_18_1 - 0.00147321428571428*G0_1_19_0 - 0.00147321428571428*G0_1_19_1;
    A[251] = 0.000885416666666662*G0_0_0_0 + 0.00148809523809523*G0_0_1_0 + 0.00297619047619047*G0_0_2_0 + 0.00261160714285713*G0_0_3_0 + 0.000334821428571433*G0_0_4_0 - 0.00140625*G0_0_5_0 + 0.00234374999999999*G0_0_6_0 - 0.0018080357142857*G0_0_7_0 + 0.00241071428571427*G0_0_8_0 + 0.00147321428571428*G0_0_9_0 + 0.000885416666666662*G0_1_10_0 + 0.00148809523809523*G0_1_11_0 + 0.00297619047619047*G0_1_12_0 + 0.00261160714285713*G0_1_13_0 + 0.000334821428571433*G0_1_14_0 - 0.00140625*G0_1_15_0 + 0.00234374999999999*G0_1_16_0 - 0.0018080357142857*G0_1_17_0 + 0.00241071428571427*G0_1_18_0 + 0.00147321428571428*G0_1_19_0;
    A[252] = 0.00148809523809523*G0_0_0_1 + 0.00148809523809523*G0_0_1_1 + 0.0177083333333332*G0_0_2_1 - 0.00602678571428568*G0_0_3_1 + 0.0133928571428571*G0_0_4_1 - 0.00602678571428568*G0_0_5_1 + 0.0133928571428571*G0_0_6_1 + 0.00267857142857141*G0_0_9_1 + 0.00148809523809523*G0_1_10_1 + 0.00148809523809523*G0_1_11_1 + 0.0177083333333332*G0_1_12_1 - 0.00602678571428568*G0_1_13_1 + 0.0133928571428571*G0_1_14_1 - 0.00602678571428568*G0_1_15_1 + 0.0133928571428571*G0_1_16_1 + 0.00267857142857141*G0_1_19_1;
    A[253] = -0.00140624999999999*G0_0_0_0 + 0.000401785714285712*G0_0_0_1 + 6.69642857142847e-05*G0_0_1_0 + 0.00234374999999998*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 + 0.00602678571428568*G0_0_3_0 + 0.00763392857142853*G0_0_3_1 - 0.0120535714285714*G0_0_4_0 - 0.0050223214285714*G0_0_4_1 + 0.00602678571428569*G0_0_5_0 - 0.000401785714285713*G0_0_5_1 - 0.0120535714285714*G0_0_6_0 - 0.00100446428571427*G0_0_6_1 + 0.000200892857142856*G0_0_7_0 - 0.00281249999999998*G0_0_7_1 + 0.00381696428571427*G0_0_8_0 + 0.00743303571428567*G0_0_8_1 + 0.00482142857142856*G0_0_9_1 - 0.00140624999999999*G0_1_10_0 + 0.000401785714285712*G0_1_10_1 + 6.69642857142847e-05*G0_1_11_0 + 0.00234374999999998*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 + 0.00602678571428568*G0_1_13_0 + 0.00763392857142853*G0_1_13_1 - 0.0120535714285714*G0_1_14_0 - 0.0050223214285714*G0_1_14_1 + 0.00602678571428569*G0_1_15_0 - 0.000401785714285713*G0_1_15_1 - 0.0120535714285714*G0_1_16_0 - 0.00100446428571427*G0_1_16_1 + 0.000200892857142856*G0_1_17_0 - 0.00281249999999998*G0_1_17_1 + 0.00381696428571427*G0_1_18_0 + 0.00743303571428567*G0_1_18_1 + 0.00482142857142856*G0_1_19_1;
    A[254] = 0.00234374999999999*G0_0_0_0 - 6.69642857142862e-05*G0_0_0_1 + 0.00234374999999999*G0_0_1_0 + 6.6964285714288e-05*G0_0_1_1 + 0.032142857142857*G0_0_2_0 + 0.00535714285714284*G0_0_2_1 - 0.0120535714285714*G0_0_3_0 - 0.0050223214285714*G0_0_3_1 + 0.0241071428571427*G0_0_4_0 + 0.00401785714285711*G0_0_4_1 - 0.0120535714285714*G0_0_5_0 - 0.00100446428571428*G0_0_5_1 + 0.0241071428571427*G0_0_6_0 + 0.00200892857142856*G0_0_6_1 - 0.00100446428571428*G0_0_7_0 + 0.000200892857142858*G0_0_7_1 - 0.00100446428571428*G0_0_8_0 - 0.00220982142857141*G0_0_8_1 - 0.0060267857142857*G0_0_9_1 + 0.00234374999999999*G0_1_10_0 - 6.69642857142862e-05*G0_1_10_1 + 0.00234374999999999*G0_1_11_0 + 6.6964285714288e-05*G0_1_11_1 + 0.032142857142857*G0_1_12_0 + 0.00535714285714284*G0_1_12_1 - 0.0120535714285714*G0_1_13_0 - 0.0050223214285714*G0_1_13_1 + 0.0241071428571427*G0_1_14_0 + 0.00401785714285711*G0_1_14_1 - 0.0120535714285714*G0_1_15_0 - 0.00100446428571428*G0_1_15_1 + 0.0241071428571427*G0_1_16_0 + 0.00200892857142856*G0_1_16_1 - 0.00100446428571428*G0_1_17_0 + 0.000200892857142858*G0_1_17_1 - 0.00100446428571428*G0_1_18_0 - 0.00220982142857141*G0_1_18_1 - 0.0060267857142857*G0_1_19_1;
    A[255] = -6.69642857142837e-05*G0_0_0_0 + 0.0022767857142857*G0_0_0_1 + 0.00140625*G0_0_1_0 + 0.00180803571428571*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0120535714285714*G0_0_2_1 - 0.00602678571428568*G0_0_3_0 - 0.0064285714285714*G0_0_3_1 + 0.0120535714285714*G0_0_4_0 + 0.0110491071428571*G0_0_4_1 - 0.00602678571428567*G0_0_5_0 + 0.00160714285714285*G0_0_5_1 + 0.0120535714285714*G0_0_6_0 + 0.00703124999999999*G0_0_6_1 - 0.00381696428571426*G0_0_7_0 + 0.0036160714285714*G0_0_7_1 - 0.000200892857142856*G0_0_8_0 - 0.00301339285714284*G0_0_8_1 + 0.00482142857142855*G0_0_9_1 - 6.69642857142837e-05*G0_1_10_0 + 0.0022767857142857*G0_1_10_1 + 0.00140625*G0_1_11_0 + 0.00180803571428571*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0120535714285714*G0_1_12_1 - 0.00602678571428568*G0_1_13_0 - 0.0064285714285714*G0_1_13_1 + 0.0120535714285714*G0_1_14_0 + 0.0110491071428571*G0_1_14_1 - 0.00602678571428567*G0_1_15_0 + 0.00160714285714285*G0_1_15_1 + 0.0120535714285714*G0_1_16_0 + 0.00703124999999999*G0_1_16_1 - 0.00381696428571426*G0_1_17_0 + 0.0036160714285714*G0_1_17_1 - 0.000200892857142856*G0_1_18_0 - 0.00301339285714284*G0_1_18_1 + 0.00482142857142855*G0_1_19_1;
    A[256] = -0.00234374999999999*G0_0_0_0 - 0.0022767857142857*G0_0_0_1 - 0.00234374999999999*G0_0_1_0 - 0.00241071428571428*G0_0_1_1 - 0.032142857142857*G0_0_2_0 - 0.0267857142857141*G0_0_2_1 + 0.0120535714285714*G0_0_3_0 + 0.0110491071428571*G0_0_3_1 - 0.0241071428571427*G0_0_4_0 - 0.0220982142857142*G0_0_4_1 + 0.0120535714285714*G0_0_5_0 + 0.00703124999999996*G0_0_5_1 - 0.0241071428571427*G0_0_6_0 - 0.0200892857142856*G0_0_6_1 + 0.00100446428571428*G0_0_7_0 - 0.00120535714285713*G0_0_7_1 + 0.00100446428571428*G0_0_8_0 + 0.00120535714285714*G0_0_8_1 - 0.00602678571428569*G0_0_9_1 - 0.00234374999999999*G0_1_10_0 - 0.0022767857142857*G0_1_10_1 - 0.00234374999999999*G0_1_11_0 - 0.00241071428571428*G0_1_11_1 - 0.032142857142857*G0_1_12_0 - 0.0267857142857141*G0_1_12_1 + 0.0120535714285714*G0_1_13_0 + 0.0110491071428571*G0_1_13_1 - 0.0241071428571427*G0_1_14_0 - 0.0220982142857142*G0_1_14_1 + 0.0120535714285714*G0_1_15_0 + 0.00703124999999996*G0_1_15_1 - 0.0241071428571427*G0_1_16_0 - 0.0200892857142856*G0_1_16_1 + 0.00100446428571428*G0_1_17_0 - 0.00120535714285713*G0_1_17_1 + 0.00100446428571428*G0_1_18_0 + 0.00120535714285714*G0_1_18_1 - 0.00602678571428569*G0_1_19_1;
    A[257] = 0.00241071428571427*G0_0_0_0 + 6.69642857142869e-05*G0_0_0_1 + 0.0018080357142857*G0_0_1_0 + 0.00140624999999999*G0_0_1_1 - 0.000200892857142854*G0_0_3_0 + 0.000200892857142858*G0_0_3_1 + 0.00100446428571427*G0_0_4_0 + 0.00200892857142856*G0_0_4_1 + 0.00381696428571426*G0_0_5_0 - 0.00381696428571426*G0_0_5_1 - 0.00100446428571429*G0_0_6_0 + 0.00401785714285712*G0_0_6_1 - 0.00743303571428566*G0_0_7_1 - 0.00421874999999998*G0_0_8_0 - 0.00140624999999999*G0_0_8_1 - 0.00361607142857141*G0_0_9_0 - 0.00843749999999996*G0_0_9_1 + 0.00241071428571427*G0_1_10_0 + 6.69642857142869e-05*G0_1_10_1 + 0.0018080357142857*G0_1_11_0 + 0.00140624999999999*G0_1_11_1 - 0.000200892857142854*G0_1_13_0 + 0.000200892857142858*G0_1_13_1 + 0.00100446428571427*G0_1_14_0 + 0.00200892857142856*G0_1_14_1 + 0.00381696428571426*G0_1_15_0 - 0.00381696428571426*G0_1_15_1 - 0.00100446428571429*G0_1_16_0 + 0.00401785714285712*G0_1_16_1 - 0.00743303571428566*G0_1_17_1 - 0.00421874999999998*G0_1_18_0 - 0.00140624999999999*G0_1_18_1 - 0.00361607142857141*G0_1_19_0 - 0.00843749999999996*G0_1_19_1;
    A[258] = -0.0018080357142857*G0_0_0_0 - 0.000401785714285712*G0_0_0_1 - 0.00241071428571427*G0_0_1_0 - 0.00234374999999998*G0_0_1_1 - 0.00381696428571426*G0_0_3_0 - 0.00763392857142853*G0_0_3_1 + 0.00100446428571428*G0_0_4_0 + 0.0050223214285714*G0_0_4_1 + 0.000200892857142856*G0_0_5_0 + 0.000401785714285712*G0_0_5_1 - 0.00100446428571427*G0_0_6_0 + 0.00100446428571428*G0_0_6_1 + 0.00421874999999997*G0_0_7_0 + 0.00281249999999999*G0_0_7_1 - 0.00743303571428567*G0_0_8_1 + 0.00361607142857141*G0_0_9_0 - 0.00482142857142856*G0_0_9_1 - 0.0018080357142857*G0_1_10_0 - 0.000401785714285712*G0_1_10_1 - 0.00241071428571427*G0_1_11_0 - 0.00234374999999998*G0_1_11_1 - 0.00381696428571426*G0_1_13_0 - 0.00763392857142853*G0_1_13_1 + 0.00100446428571428*G0_1_14_0 + 0.0050223214285714*G0_1_14_1 + 0.000200892857142856*G0_1_15_0 + 0.000401785714285712*G0_1_15_1 - 0.00100446428571427*G0_1_16_0 + 0.00100446428571428*G0_1_16_1 + 0.00421874999999997*G0_1_17_0 + 0.00281249999999999*G0_1_17_1 - 0.00743303571428567*G0_1_18_1 + 0.00361607142857141*G0_1_19_0 - 0.00482142857142856*G0_1_19_1;
    A[259] = 0.00147321428571428*G0_0_0_0 - 0.00147321428571428*G0_0_1_0 - 0.00147321428571428*G0_0_1_1 - 0.00535714285714284*G0_0_2_1 + 0.00482142857142855*G0_0_3_1 - 0.00602678571428567*G0_0_4_1 + 0.00482142857142854*G0_0_5_1 - 0.00602678571428568*G0_0_6_1 + 0.0036160714285714*G0_0_7_0 + 0.0072321428571428*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 + 0.00361607142857141*G0_0_8_1 + 0.0144642857142857*G0_0_9_1 + 0.00147321428571428*G0_1_10_0 - 0.00147321428571428*G0_1_11_0 - 0.00147321428571428*G0_1_11_1 - 0.00535714285714284*G0_1_12_1 + 0.00482142857142855*G0_1_13_1 - 0.00602678571428567*G0_1_14_1 + 0.00482142857142854*G0_1_15_1 - 0.00602678571428568*G0_1_16_1 + 0.0036160714285714*G0_1_17_0 + 0.0072321428571428*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 + 0.00361607142857141*G0_1_18_1 + 0.0144642857142857*G0_1_19_1;
    A[260] = 0;
    A[261] = 0;
    A[262] = 0;
    A[263] = 0;
    A[264] = 0;
    A[265] = 0;
    A[266] = 0;
    A[267] = 0;
    A[268] = 0;
    A[269] = 0;
    A[270] = -0.00234374999999998*G0_0_1_0 - 0.00234374999999999*G0_0_1_1 + 0.00140624999999999*G0_0_2_0 + 0.00140624999999999*G0_0_2_1 - 0.0148660714285713*G0_0_3_0 - 0.0148660714285713*G0_0_3_1 + 0.00140625*G0_0_4_0 + 0.00140625*G0_0_4_1 + 0.00220982142857142*G0_0_5_0 + 0.00220982142857142*G0_0_5_1 - 0.00261160714285713*G0_0_6_0 - 0.00261160714285713*G0_0_6_1 + 0.00281249999999998*G0_0_7_0 + 0.00281249999999999*G0_0_7_1 - 0.000200892857142849*G0_0_8_0 - 0.000200892857142852*G0_0_8_1 - 0.00120535714285715*G0_0_9_0 - 0.00120535714285715*G0_0_9_1 - 0.00234374999999998*G0_1_11_0 - 0.00234374999999999*G0_1_11_1 + 0.00140624999999999*G0_1_12_0 + 0.00140624999999999*G0_1_12_1 - 0.0148660714285713*G0_1_13_0 - 0.0148660714285713*G0_1_13_1 + 0.00140625*G0_1_14_0 + 0.00140625*G0_1_14_1 + 0.00220982142857142*G0_1_15_0 + 0.00220982142857142*G0_1_15_1 - 0.00261160714285713*G0_1_16_0 - 0.00261160714285713*G0_1_16_1 + 0.00281249999999998*G0_1_17_0 + 0.00281249999999999*G0_1_17_1 - 0.000200892857142849*G0_1_18_0 - 0.000200892857142852*G0_1_18_1 - 0.00120535714285715*G0_1_19_0 - 0.00120535714285715*G0_1_19_1;
    A[271] = 0.00241071428571427*G0_0_0_0 + 0.0133928571428571*G0_0_1_0 + 0.00261160714285713*G0_0_2_0 + 0.0401785714285712*G0_0_3_0 - 0.0140624999999999*G0_0_4_0 - 0.00220982142857141*G0_0_5_0 - 0.00281249999999999*G0_0_6_0 - 0.0100446428571428*G0_0_7_0 + 0.0200892857142856*G0_0_8_0 + 0.0120535714285714*G0_0_9_0 + 0.00241071428571427*G0_1_10_0 + 0.0133928571428571*G0_1_11_0 + 0.00261160714285713*G0_1_12_0 + 0.0401785714285712*G0_1_13_0 - 0.0140624999999999*G0_1_14_0 - 0.00220982142857141*G0_1_15_0 - 0.00281249999999999*G0_1_16_0 - 0.0100446428571428*G0_1_17_0 + 0.0200892857142856*G0_1_18_0 + 0.0120535714285714*G0_1_19_0;
    A[272] = -0.00180803571428571*G0_0_0_1 + 0.000334821428571422*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 - 0.0032142857142857*G0_0_3_1 - 0.0140624999999999*G0_0_4_1 + 0.00683035714285711*G0_0_5_1 - 0.0100446428571428*G0_0_6_1 + 0.00261160714285714*G0_0_7_1 + 0.000200892857142846*G0_0_8_1 - 0.00964285714285711*G0_0_9_1 - 0.00180803571428571*G0_1_10_1 + 0.000334821428571422*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 - 0.0032142857142857*G0_1_13_1 - 0.0140624999999999*G0_1_14_1 + 0.00683035714285711*G0_1_15_1 - 0.0100446428571428*G0_1_16_1 + 0.00261160714285714*G0_1_17_1 + 0.000200892857142846*G0_1_18_1 - 0.00964285714285711*G0_1_19_1;
    A[273] = 0.00743303571428568*G0_0_0_0 + 0.00743303571428567*G0_0_0_1 + 0.00401785714285712*G0_0_1_0 + 0.0241071428571427*G0_0_1_1 + 0.00602678571428568*G0_0_2_0 + 0.00763392857142853*G0_0_2_1 + 0.108482142857142*G0_0_3_0 + 0.108482142857142*G0_0_3_1 - 0.00542410714285719*G0_0_4_0 - 0.0271205357142856*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 - 0.0072321428571428*G0_0_5_1 + 0.0054241071428571*G0_0_6_0 - 0.00180803571428572*G0_0_6_1 - 0.0235044642857142*G0_0_7_0 - 0.0271205357142856*G0_0_7_1 + 0.0361607142857141*G0_0_8_0 + 0.0542410714285711*G0_0_8_1 + 0.0650892857142855*G0_0_9_0 + 0.0542410714285712*G0_0_9_1 + 0.00743303571428568*G0_1_10_0 + 0.00743303571428567*G0_1_10_1 + 0.00401785714285712*G0_1_11_0 + 0.0241071428571427*G0_1_11_1 + 0.00602678571428568*G0_1_12_0 + 0.00763392857142853*G0_1_12_1 + 0.108482142857142*G0_1_13_0 + 0.108482142857142*G0_1_13_1 - 0.00542410714285719*G0_1_14_0 - 0.0271205357142856*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 - 0.0072321428571428*G0_1_15_1 + 0.0054241071428571*G0_1_16_0 - 0.00180803571428572*G0_1_16_1 - 0.0235044642857142*G0_1_17_0 - 0.0271205357142856*G0_1_17_1 + 0.0361607142857141*G0_1_18_0 + 0.0542410714285711*G0_1_18_1 + 0.0650892857142855*G0_1_19_0 + 0.0542410714285712*G0_1_19_1;
    A[274] = -0.00281249999999999*G0_0_0_0 + 0.00140624999999999*G0_0_0_1 - 0.00502232142857141*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.0050223214285714*G0_0_2_1 + 0.0108482142857142*G0_0_3_0 + 0.0542410714285711*G0_0_3_1 - 0.0271205357142856*G0_0_4_0 - 0.0054241071428572*G0_0_4_1 + 0.0108482142857142*G0_0_5_0 - 0.00180803571428569*G0_0_5_1 - 0.0271205357142856*G0_0_6_0 - 0.01265625*G0_0_6_1 + 0.00361607142857142*G0_0_7_0 - 0.00542410714285711*G0_0_7_1 - 0.00180803571428572*G0_0_8_0 - 0.0216964285714285*G0_0_9_0 + 0.0108482142857142*G0_0_9_1 - 0.00281249999999999*G0_1_10_0 + 0.00140624999999999*G0_1_10_1 - 0.00502232142857141*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.0050223214285714*G0_1_12_1 + 0.0108482142857142*G0_1_13_0 + 0.0542410714285711*G0_1_13_1 - 0.0271205357142856*G0_1_14_0 - 0.0054241071428572*G0_1_14_1 + 0.0108482142857142*G0_1_15_0 - 0.00180803571428569*G0_1_15_1 - 0.0271205357142856*G0_1_16_0 - 0.01265625*G0_1_16_1 + 0.00361607142857142*G0_1_17_0 - 0.00542410714285711*G0_1_17_1 - 0.00180803571428572*G0_1_18_0 - 0.0216964285714285*G0_1_19_0 + 0.0108482142857142*G0_1_19_1;
    A[275] = -0.000200892857142856*G0_0_0_0 - 0.00120535714285714*G0_0_0_1 + 0.00200892857142858*G0_0_1_0 + 0.00100446428571429*G0_0_1_1 - 0.00602678571428568*G0_0_2_0 - 0.0064285714285714*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0144642857142856*G0_0_3_1 - 0.00542410714285715*G0_0_4_0 - 0.00180803571428573*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 + 0.00542410714285713*G0_0_6_0 + 0.00904017857142854*G0_0_6_1 + 0.0018080357142857*G0_0_7_0 - 0.00361607142857139*G0_0_8_0 - 0.00542410714285711*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 - 0.000200892857142856*G0_1_10_0 - 0.00120535714285714*G0_1_10_1 + 0.00200892857142858*G0_1_11_0 + 0.00100446428571429*G0_1_11_1 - 0.00602678571428568*G0_1_12_0 - 0.0064285714285714*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0144642857142856*G0_1_13_1 - 0.00542410714285715*G0_1_14_0 - 0.00180803571428573*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 + 0.00542410714285713*G0_1_16_0 + 0.00904017857142854*G0_1_16_1 + 0.0018080357142857*G0_1_17_0 - 0.00361607142857139*G0_1_18_0 - 0.00542410714285711*G0_1_18_1 + 0.0216964285714285*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[276] = 0.00281249999999999*G0_0_0_0 + 0.00301339285714284*G0_0_0_1 + 0.00502232142857141*G0_0_1_0 + 0.00100446428571427*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0110491071428571*G0_0_2_1 - 0.0108482142857143*G0_0_3_0 + 0.00361607142857138*G0_0_3_1 + 0.0271205357142856*G0_0_4_0 + 0.0144642857142857*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 - 0.01265625*G0_0_5_1 + 0.0271205357142856*G0_0_6_0 + 0.0036160714285714*G0_0_6_1 - 0.00361607142857141*G0_0_7_0 - 0.00542410714285711*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.00281249999999999*G0_1_10_0 + 0.00301339285714284*G0_1_10_1 + 0.00502232142857141*G0_1_11_0 + 0.00100446428571427*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0110491071428571*G0_1_12_1 - 0.0108482142857143*G0_1_13_0 + 0.00361607142857138*G0_1_13_1 + 0.0271205357142856*G0_1_14_0 + 0.0144642857142857*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 - 0.01265625*G0_1_15_1 + 0.0271205357142856*G0_1_16_0 + 0.0036160714285714*G0_1_16_1 - 0.00361607142857141*G0_1_17_0 - 0.00542410714285711*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0216964285714285*G0_1_19_0;
    A[277] = 0.00120535714285714*G0_0_0_0 + 0.00220982142857142*G0_0_0_1 + 0.0110491071428571*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 - 0.000200892857142854*G0_0_2_0 + 0.000200892857142858*G0_0_2_1 + 0.0470089285714283*G0_0_3_0 + 0.0542410714285712*G0_0_3_1 - 0.00180803571428572*G0_0_4_0 - 0.00542410714285715*G0_0_4_1 - 0.00542410714285712*G0_0_5_0 + 0.00180803571428572*G0_0_5_1 + 0.00542410714285712*G0_0_6_0 + 0.0018080357142857*G0_0_6_1 - 0.00723214285714282*G0_0_7_0 - 0.00542410714285712*G0_0_7_1 - 0.00180803571428571*G0_0_8_0 + 0.0108482142857143*G0_0_9_1 + 0.00120535714285714*G0_1_10_0 + 0.00220982142857142*G0_1_10_1 + 0.0110491071428571*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 - 0.000200892857142854*G0_1_12_0 + 0.000200892857142858*G0_1_12_1 + 0.0470089285714283*G0_1_13_0 + 0.0542410714285712*G0_1_13_1 - 0.00180803571428572*G0_1_14_0 - 0.00542410714285715*G0_1_14_1 - 0.00542410714285712*G0_1_15_0 + 0.00180803571428572*G0_1_15_1 + 0.00542410714285712*G0_1_16_0 + 0.0018080357142857*G0_1_16_1 - 0.00723214285714282*G0_1_17_0 - 0.00542410714285712*G0_1_17_1 - 0.00180803571428571*G0_1_18_0 + 0.0108482142857143*G0_1_19_1;
    A[278] = -0.00361607142857141*G0_0_0_0 - 0.00743303571428567*G0_0_0_1 - 0.0220982142857141*G0_0_1_0 - 0.0241071428571427*G0_0_1_1 - 0.00381696428571426*G0_0_2_0 - 0.00763392857142853*G0_0_2_1 - 0.0723214285714282*G0_0_3_0 - 0.108482142857142*G0_0_3_1 + 0.0144642857142857*G0_0_4_0 + 0.0271205357142856*G0_0_4_1 + 0.00542410714285711*G0_0_5_0 + 0.00723214285714281*G0_0_5_1 + 0.00180803571428572*G0_0_6_1 + 0.0144642857142856*G0_0_7_0 + 0.0271205357142856*G0_0_7_1 - 0.018080357142857*G0_0_8_0 - 0.0542410714285711*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0542410714285713*G0_0_9_1 - 0.00361607142857141*G0_1_10_0 - 0.00743303571428567*G0_1_10_1 - 0.0220982142857141*G0_1_11_0 - 0.0241071428571427*G0_1_11_1 - 0.00381696428571426*G0_1_12_0 - 0.00763392857142853*G0_1_12_1 - 0.0723214285714282*G0_1_13_0 - 0.108482142857142*G0_1_13_1 + 0.0144642857142857*G0_1_14_0 + 0.0271205357142856*G0_1_14_1 + 0.00542410714285711*G0_1_15_0 + 0.00723214285714281*G0_1_15_1 + 0.00180803571428572*G0_1_16_1 + 0.0144642857142856*G0_1_17_0 + 0.0271205357142856*G0_1_17_1 - 0.018080357142857*G0_1_18_0 - 0.0542410714285711*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0542410714285713*G0_1_19_1;
    A[279] = -0.00723214285714282*G0_0_0_0 - 0.00361607142857141*G0_0_0_1 - 0.00602678571428569*G0_0_1_0 + 0.00482142857142855*G0_0_2_1 - 0.130178571428571*G0_0_3_0 - 0.108482142857142*G0_0_3_1 + 0.0108482142857143*G0_0_4_0 + 0.0108482142857143*G0_0_4_1 - 0.0108482142857142*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 - 0.0325446428571427*G0_0_8_0 - 0.086785714285714*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00723214285714282*G0_1_10_0 - 0.00361607142857141*G0_1_10_1 - 0.00602678571428569*G0_1_11_0 + 0.00482142857142855*G0_1_12_1 - 0.130178571428571*G0_1_13_0 - 0.108482142857142*G0_1_13_1 + 0.0108482142857143*G0_1_14_0 + 0.0108482142857143*G0_1_14_1 - 0.0108482142857142*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 - 0.0325446428571427*G0_1_18_0 - 0.086785714285714*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[280] = 0;
    A[281] = 0;
    A[282] = 0;
    A[283] = 0;
    A[284] = 0;
    A[285] = 0;
    A[286] = 0;
    A[287] = 0;
    A[288] = 0;
    A[289] = 0;
    A[290] = 0.00140624999999999*G0_0_1_0 + 0.00140624999999999*G0_0_1_1 - 0.00234374999999999*G0_0_2_0 - 0.00234374999999999*G0_0_2_1 + 0.00140625*G0_0_3_0 + 0.00140625*G0_0_3_1 - 0.0148660714285713*G0_0_4_0 - 0.0148660714285713*G0_0_4_1 + 0.00281249999999999*G0_0_5_0 + 0.00281249999999999*G0_0_5_1 - 0.00020089285714285*G0_0_6_0 - 0.000200892857142851*G0_0_6_1 + 0.00220982142857142*G0_0_7_0 + 0.00220982142857142*G0_0_7_1 - 0.00261160714285713*G0_0_8_0 - 0.00261160714285713*G0_0_8_1 - 0.00120535714285714*G0_0_9_0 - 0.00120535714285714*G0_0_9_1 + 0.00140624999999999*G0_1_11_0 + 0.00140624999999999*G0_1_11_1 - 0.00234374999999999*G0_1_12_0 - 0.00234374999999999*G0_1_12_1 + 0.00140625*G0_1_13_0 + 0.00140625*G0_1_13_1 - 0.0148660714285713*G0_1_14_0 - 0.0148660714285713*G0_1_14_1 + 0.00281249999999999*G0_1_15_0 + 0.00281249999999999*G0_1_15_1 - 0.00020089285714285*G0_1_16_0 - 0.000200892857142851*G0_1_16_1 + 0.00220982142857142*G0_1_17_0 + 0.00220982142857142*G0_1_17_1 - 0.00261160714285713*G0_1_18_0 - 0.00261160714285713*G0_1_18_1 - 0.00120535714285714*G0_1_19_0 - 0.00120535714285714*G0_1_19_1;
    A[291] = -0.00180803571428571*G0_0_0_0 - 0.00602678571428568*G0_0_1_0 + 0.000334821428571432*G0_0_2_0 - 0.0140624999999999*G0_0_3_0 - 0.00321428571428571*G0_0_4_0 + 0.00261160714285713*G0_0_5_0 + 0.000200892857142853*G0_0_6_0 + 0.00683035714285711*G0_0_7_0 - 0.0100446428571428*G0_0_8_0 - 0.00964285714285712*G0_0_9_0 - 0.00180803571428571*G0_1_10_0 - 0.00602678571428568*G0_1_11_0 + 0.000334821428571432*G0_1_12_0 - 0.0140624999999999*G0_1_13_0 - 0.00321428571428571*G0_1_14_0 + 0.00261160714285713*G0_1_15_0 + 0.000200892857142853*G0_1_16_0 + 0.00683035714285711*G0_1_17_0 - 0.0100446428571428*G0_1_18_0 - 0.00964285714285712*G0_1_19_0;
    A[292] = 0.00241071428571428*G0_0_0_1 + 0.00261160714285714*G0_0_1_1 + 0.0133928571428571*G0_0_2_1 - 0.0140624999999999*G0_0_3_1 + 0.0401785714285712*G0_0_4_1 - 0.0100446428571428*G0_0_5_1 + 0.0200892857142856*G0_0_6_1 - 0.00220982142857142*G0_0_7_1 - 0.00281249999999998*G0_0_8_1 + 0.0120535714285714*G0_0_9_1 + 0.00241071428571428*G0_1_10_1 + 0.00261160714285714*G0_1_11_1 + 0.0133928571428571*G0_1_12_1 - 0.0140624999999999*G0_1_13_1 + 0.0401785714285712*G0_1_14_1 - 0.0100446428571428*G0_1_15_1 + 0.0200892857142856*G0_1_16_1 - 0.00220982142857142*G0_1_17_1 - 0.00281249999999998*G0_1_18_1 + 0.0120535714285714*G0_1_19_1;
    A[293] = 0.00140625*G0_0_0_0 - 0.00281249999999999*G0_0_0_1 - 0.0050223214285714*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.0050223214285714*G0_0_2_1 - 0.0054241071428572*G0_0_3_0 - 0.0271205357142856*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 - 0.00542410714285714*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 - 0.00180803571428571*G0_0_6_1 - 0.0018080357142857*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 - 0.01265625*G0_0_8_0 - 0.0271205357142856*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 + 0.00140625*G0_1_10_0 - 0.00281249999999999*G0_1_10_1 - 0.0050223214285714*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.0050223214285714*G0_1_12_1 - 0.0054241071428572*G0_1_13_0 - 0.0271205357142856*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 - 0.00542410714285714*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 - 0.00180803571428571*G0_1_16_1 - 0.0018080357142857*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 - 0.01265625*G0_1_18_0 - 0.0271205357142856*G0_1_18_1 + 0.0108482142857142*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[294] = 0.00743303571428569*G0_0_0_0 + 0.0074330357142857*G0_0_0_1 + 0.00763392857142855*G0_0_1_0 + 0.0060267857142857*G0_0_1_1 + 0.0241071428571427*G0_0_2_0 + 0.00401785714285711*G0_0_2_1 - 0.0271205357142856*G0_0_3_0 - 0.0054241071428572*G0_0_3_1 + 0.108482142857142*G0_0_4_0 + 0.108482142857142*G0_0_4_1 - 0.0271205357142856*G0_0_5_0 - 0.0235044642857142*G0_0_5_1 + 0.0542410714285712*G0_0_6_0 + 0.0361607142857142*G0_0_6_1 - 0.00723214285714284*G0_0_7_0 - 0.0108482142857143*G0_0_7_1 - 0.0018080357142857*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0542410714285712*G0_0_9_0 + 0.0650892857142855*G0_0_9_1 + 0.00743303571428569*G0_1_10_0 + 0.0074330357142857*G0_1_10_1 + 0.00763392857142855*G0_1_11_0 + 0.0060267857142857*G0_1_11_1 + 0.0241071428571427*G0_1_12_0 + 0.00401785714285711*G0_1_12_1 - 0.0271205357142856*G0_1_13_0 - 0.0054241071428572*G0_1_13_1 + 0.108482142857142*G0_1_14_0 + 0.108482142857142*G0_1_14_1 - 0.0271205357142856*G0_1_15_0 - 0.0235044642857142*G0_1_15_1 + 0.0542410714285712*G0_1_16_0 + 0.0361607142857142*G0_1_16_1 - 0.00723214285714284*G0_1_17_0 - 0.0108482142857143*G0_1_17_1 - 0.0018080357142857*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0542410714285712*G0_1_19_0 + 0.0650892857142855*G0_1_19_1;
    A[295] = 0.00220982142857142*G0_0_0_0 + 0.00120535714285714*G0_0_0_1 + 0.000200892857142852*G0_0_1_0 - 0.000200892857142857*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.0110491071428571*G0_0_2_1 - 0.00542410714285715*G0_0_3_0 - 0.00180803571428573*G0_0_3_1 + 0.0542410714285711*G0_0_4_0 + 0.0470089285714283*G0_0_4_1 - 0.00542410714285712*G0_0_5_0 - 0.00723214285714283*G0_0_5_1 - 0.00180803571428572*G0_0_6_1 + 0.00180803571428571*G0_0_7_0 - 0.00542410714285712*G0_0_7_1 + 0.00180803571428569*G0_0_8_0 + 0.00542410714285712*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 + 0.00220982142857142*G0_1_10_0 + 0.00120535714285714*G0_1_10_1 + 0.000200892857142852*G0_1_11_0 - 0.000200892857142857*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.0110491071428571*G0_1_12_1 - 0.00542410714285715*G0_1_13_0 - 0.00180803571428573*G0_1_13_1 + 0.0542410714285711*G0_1_14_0 + 0.0470089285714283*G0_1_14_1 - 0.00542410714285712*G0_1_15_0 - 0.00723214285714283*G0_1_15_1 - 0.00180803571428572*G0_1_16_1 + 0.00180803571428571*G0_1_17_0 - 0.00542410714285712*G0_1_17_1 + 0.00180803571428569*G0_1_18_0 + 0.00542410714285712*G0_1_18_1 + 0.0108482142857142*G0_1_19_0;
    A[296] = -0.00743303571428569*G0_0_0_0 - 0.00361607142857142*G0_0_0_1 - 0.00763392857142855*G0_0_1_0 - 0.00381696428571427*G0_0_1_1 - 0.0241071428571427*G0_0_2_0 - 0.0220982142857142*G0_0_2_1 + 0.0271205357142856*G0_0_3_0 + 0.0144642857142857*G0_0_3_1 - 0.108482142857142*G0_0_4_0 - 0.0723214285714282*G0_0_4_1 + 0.0271205357142856*G0_0_5_0 + 0.0144642857142856*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 - 0.0180803571428571*G0_0_6_1 + 0.00723214285714284*G0_0_7_0 + 0.00542410714285711*G0_0_7_1 + 0.0018080357142857*G0_0_8_0 - 0.0542410714285712*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00743303571428569*G0_1_10_0 - 0.00361607142857142*G0_1_10_1 - 0.00763392857142855*G0_1_11_0 - 0.00381696428571427*G0_1_11_1 - 0.0241071428571427*G0_1_12_0 - 0.0220982142857142*G0_1_12_1 + 0.0271205357142856*G0_1_13_0 + 0.0144642857142857*G0_1_13_1 - 0.108482142857142*G0_1_14_0 - 0.0723214285714282*G0_1_14_1 + 0.0271205357142856*G0_1_15_0 + 0.0144642857142856*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 - 0.0180803571428571*G0_1_16_1 + 0.00723214285714284*G0_1_17_0 + 0.00542410714285711*G0_1_17_1 + 0.0018080357142857*G0_1_18_0 - 0.0542410714285712*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[297] = -0.00120535714285714*G0_0_0_0 - 0.000200892857142856*G0_0_0_1 - 0.0064285714285714*G0_0_1_0 - 0.00602678571428569*G0_0_1_1 + 0.00100446428571427*G0_0_2_0 + 0.00200892857142856*G0_0_2_1 - 0.00180803571428572*G0_0_3_0 - 0.00542410714285716*G0_0_3_1 + 0.0144642857142856*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.0018080357142857*G0_0_5_1 - 0.00542410714285713*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 + 0.00361607142857141*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 + 0.00904017857142853*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00120535714285714*G0_1_10_0 - 0.000200892857142856*G0_1_10_1 - 0.0064285714285714*G0_1_11_0 - 0.00602678571428569*G0_1_11_1 + 0.00100446428571427*G0_1_12_0 + 0.00200892857142856*G0_1_12_1 - 0.00180803571428572*G0_1_13_0 - 0.00542410714285716*G0_1_13_1 + 0.0144642857142856*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.0018080357142857*G0_1_15_1 - 0.00542410714285713*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 + 0.00361607142857141*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 + 0.00904017857142853*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[298] = 0.00301339285714284*G0_0_0_0 + 0.00281249999999998*G0_0_0_1 + 0.0110491071428571*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 + 0.0050223214285714*G0_0_2_1 + 0.0144642857142857*G0_0_3_0 + 0.0271205357142856*G0_0_3_1 + 0.0036160714285714*G0_0_4_0 - 0.0108482142857143*G0_0_4_1 - 0.00542410714285711*G0_0_5_0 - 0.0036160714285714*G0_0_5_1 + 0.00542410714285712*G0_0_6_0 + 0.0018080357142857*G0_0_6_1 - 0.0126562499999999*G0_0_7_0 - 0.0108482142857142*G0_0_7_1 + 0.00361607142857141*G0_0_8_0 + 0.0271205357142856*G0_0_8_1 + 0.0216964285714285*G0_0_9_1 + 0.00301339285714284*G0_1_10_0 + 0.00281249999999998*G0_1_10_1 + 0.0110491071428571*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 + 0.0050223214285714*G0_1_12_1 + 0.0144642857142857*G0_1_13_0 + 0.0271205357142856*G0_1_13_1 + 0.0036160714285714*G0_1_14_0 - 0.0108482142857143*G0_1_14_1 - 0.00542410714285711*G0_1_15_0 - 0.0036160714285714*G0_1_15_1 + 0.00542410714285712*G0_1_16_0 + 0.0018080357142857*G0_1_16_1 - 0.0126562499999999*G0_1_17_0 - 0.0108482142857142*G0_1_17_1 + 0.00361607142857141*G0_1_18_0 + 0.0271205357142856*G0_1_18_1 + 0.0216964285714285*G0_1_19_1;
    A[299] = -0.00361607142857142*G0_0_0_0 - 0.00723214285714284*G0_0_0_1 + 0.00482142857142855*G0_0_1_0 - 0.00602678571428567*G0_0_2_1 + 0.0108482142857144*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 - 0.108482142857142*G0_0_4_0 - 0.130178571428571*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.0325446428571428*G0_0_6_1 + 0.0108482142857143*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.086785714285714*G0_0_9_1 - 0.00361607142857142*G0_1_10_0 - 0.00723214285714284*G0_1_10_1 + 0.00482142857142855*G0_1_11_0 - 0.00602678571428567*G0_1_12_1 + 0.0108482142857144*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 - 0.108482142857142*G0_1_14_0 - 0.130178571428571*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.0325446428571428*G0_1_16_1 + 0.0108482142857143*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.086785714285714*G0_1_19_1;
    A[300] = 0;
    A[301] = 0;
    A[302] = 0;
    A[303] = 0;
    A[304] = 0;
    A[305] = 0;
    A[306] = 0;
    A[307] = 0;
    A[308] = 0;
    A[309] = 0;
    A[310] = -0.0133928571428571*G0_0_0_0 - 0.0133928571428571*G0_0_0_1 - 0.00241071428571427*G0_0_1_0 - 0.00241071428571427*G0_0_1_1 - 0.00261160714285713*G0_0_2_0 - 0.00261160714285713*G0_0_2_1 + 0.00220982142857142*G0_0_3_0 + 0.00220982142857142*G0_0_3_1 + 0.00281249999999999*G0_0_4_0 + 0.00281249999999999*G0_0_4_1 - 0.0401785714285712*G0_0_5_0 - 0.0401785714285712*G0_0_5_1 + 0.0140624999999999*G0_0_6_0 + 0.0140624999999999*G0_0_6_1 - 0.0200892857142856*G0_0_7_0 - 0.0200892857142856*G0_0_7_1 + 0.0100446428571428*G0_0_8_0 + 0.0100446428571428*G0_0_8_1 - 0.0120535714285714*G0_0_9_0 - 0.0120535714285714*G0_0_9_1 - 0.0133928571428571*G0_1_10_0 - 0.0133928571428571*G0_1_10_1 - 0.00241071428571427*G0_1_11_0 - 0.00241071428571427*G0_1_11_1 - 0.00261160714285713*G0_1_12_0 - 0.00261160714285713*G0_1_12_1 + 0.00220982142857142*G0_1_13_0 + 0.00220982142857142*G0_1_13_1 + 0.00281249999999999*G0_1_14_0 + 0.00281249999999999*G0_1_14_1 - 0.0401785714285712*G0_1_15_0 - 0.0401785714285712*G0_1_15_1 + 0.0140624999999999*G0_1_16_0 + 0.0140624999999999*G0_1_16_1 - 0.0200892857142856*G0_1_17_0 - 0.0200892857142856*G0_1_17_1 + 0.0100446428571428*G0_1_18_0 + 0.0100446428571428*G0_1_18_1 - 0.0120535714285714*G0_1_19_0 - 0.0120535714285714*G0_1_19_1;
    A[311] = 0.00234374999999999*G0_0_0_0 - 0.00140625*G0_0_2_0 - 0.00220982142857141*G0_0_3_0 + 0.00261160714285713*G0_0_4_0 + 0.0148660714285714*G0_0_5_0 - 0.00140625*G0_0_6_0 + 0.000200892857142853*G0_0_7_0 - 0.00281249999999998*G0_0_8_0 + 0.00120535714285716*G0_0_9_0 + 0.00234374999999999*G0_1_10_0 - 0.00140625*G0_1_12_0 - 0.00220982142857141*G0_1_13_0 + 0.00261160714285713*G0_1_14_0 + 0.0148660714285714*G0_1_15_0 - 0.00140625*G0_1_16_0 + 0.000200892857142853*G0_1_17_0 - 0.00281249999999998*G0_1_18_0 + 0.00120535714285716*G0_1_19_0;
    A[312] = 0.000334821428571421*G0_0_0_1 - 0.00180803571428571*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 + 0.00683035714285711*G0_0_3_1 - 0.0100446428571428*G0_0_4_1 - 0.00321428571428571*G0_0_5_1 - 0.0140624999999999*G0_0_6_1 + 0.000200892857142842*G0_0_7_1 + 0.00261160714285714*G0_0_8_1 - 0.0096428571428571*G0_0_9_1 + 0.000334821428571421*G0_1_10_1 - 0.00180803571428571*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 + 0.00683035714285711*G0_1_13_1 - 0.0100446428571428*G0_1_14_1 - 0.00321428571428571*G0_1_15_1 - 0.0140624999999999*G0_1_16_1 + 0.000200892857142842*G0_1_17_1 + 0.00261160714285714*G0_1_18_1 - 0.0096428571428571*G0_1_19_1;
    A[313] = -0.00200892857142856*G0_0_0_0 - 0.00100446428571428*G0_0_0_1 + 0.000200892857142859*G0_0_1_0 - 0.00100446428571427*G0_0_1_1 + 0.00602678571428569*G0_0_2_0 - 0.000401785714285713*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 - 0.0072321428571428*G0_0_3_1 - 0.00542410714285714*G0_0_4_0 + 0.00361607142857141*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.00723214285714284*G0_0_5_1 + 0.00542410714285711*G0_0_6_0 + 0.00361607142857141*G0_0_6_1 + 0.00361607142857141*G0_0_7_0 - 0.00180803571428571*G0_0_7_1 - 0.0018080357142857*G0_0_8_0 - 0.00180803571428569*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00200892857142856*G0_1_10_0 - 0.00100446428571428*G0_1_10_1 + 0.000200892857142859*G0_1_11_0 - 0.00100446428571427*G0_1_11_1 + 0.00602678571428569*G0_1_12_0 - 0.000401785714285713*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 - 0.0072321428571428*G0_1_13_1 - 0.00542410714285714*G0_1_14_0 + 0.00361607142857141*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.00723214285714284*G0_1_15_1 + 0.00542410714285711*G0_1_16_0 + 0.00361607142857141*G0_1_16_1 + 0.00361607142857141*G0_1_17_0 - 0.00180803571428571*G0_1_17_1 - 0.0018080357142857*G0_1_18_0 - 0.00180803571428569*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[314] = -0.00502232142857141*G0_0_0_0 - 0.00401785714285713*G0_0_0_1 - 0.00281249999999999*G0_0_1_0 + 0.000200892857142853*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.00100446428571428*G0_0_2_1 + 0.0108482142857142*G0_0_3_0 - 0.0018080357142857*G0_0_3_1 - 0.0271205357142856*G0_0_4_0 - 0.0235044642857142*G0_0_4_1 + 0.0108482142857142*G0_0_5_0 + 0.0144642857142857*G0_0_5_1 - 0.0271205357142856*G0_0_6_0 - 0.01265625*G0_0_6_1 - 0.00180803571428571*G0_0_7_0 + 0.00361607142857142*G0_0_7_1 + 0.00361607142857141*G0_0_8_0 - 0.00180803571428571*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00502232142857141*G0_1_10_0 - 0.00401785714285713*G0_1_10_1 - 0.00281249999999999*G0_1_11_0 + 0.000200892857142853*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.00100446428571428*G0_1_12_1 + 0.0108482142857142*G0_1_13_0 - 0.0018080357142857*G0_1_13_1 - 0.0271205357142856*G0_1_14_0 - 0.0235044642857142*G0_1_14_1 + 0.0108482142857142*G0_1_15_0 + 0.0144642857142857*G0_1_15_1 - 0.0271205357142856*G0_1_16_0 - 0.01265625*G0_1_16_1 - 0.00180803571428571*G0_1_17_0 + 0.00361607142857142*G0_1_17_1 + 0.00361607142857141*G0_1_18_0 - 0.00180803571428571*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[315] = -0.00401785714285709*G0_0_0_0 + 0.0200892857142856*G0_0_0_1 - 0.00743303571428569*G0_0_1_0 - 0.00602678571428567*G0_0_2_0 + 0.00160714285714285*G0_0_2_1 + 0.0108482142857143*G0_0_3_0 + 0.00361607142857141*G0_0_3_1 - 0.00542410714285712*G0_0_4_0 - 0.00723214285714283*G0_0_4_1 - 0.108482142857142*G0_0_5_0 + 0.00542410714285713*G0_0_6_0 - 0.0216964285714285*G0_0_6_1 - 0.0361607142857141*G0_0_7_0 + 0.018080357142857*G0_0_7_1 + 0.0235044642857142*G0_0_8_0 - 0.0036160714285714*G0_0_8_1 - 0.0650892857142855*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.00401785714285709*G0_1_10_0 + 0.0200892857142856*G0_1_10_1 - 0.00743303571428569*G0_1_11_0 - 0.00602678571428567*G0_1_12_0 + 0.00160714285714285*G0_1_12_1 + 0.0108482142857143*G0_1_13_0 + 0.00361607142857141*G0_1_13_1 - 0.00542410714285712*G0_1_14_0 - 0.00723214285714283*G0_1_14_1 - 0.108482142857142*G0_1_15_0 + 0.00542410714285713*G0_1_16_0 - 0.0216964285714285*G0_1_16_1 - 0.0361607142857141*G0_1_17_0 + 0.018080357142857*G0_1_17_1 + 0.0235044642857142*G0_1_18_0 - 0.0036160714285714*G0_1_18_1 - 0.0650892857142855*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[316] = 0.00502232142857141*G0_0_0_0 - 0.00703124999999997*G0_0_0_1 + 0.00281249999999999*G0_0_1_0 + 0.00421874999999999*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.00703124999999996*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 - 0.01265625*G0_0_3_1 + 0.0271205357142856*G0_0_4_0 + 0.0144642857142856*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 + 0.043392857142857*G0_0_5_1 + 0.0271205357142856*G0_0_6_0 + 0.0216964285714285*G0_0_6_1 + 0.00180803571428571*G0_0_7_0 + 0.00180803571428574*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 - 0.00904017857142854*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.0325446428571428*G0_0_9_1 + 0.00502232142857141*G0_1_10_0 - 0.00703124999999997*G0_1_10_1 + 0.00281249999999999*G0_1_11_0 + 0.00421874999999999*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.00703124999999996*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 - 0.01265625*G0_1_13_1 + 0.0271205357142856*G0_1_14_0 + 0.0144642857142856*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 + 0.043392857142857*G0_1_15_1 + 0.0271205357142856*G0_1_16_0 + 0.0216964285714285*G0_1_16_1 + 0.00180803571428571*G0_1_17_0 + 0.00180803571428574*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 - 0.00904017857142854*G0_1_18_1 + 0.0216964285714285*G0_1_19_0 + 0.0325446428571428*G0_1_19_1;
    A[317] = 0.0220982142857142*G0_0_0_0 - 0.00200892857142855*G0_0_0_1 + 0.00361607142857142*G0_0_1_0 - 0.00381696428571427*G0_0_1_1 + 0.00381696428571427*G0_0_2_0 - 0.00381696428571426*G0_0_2_1 - 0.00542410714285712*G0_0_3_0 + 0.00180803571428572*G0_0_3_1 + 0.0018080357142857*G0_0_4_1 + 0.0723214285714283*G0_0_5_0 - 0.0361607142857142*G0_0_5_1 - 0.0144642857142857*G0_0_6_0 + 0.0126562499999999*G0_0_6_1 + 0.0180803571428571*G0_0_7_0 - 0.0361607142857141*G0_0_7_1 - 0.0144642857142856*G0_0_8_0 + 0.0126562499999999*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 - 0.043392857142857*G0_0_9_1 + 0.0220982142857142*G0_1_10_0 - 0.00200892857142855*G0_1_10_1 + 0.00361607142857142*G0_1_11_0 - 0.00381696428571427*G0_1_11_1 + 0.00381696428571427*G0_1_12_0 - 0.00381696428571426*G0_1_12_1 - 0.00542410714285712*G0_1_13_0 + 0.00180803571428572*G0_1_13_1 + 0.0018080357142857*G0_1_14_1 + 0.0723214285714283*G0_1_15_0 - 0.0361607142857142*G0_1_15_1 - 0.0144642857142857*G0_1_16_0 + 0.0126562499999999*G0_1_16_1 + 0.0180803571428571*G0_1_17_0 - 0.0361607142857141*G0_1_17_1 - 0.0144642857142856*G0_1_18_0 + 0.0126562499999999*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 - 0.043392857142857*G0_1_19_1;
    A[318] = -0.0110491071428571*G0_0_0_0 + 0.00100446428571428*G0_0_0_1 - 0.00120535714285715*G0_0_1_0 + 0.00100446428571427*G0_0_1_1 + 0.000200892857142856*G0_0_2_0 + 0.000401785714285712*G0_0_2_1 + 0.00542410714285711*G0_0_3_0 + 0.00723214285714281*G0_0_3_1 - 0.00542410714285711*G0_0_4_0 - 0.0036160714285714*G0_0_4_1 - 0.0470089285714284*G0_0_5_0 + 0.00723214285714282*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 + 0.0018080357142857*G0_0_7_0 + 0.00180803571428571*G0_0_7_1 + 0.00723214285714282*G0_0_8_0 + 0.00180803571428569*G0_0_8_1 + 0.0108482142857142*G0_0_9_1 - 0.0110491071428571*G0_1_10_0 + 0.00100446428571428*G0_1_10_1 - 0.00120535714285715*G0_1_11_0 + 0.00100446428571427*G0_1_11_1 + 0.000200892857142856*G0_1_12_0 + 0.000401785714285712*G0_1_12_1 + 0.00542410714285711*G0_1_13_0 + 0.00723214285714281*G0_1_13_1 - 0.00542410714285711*G0_1_14_0 - 0.0036160714285714*G0_1_14_1 - 0.0470089285714284*G0_1_15_0 + 0.00723214285714282*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 + 0.0018080357142857*G0_1_17_0 + 0.00180803571428571*G0_1_17_1 + 0.00723214285714282*G0_1_18_0 + 0.00180803571428569*G0_1_18_1 + 0.0108482142857142*G0_1_19_1;
    A[319] = 0.00602678571428565*G0_0_0_0 + 0.00602678571428569*G0_0_0_1 + 0.00723214285714283*G0_0_1_0 + 0.00361607142857141*G0_0_1_1 + 0.00482142857142854*G0_0_2_1 + 0.0108482142857143*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.130178571428571*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 + 0.0325446428571427*G0_0_7_0 + 0.0325446428571427*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 + 0.086785714285714*G0_0_9_0 + 0.0650892857142855*G0_0_9_1 + 0.00602678571428565*G0_1_10_0 + 0.00602678571428569*G0_1_10_1 + 0.00723214285714283*G0_1_11_0 + 0.00361607142857141*G0_1_11_1 + 0.00482142857142854*G0_1_12_1 + 0.0108482142857143*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.130178571428571*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 + 0.0325446428571427*G0_1_17_0 + 0.0325446428571427*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 + 0.086785714285714*G0_1_19_0 + 0.0650892857142855*G0_1_19_1;
    A[320] = 0;
    A[321] = 0;
    A[322] = 0;
    A[323] = 0;
    A[324] = 0;
    A[325] = 0;
    A[326] = 0;
    A[327] = 0;
    A[328] = 0;
    A[329] = 0;
    A[330] = 0.00602678571428568*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 + 0.00180803571428571*G0_0_1_0 + 0.00180803571428571*G0_0_1_1 - 0.000334821428571433*G0_0_2_0 - 0.000334821428571433*G0_0_2_1 - 0.00261160714285713*G0_0_3_0 - 0.00261160714285713*G0_0_3_1 - 0.00020089285714285*G0_0_4_0 - 0.000200892857142851*G0_0_4_1 + 0.0140624999999999*G0_0_5_0 + 0.0140624999999999*G0_0_5_1 + 0.00321428571428572*G0_0_6_0 + 0.00321428571428573*G0_0_6_1 + 0.0100446428571428*G0_0_7_0 + 0.0100446428571428*G0_0_7_1 - 0.00683035714285711*G0_0_8_0 - 0.00683035714285711*G0_0_8_1 + 0.00964285714285711*G0_0_9_0 + 0.00964285714285712*G0_0_9_1 + 0.00602678571428568*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 + 0.00180803571428571*G0_1_11_0 + 0.00180803571428571*G0_1_11_1 - 0.000334821428571433*G0_1_12_0 - 0.000334821428571433*G0_1_12_1 - 0.00261160714285713*G0_1_13_0 - 0.00261160714285713*G0_1_13_1 - 0.00020089285714285*G0_1_14_0 - 0.000200892857142851*G0_1_14_1 + 0.0140624999999999*G0_1_15_0 + 0.0140624999999999*G0_1_15_1 + 0.00321428571428572*G0_1_16_0 + 0.00321428571428573*G0_1_16_1 + 0.0100446428571428*G0_1_17_0 + 0.0100446428571428*G0_1_17_1 - 0.00683035714285711*G0_1_18_0 - 0.00683035714285711*G0_1_18_1 + 0.00964285714285711*G0_1_19_0 + 0.00964285714285712*G0_1_19_1;
    A[331] = -0.00140624999999999*G0_0_0_0 + 0.00234374999999999*G0_0_2_0 - 0.00281249999999999*G0_0_3_0 + 0.000200892857142853*G0_0_4_0 - 0.00140624999999999*G0_0_5_0 + 0.0148660714285714*G0_0_6_0 + 0.00261160714285713*G0_0_7_0 - 0.00220982142857142*G0_0_8_0 + 0.00120535714285713*G0_0_9_0 - 0.00140624999999999*G0_1_10_0 + 0.00234374999999999*G0_1_12_0 - 0.00281249999999999*G0_1_13_0 + 0.000200892857142853*G0_1_14_0 - 0.00140624999999999*G0_1_15_0 + 0.0148660714285714*G0_1_16_0 + 0.00261160714285713*G0_1_17_0 - 0.00220982142857142*G0_1_18_0 + 0.00120535714285713*G0_1_19_0;
    A[332] = 0.00261160714285714*G0_0_0_1 + 0.00241071428571428*G0_0_1_1 + 0.0133928571428571*G0_0_2_1 - 0.0100446428571428*G0_0_3_1 + 0.0200892857142856*G0_0_4_1 - 0.0140624999999999*G0_0_5_1 + 0.0401785714285713*G0_0_6_1 - 0.00281249999999998*G0_0_7_1 - 0.00220982142857142*G0_0_8_1 + 0.0120535714285714*G0_0_9_1 + 0.00261160714285714*G0_1_10_1 + 0.00241071428571428*G0_1_11_1 + 0.0133928571428571*G0_1_12_1 - 0.0100446428571428*G0_1_13_1 + 0.0200892857142856*G0_1_14_1 - 0.0140624999999999*G0_1_15_1 + 0.0401785714285713*G0_1_16_1 - 0.00281249999999998*G0_1_17_1 - 0.00220982142857142*G0_1_18_1 + 0.0120535714285714*G0_1_19_1;
    A[333] = -0.000200892857142856*G0_0_0_0 - 0.000401785714285713*G0_0_0_1 - 0.00220982142857142*G0_0_1_0 - 0.00100446428571428*G0_0_1_1 - 0.0120535714285714*G0_0_2_0 - 0.00100446428571427*G0_0_2_1 + 0.0054241071428571*G0_0_3_0 - 0.00180803571428572*G0_0_3_1 - 0.00180803571428571*G0_0_4_1 + 0.00542410714285711*G0_0_5_0 + 0.00361607142857141*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 - 0.00723214285714284*G0_0_6_1 - 0.00180803571428571*G0_0_7_0 + 0.00361607142857141*G0_0_7_1 - 0.00180803571428571*G0_0_8_0 - 0.00723214285714283*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0108482142857143*G0_0_9_1 - 0.000200892857142856*G0_1_10_0 - 0.000401785714285713*G0_1_10_1 - 0.00220982142857142*G0_1_11_0 - 0.00100446428571428*G0_1_11_1 - 0.0120535714285714*G0_1_12_0 - 0.00100446428571427*G0_1_12_1 + 0.0054241071428571*G0_1_13_0 - 0.00180803571428572*G0_1_13_1 - 0.00180803571428571*G0_1_14_1 + 0.00542410714285711*G0_1_15_0 + 0.00361607142857141*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 - 0.00723214285714284*G0_1_16_1 - 0.00180803571428571*G0_1_17_0 + 0.00361607142857141*G0_1_17_1 - 0.00180803571428571*G0_1_18_0 - 0.00723214285714283*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0108482142857143*G0_1_19_1;
    A[334] = 0.00763392857142854*G0_0_0_0 + 0.00381696428571428*G0_0_0_1 + 0.0074330357142857*G0_0_1_0 + 0.00381696428571428*G0_0_1_1 + 0.0241071428571427*G0_0_2_0 + 0.00200892857142856*G0_0_2_1 - 0.0271205357142856*G0_0_3_0 - 0.01265625*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0361607142857142*G0_0_4_1 - 0.0271205357142856*G0_0_5_0 - 0.01265625*G0_0_5_1 + 0.108482142857142*G0_0_6_0 + 0.0361607142857142*G0_0_6_1 - 0.0018080357142857*G0_0_7_0 - 0.00180803571428571*G0_0_7_1 - 0.00723214285714282*G0_0_8_0 - 0.00180803571428571*G0_0_8_1 + 0.0542410714285712*G0_0_9_0 + 0.043392857142857*G0_0_9_1 + 0.00763392857142854*G0_1_10_0 + 0.00381696428571428*G0_1_10_1 + 0.0074330357142857*G0_1_11_0 + 0.00381696428571428*G0_1_11_1 + 0.0241071428571427*G0_1_12_0 + 0.00200892857142856*G0_1_12_1 - 0.0271205357142856*G0_1_13_0 - 0.01265625*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0361607142857142*G0_1_14_1 - 0.0271205357142856*G0_1_15_0 - 0.01265625*G0_1_15_1 + 0.108482142857142*G0_1_16_0 + 0.0361607142857142*G0_1_16_1 - 0.0018080357142857*G0_1_17_0 - 0.00180803571428571*G0_1_17_1 - 0.00723214285714282*G0_1_18_0 - 0.00180803571428571*G0_1_18_1 + 0.0542410714285712*G0_1_19_0 + 0.043392857142857*G0_1_19_1;
    A[335] = 0.0050223214285714*G0_0_0_0 - 0.00703124999999995*G0_0_0_1 - 0.00140625*G0_0_1_0 - 0.00421874999999999*G0_0_1_1 + 0.0120535714285714*G0_0_2_0 + 0.00703124999999999*G0_0_2_1 + 0.00542410714285713*G0_0_3_0 + 0.00904017857142854*G0_0_3_1 - 0.00180803571428572*G0_0_4_1 + 0.00542410714285713*G0_0_5_0 - 0.0216964285714285*G0_0_5_1 - 0.0542410714285713*G0_0_6_0 - 0.043392857142857*G0_0_6_1 + 0.0126562499999999*G0_0_7_0 - 0.0144642857142856*G0_0_7_1 + 0.00180803571428571*G0_0_8_0 + 0.0126562499999999*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0325446428571427*G0_0_9_1 + 0.0050223214285714*G0_1_10_0 - 0.00703124999999995*G0_1_10_1 - 0.00140625*G0_1_11_0 - 0.00421874999999999*G0_1_11_1 + 0.0120535714285714*G0_1_12_0 + 0.00703124999999999*G0_1_12_1 + 0.00542410714285713*G0_1_13_0 + 0.00904017857142854*G0_1_13_1 - 0.00180803571428572*G0_1_14_1 + 0.00542410714285713*G0_1_15_0 - 0.0216964285714285*G0_1_15_1 - 0.0542410714285713*G0_1_16_0 - 0.043392857142857*G0_1_16_1 + 0.0126562499999999*G0_1_17_0 - 0.0144642857142856*G0_1_17_1 + 0.00180803571428571*G0_1_18_0 + 0.0126562499999999*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0325446428571427*G0_1_19_1;
    A[336] = -0.00763392857142855*G0_0_0_0 - 0.00160714285714286*G0_0_0_1 - 0.0074330357142857*G0_0_1_0 - 0.0241071428571427*G0_0_2_0 - 0.0200892857142856*G0_0_2_1 + 0.0271205357142856*G0_0_3_0 + 0.0036160714285714*G0_0_3_1 - 0.0542410714285712*G0_0_4_0 - 0.0180803571428571*G0_0_4_1 + 0.0271205357142856*G0_0_5_0 + 0.0216964285714285*G0_0_5_1 - 0.108482142857142*G0_0_6_0 + 0.0018080357142857*G0_0_7_0 + 0.0072321428571428*G0_0_7_1 + 0.00723214285714282*G0_0_8_0 - 0.00361607142857141*G0_0_8_1 - 0.0542410714285712*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 - 0.00763392857142855*G0_1_10_0 - 0.00160714285714286*G0_1_10_1 - 0.0074330357142857*G0_1_11_0 - 0.0241071428571427*G0_1_12_0 - 0.0200892857142856*G0_1_12_1 + 0.0271205357142856*G0_1_13_0 + 0.0036160714285714*G0_1_13_1 - 0.0542410714285712*G0_1_14_0 - 0.0180803571428571*G0_1_14_1 + 0.0271205357142856*G0_1_15_0 + 0.0216964285714285*G0_1_15_1 - 0.108482142857142*G0_1_16_0 + 0.0018080357142857*G0_1_17_0 + 0.0072321428571428*G0_1_17_1 + 0.00723214285714282*G0_1_18_0 - 0.00361607142857141*G0_1_18_1 - 0.0542410714285712*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[337] = -0.0110491071428571*G0_0_0_0 + 0.00100446428571427*G0_0_0_1 - 0.00301339285714285*G0_0_1_0 - 0.000200892857142861*G0_0_1_1 - 0.00100446428571429*G0_0_2_0 + 0.00401785714285712*G0_0_2_1 + 0.00542410714285712*G0_0_3_0 + 0.0018080357142857*G0_0_3_1 - 0.00542410714285713*G0_0_4_0 - 0.00361607142857141*G0_0_4_1 - 0.0144642857142857*G0_0_5_0 + 0.0126562499999999*G0_0_5_1 - 0.00361607142857146*G0_0_6_0 - 0.0144642857142857*G0_0_6_1 - 0.00361607142857142*G0_0_7_0 + 0.0235044642857142*G0_0_7_1 + 0.0126562499999999*G0_0_8_0 + 0.00180803571428571*G0_0_8_1 + 0.0216964285714285*G0_0_9_1 - 0.0110491071428571*G0_1_10_0 + 0.00100446428571427*G0_1_10_1 - 0.00301339285714285*G0_1_11_0 - 0.000200892857142861*G0_1_11_1 - 0.00100446428571429*G0_1_12_0 + 0.00401785714285712*G0_1_12_1 + 0.00542410714285712*G0_1_13_0 + 0.0018080357142857*G0_1_13_1 - 0.00542410714285713*G0_1_14_0 - 0.00361607142857141*G0_1_14_1 - 0.0144642857142857*G0_1_15_0 + 0.0126562499999999*G0_1_15_1 - 0.00361607142857146*G0_1_16_0 - 0.0144642857142857*G0_1_16_1 - 0.00361607142857142*G0_1_17_0 + 0.0235044642857142*G0_1_17_1 + 0.0126562499999999*G0_1_18_0 + 0.00180803571428571*G0_1_18_1 + 0.0216964285714285*G0_1_19_1;
    A[338] = 0.0064285714285714*G0_0_0_0 + 0.000401785714285714*G0_0_0_1 + 0.00120535714285714*G0_0_1_0 + 0.00100446428571428*G0_0_1_1 - 0.00100446428571427*G0_0_2_0 + 0.00100446428571428*G0_0_2_1 + 0.00180803571428572*G0_0_3_1 + 0.00542410714285712*G0_0_4_0 + 0.0018080357142857*G0_0_4_1 + 0.00180803571428571*G0_0_5_0 - 0.00361607142857141*G0_0_5_1 - 0.0144642857142856*G0_0_6_0 + 0.00723214285714284*G0_0_6_1 - 0.00904017857142852*G0_0_7_0 - 0.00361607142857142*G0_0_7_1 - 0.00361607142857141*G0_0_8_0 + 0.00723214285714283*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 + 0.0108482142857143*G0_0_9_1 + 0.0064285714285714*G0_1_10_0 + 0.000401785714285714*G0_1_10_1 + 0.00120535714285714*G0_1_11_0 + 0.00100446428571428*G0_1_11_1 - 0.00100446428571427*G0_1_12_0 + 0.00100446428571428*G0_1_12_1 + 0.00180803571428572*G0_1_13_1 + 0.00542410714285712*G0_1_14_0 + 0.0018080357142857*G0_1_14_1 + 0.00180803571428571*G0_1_15_0 - 0.00361607142857141*G0_1_15_1 - 0.0144642857142856*G0_1_16_0 + 0.00723214285714284*G0_1_16_1 - 0.00904017857142852*G0_1_17_0 - 0.00361607142857142*G0_1_17_1 - 0.00361607142857141*G0_1_18_0 + 0.00723214285714283*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 + 0.0108482142857143*G0_1_19_1;
    A[339] = -0.00482142857142855*G0_0_0_0 - 0.00482142857142855*G0_0_0_1 + 0.00361607142857142*G0_0_1_0 - 0.00361607142857142*G0_0_1_1 - 0.00602678571428568*G0_0_2_1 - 0.0108482142857142*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 - 0.0325446428571428*G0_0_4_1 - 0.0108482142857142*G0_0_5_0 + 0.108482142857142*G0_0_6_0 - 0.0216964285714285*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0216964285714284*G0_0_7_1 + 0.0216964285714285*G0_0_9_0 - 0.0650892857142855*G0_0_9_1 - 0.00482142857142855*G0_1_10_0 - 0.00482142857142855*G0_1_10_1 + 0.00361607142857142*G0_1_11_0 - 0.00361607142857142*G0_1_11_1 - 0.00602678571428568*G0_1_12_1 - 0.0108482142857142*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 - 0.0325446428571428*G0_1_14_1 - 0.0108482142857142*G0_1_15_0 + 0.108482142857142*G0_1_16_0 - 0.0216964285714285*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0216964285714284*G0_1_17_1 + 0.0216964285714285*G0_1_19_0 - 0.0650892857142855*G0_1_19_1;
    A[340] = 0;
    A[341] = 0;
    A[342] = 0;
    A[343] = 0;
    A[344] = 0;
    A[345] = 0;
    A[346] = 0;
    A[347] = 0;
    A[348] = 0;
    A[349] = 0;
    A[350] = -0.0133928571428571*G0_0_0_0 - 0.0133928571428571*G0_0_0_1 - 0.00261160714285713*G0_0_1_0 - 0.00261160714285713*G0_0_1_1 - 0.00241071428571427*G0_0_2_0 - 0.00241071428571427*G0_0_2_1 + 0.00281249999999998*G0_0_3_0 + 0.00281249999999999*G0_0_3_1 + 0.00220982142857142*G0_0_4_0 + 0.00220982142857142*G0_0_4_1 - 0.0200892857142856*G0_0_5_0 - 0.0200892857142856*G0_0_5_1 + 0.0100446428571428*G0_0_6_0 + 0.0100446428571428*G0_0_6_1 - 0.0401785714285712*G0_0_7_0 - 0.0401785714285712*G0_0_7_1 + 0.0140624999999999*G0_0_8_0 + 0.0140624999999999*G0_0_8_1 - 0.0120535714285714*G0_0_9_0 - 0.0120535714285714*G0_0_9_1 - 0.0133928571428571*G0_1_10_0 - 0.0133928571428571*G0_1_10_1 - 0.00261160714285713*G0_1_11_0 - 0.00261160714285713*G0_1_11_1 - 0.00241071428571427*G0_1_12_0 - 0.00241071428571427*G0_1_12_1 + 0.00281249999999998*G0_1_13_0 + 0.00281249999999999*G0_1_13_1 + 0.00220982142857142*G0_1_14_0 + 0.00220982142857142*G0_1_14_1 - 0.0200892857142856*G0_1_15_0 - 0.0200892857142856*G0_1_15_1 + 0.0100446428571428*G0_1_16_0 + 0.0100446428571428*G0_1_16_1 - 0.0401785714285712*G0_1_17_0 - 0.0401785714285712*G0_1_17_1 + 0.0140624999999999*G0_1_18_0 + 0.0140624999999999*G0_1_18_1 - 0.0120535714285714*G0_1_19_0 - 0.0120535714285714*G0_1_19_1;
    A[351] = 0.000334821428571429*G0_0_0_0 - 0.00602678571428568*G0_0_1_0 - 0.0018080357142857*G0_0_2_0 - 0.0100446428571428*G0_0_3_0 + 0.00683035714285711*G0_0_4_0 + 0.000200892857142854*G0_0_5_0 + 0.00261160714285713*G0_0_6_0 - 0.0032142857142857*G0_0_7_0 - 0.0140624999999999*G0_0_8_0 - 0.00964285714285709*G0_0_9_0 + 0.000334821428571429*G0_1_10_0 - 0.00602678571428568*G0_1_11_0 - 0.0018080357142857*G0_1_12_0 - 0.0100446428571428*G0_1_13_0 + 0.00683035714285711*G0_1_14_0 + 0.000200892857142854*G0_1_15_0 + 0.00261160714285713*G0_1_16_0 - 0.0032142857142857*G0_1_17_0 - 0.0140624999999999*G0_1_18_0 - 0.00964285714285709*G0_1_19_0;
    A[352] = 0.00234374999999998*G0_0_0_1 - 0.00140625*G0_0_1_1 + 0.00261160714285714*G0_0_3_1 - 0.00220982142857142*G0_0_4_1 + 0.000200892857142842*G0_0_5_1 - 0.00281249999999998*G0_0_6_1 + 0.0148660714285713*G0_0_7_1 - 0.00140624999999998*G0_0_8_1 + 0.00120535714285713*G0_0_9_1 + 0.00234374999999998*G0_1_10_1 - 0.00140625*G0_1_11_1 + 0.00261160714285714*G0_1_13_1 - 0.00220982142857142*G0_1_14_1 + 0.000200892857142842*G0_1_15_1 - 0.00281249999999998*G0_1_16_1 + 0.0148660714285713*G0_1_17_1 - 0.00140624999999998*G0_1_18_1 + 0.00120535714285713*G0_1_19_1;
    A[353] = -0.00401785714285713*G0_0_0_0 - 0.0050223214285714*G0_0_0_1 - 0.00100446428571428*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 + 0.000200892857142856*G0_0_2_0 - 0.00281249999999998*G0_0_2_1 - 0.0235044642857142*G0_0_3_0 - 0.0271205357142856*G0_0_3_1 - 0.0018080357142857*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 + 0.00361607142857141*G0_0_5_0 - 0.00180803571428571*G0_0_5_1 - 0.00180803571428571*G0_0_6_0 + 0.00361607142857141*G0_0_6_1 + 0.0144642857142856*G0_0_7_0 + 0.0108482142857143*G0_0_7_1 - 0.01265625*G0_0_8_0 - 0.0271205357142856*G0_0_8_1 - 0.0216964285714285*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00401785714285713*G0_1_10_0 - 0.0050223214285714*G0_1_10_1 - 0.00100446428571428*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 + 0.000200892857142856*G0_1_12_0 - 0.00281249999999998*G0_1_12_1 - 0.0235044642857142*G0_1_13_0 - 0.0271205357142856*G0_1_13_1 - 0.0018080357142857*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 + 0.00361607142857141*G0_1_15_0 - 0.00180803571428571*G0_1_15_1 - 0.00180803571428571*G0_1_16_0 + 0.00361607142857141*G0_1_16_1 + 0.0144642857142856*G0_1_17_0 + 0.0108482142857143*G0_1_17_1 - 0.01265625*G0_1_18_0 - 0.0271205357142856*G0_1_18_1 - 0.0216964285714285*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[354] = -0.00100446428571428*G0_0_0_0 - 0.00200892857142857*G0_0_0_1 - 0.000401785714285714*G0_0_1_0 + 0.00602678571428569*G0_0_1_1 - 0.00100446428571428*G0_0_2_0 + 0.000200892857142858*G0_0_2_1 + 0.00361607142857142*G0_0_3_0 - 0.00542410714285712*G0_0_3_1 - 0.00723214285714284*G0_0_4_0 - 0.0108482142857143*G0_0_4_1 - 0.00180803571428571*G0_0_5_0 + 0.00361607142857142*G0_0_5_1 - 0.0018080357142857*G0_0_6_0 - 0.00180803571428571*G0_0_6_1 - 0.00723214285714285*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 + 0.00361607142857142*G0_0_8_0 + 0.00542410714285712*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 - 0.0216964285714285*G0_0_9_1 - 0.00100446428571428*G0_1_10_0 - 0.00200892857142857*G0_1_10_1 - 0.000401785714285714*G0_1_11_0 + 0.00602678571428569*G0_1_11_1 - 0.00100446428571428*G0_1_12_0 + 0.000200892857142858*G0_1_12_1 + 0.00361607142857142*G0_1_13_0 - 0.00542410714285712*G0_1_13_1 - 0.00723214285714284*G0_1_14_0 - 0.0108482142857143*G0_1_14_1 - 0.00180803571428571*G0_1_15_0 + 0.00361607142857142*G0_1_15_1 - 0.0018080357142857*G0_1_16_0 - 0.00180803571428571*G0_1_16_1 - 0.00723214285714285*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 + 0.00361607142857142*G0_1_18_0 + 0.00542410714285712*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 - 0.0216964285714285*G0_1_19_1;
    A[355] = -0.00200892857142855*G0_0_0_0 + 0.0220982142857142*G0_0_0_1 - 0.00381696428571427*G0_0_1_0 + 0.00381696428571426*G0_0_1_1 - 0.00381696428571426*G0_0_2_0 + 0.0036160714285714*G0_0_2_1 + 0.0018080357142857*G0_0_3_0 + 0.00180803571428571*G0_0_4_0 - 0.00542410714285712*G0_0_4_1 - 0.0361607142857141*G0_0_5_0 + 0.018080357142857*G0_0_5_1 + 0.0126562499999999*G0_0_6_0 - 0.0144642857142856*G0_0_6_1 - 0.0361607142857141*G0_0_7_0 + 0.0723214285714282*G0_0_7_1 + 0.0126562499999999*G0_0_8_0 - 0.0144642857142856*G0_0_8_1 - 0.043392857142857*G0_0_9_0 + 0.0108482142857142*G0_0_9_1 - 0.00200892857142855*G0_1_10_0 + 0.0220982142857142*G0_1_10_1 - 0.00381696428571427*G0_1_11_0 + 0.00381696428571426*G0_1_11_1 - 0.00381696428571426*G0_1_12_0 + 0.0036160714285714*G0_1_12_1 + 0.0018080357142857*G0_1_13_0 + 0.00180803571428571*G0_1_14_0 - 0.00542410714285712*G0_1_14_1 - 0.0361607142857141*G0_1_15_0 + 0.018080357142857*G0_1_15_1 + 0.0126562499999999*G0_1_16_0 - 0.0144642857142856*G0_1_16_1 - 0.0361607142857141*G0_1_17_0 + 0.0723214285714282*G0_1_17_1 + 0.0126562499999999*G0_1_18_0 - 0.0144642857142856*G0_1_18_1 - 0.043392857142857*G0_1_19_0 + 0.0108482142857142*G0_1_19_1;
    A[356] = 0.00100446428571429*G0_0_0_0 - 0.0110491071428571*G0_0_0_1 + 0.000401785714285715*G0_0_1_0 + 0.000200892857142867*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 - 0.00120535714285713*G0_0_2_1 - 0.00361607142857141*G0_0_3_0 - 0.00542410714285711*G0_0_3_1 + 0.00723214285714284*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 + 0.00180803571428571*G0_0_5_0 + 0.00180803571428574*G0_0_5_1 + 0.0018080357142857*G0_0_6_0 + 0.0072321428571428*G0_0_6_1 + 0.00723214285714284*G0_0_7_0 - 0.0470089285714283*G0_0_7_1 - 0.00361607142857142*G0_0_8_0 + 0.0018080357142857*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 + 0.00100446428571429*G0_1_10_0 - 0.0110491071428571*G0_1_10_1 + 0.000401785714285715*G0_1_11_0 + 0.000200892857142867*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 - 0.00120535714285713*G0_1_12_1 - 0.00361607142857141*G0_1_13_0 - 0.00542410714285711*G0_1_13_1 + 0.00723214285714284*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 + 0.00180803571428571*G0_1_15_0 + 0.00180803571428574*G0_1_15_1 + 0.0018080357142857*G0_1_16_0 + 0.0072321428571428*G0_1_16_1 + 0.00723214285714284*G0_1_17_0 - 0.0470089285714283*G0_1_17_1 - 0.00361607142857142*G0_1_18_0 + 0.0018080357142857*G0_1_18_1 + 0.0108482142857143*G0_1_19_0;
    A[357] = 0.0200892857142856*G0_0_0_0 - 0.00401785714285711*G0_0_0_1 + 0.00160714285714286*G0_0_1_0 - 0.00602678571428568*G0_0_1_1 - 0.00743303571428566*G0_0_2_1 - 0.00723214285714282*G0_0_3_0 - 0.00542410714285712*G0_0_3_1 + 0.00361607142857141*G0_0_4_0 + 0.0108482142857142*G0_0_4_1 + 0.0180803571428571*G0_0_5_0 - 0.0361607142857141*G0_0_5_1 - 0.00361607142857142*G0_0_6_0 + 0.0235044642857141*G0_0_6_1 - 0.108482142857142*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 + 0.00542410714285711*G0_0_8_1 - 0.0108482142857142*G0_0_9_0 - 0.0650892857142854*G0_0_9_1 + 0.0200892857142856*G0_1_10_0 - 0.00401785714285711*G0_1_10_1 + 0.00160714285714286*G0_1_11_0 - 0.00602678571428568*G0_1_11_1 - 0.00743303571428566*G0_1_12_1 - 0.00723214285714282*G0_1_13_0 - 0.00542410714285712*G0_1_13_1 + 0.00361607142857141*G0_1_14_0 + 0.0108482142857142*G0_1_14_1 + 0.0180803571428571*G0_1_15_0 - 0.0361607142857141*G0_1_15_1 - 0.00361607142857142*G0_1_16_0 + 0.0235044642857141*G0_1_16_1 - 0.108482142857142*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 + 0.00542410714285711*G0_1_18_1 - 0.0108482142857142*G0_1_19_0 - 0.0650892857142854*G0_1_19_1;
    A[358] = -0.00703124999999997*G0_0_0_0 + 0.0050223214285714*G0_0_0_1 + 0.00703124999999996*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 + 0.00421874999999997*G0_0_2_0 + 0.00281249999999999*G0_0_2_1 + 0.0144642857142856*G0_0_3_0 + 0.0271205357142856*G0_0_3_1 - 0.0126562499999999*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 + 0.0018080357142857*G0_0_5_0 + 0.00180803571428571*G0_0_5_1 - 0.00904017857142852*G0_0_6_0 - 0.00361607142857142*G0_0_6_1 + 0.0433928571428569*G0_0_7_0 - 0.0108482142857142*G0_0_7_1 + 0.0216964285714285*G0_0_8_0 + 0.0271205357142856*G0_0_8_1 + 0.0325446428571427*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00703124999999997*G0_1_10_0 + 0.0050223214285714*G0_1_10_1 + 0.00703124999999996*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 + 0.00421874999999997*G0_1_12_0 + 0.00281249999999999*G0_1_12_1 + 0.0144642857142856*G0_1_13_0 + 0.0271205357142856*G0_1_13_1 - 0.0126562499999999*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 + 0.0018080357142857*G0_1_15_0 + 0.00180803571428571*G0_1_15_1 - 0.00904017857142852*G0_1_16_0 - 0.00361607142857142*G0_1_16_1 + 0.0433928571428569*G0_1_17_0 - 0.0108482142857142*G0_1_17_1 + 0.0216964285714285*G0_1_18_0 + 0.0271205357142856*G0_1_18_1 + 0.0325446428571427*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[359] = 0.00602678571428567*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 + 0.00482142857142855*G0_0_1_0 + 0.0036160714285714*G0_0_2_0 + 0.00723214285714281*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0108482142857142*G0_0_3_1 + 0.0325446428571427*G0_0_5_0 + 0.0325446428571427*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 - 0.0216964285714284*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.130178571428571*G0_0_7_1 - 0.0108482142857142*G0_0_8_1 + 0.0650892857142855*G0_0_9_0 + 0.0867857142857139*G0_0_9_1 + 0.00602678571428567*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 + 0.00482142857142855*G0_1_11_0 + 0.0036160714285714*G0_1_12_0 + 0.00723214285714281*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0108482142857142*G0_1_13_1 + 0.0325446428571427*G0_1_15_0 + 0.0325446428571427*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 - 0.0216964285714284*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.130178571428571*G0_1_17_1 - 0.0108482142857142*G0_1_18_1 + 0.0650892857142855*G0_1_19_0 + 0.0867857142857139*G0_1_19_1;
    A[360] = 0;
    A[361] = 0;
    A[362] = 0;
    A[363] = 0;
    A[364] = 0;
    A[365] = 0;
    A[366] = 0;
    A[367] = 0;
    A[368] = 0;
    A[369] = 0;
    A[370] = 0.00602678571428568*G0_0_0_0 + 0.00602678571428568*G0_0_0_1 - 0.000334821428571427*G0_0_1_0 - 0.000334821428571429*G0_0_1_1 + 0.0018080357142857*G0_0_2_0 + 0.0018080357142857*G0_0_2_1 - 0.000200892857142849*G0_0_3_0 - 0.000200892857142852*G0_0_3_1 - 0.00261160714285713*G0_0_4_0 - 0.00261160714285713*G0_0_4_1 + 0.0100446428571428*G0_0_5_0 + 0.0100446428571428*G0_0_5_1 - 0.00683035714285711*G0_0_6_0 - 0.00683035714285711*G0_0_6_1 + 0.0140624999999999*G0_0_7_0 + 0.0140624999999999*G0_0_7_1 + 0.00321428571428571*G0_0_8_0 + 0.0032142857142857*G0_0_8_1 + 0.00964285714285712*G0_0_9_0 + 0.00964285714285712*G0_0_9_1 + 0.00602678571428568*G0_1_10_0 + 0.00602678571428568*G0_1_10_1 - 0.000334821428571427*G0_1_11_0 - 0.000334821428571429*G0_1_11_1 + 0.0018080357142857*G0_1_12_0 + 0.0018080357142857*G0_1_12_1 - 0.000200892857142849*G0_1_13_0 - 0.000200892857142852*G0_1_13_1 - 0.00261160714285713*G0_1_14_0 - 0.00261160714285713*G0_1_14_1 + 0.0100446428571428*G0_1_15_0 + 0.0100446428571428*G0_1_15_1 - 0.00683035714285711*G0_1_16_0 - 0.00683035714285711*G0_1_16_1 + 0.0140624999999999*G0_1_17_0 + 0.0140624999999999*G0_1_17_1 + 0.00321428571428571*G0_1_18_0 + 0.0032142857142857*G0_1_18_1 + 0.00964285714285712*G0_1_19_0 + 0.00964285714285712*G0_1_19_1;
    A[371] = 0.00261160714285713*G0_0_0_0 + 0.0133928571428571*G0_0_1_0 + 0.00241071428571427*G0_0_2_0 + 0.0200892857142856*G0_0_3_0 - 0.0100446428571428*G0_0_4_0 - 0.00281249999999998*G0_0_5_0 - 0.00220982142857142*G0_0_6_0 - 0.0140624999999999*G0_0_7_0 + 0.0401785714285712*G0_0_8_0 + 0.0120535714285714*G0_0_9_0 + 0.00261160714285713*G0_1_10_0 + 0.0133928571428571*G0_1_11_0 + 0.00241071428571427*G0_1_12_0 + 0.0200892857142856*G0_1_13_0 - 0.0100446428571428*G0_1_14_0 - 0.00281249999999998*G0_1_15_0 - 0.00220982142857142*G0_1_16_0 - 0.0140624999999999*G0_1_17_0 + 0.0401785714285712*G0_1_18_0 + 0.0120535714285714*G0_1_19_0;
    A[372] = -0.00140624999999999*G0_0_0_1 + 0.00234374999999999*G0_0_1_1 + 0.000200892857142846*G0_0_3_1 - 0.00281249999999998*G0_0_4_1 + 0.00261160714285714*G0_0_5_1 - 0.00220982142857142*G0_0_6_1 - 0.00140624999999998*G0_0_7_1 + 0.0148660714285713*G0_0_8_1 + 0.00120535714285712*G0_0_9_1 - 0.00140624999999999*G0_1_10_1 + 0.00234374999999999*G0_1_11_1 + 0.000200892857142846*G0_1_13_1 - 0.00281249999999998*G0_1_14_1 + 0.00261160714285714*G0_1_15_1 - 0.00220982142857142*G0_1_16_1 - 0.00140624999999998*G0_1_17_1 + 0.0148660714285713*G0_1_18_1 + 0.00120535714285712*G0_1_19_1;
    A[373] = 0.00381696428571427*G0_0_0_0 + 0.00763392857142852*G0_0_0_1 + 0.00200892857142856*G0_0_1_0 + 0.0241071428571427*G0_0_1_1 + 0.00381696428571427*G0_0_2_0 + 0.00743303571428567*G0_0_2_1 + 0.0361607142857141*G0_0_3_0 + 0.0542410714285711*G0_0_3_1 - 0.01265625*G0_0_4_0 - 0.0271205357142856*G0_0_4_1 - 0.0018080357142857*G0_0_5_0 - 0.00180803571428569*G0_0_5_1 - 0.00180803571428571*G0_0_6_0 - 0.00723214285714283*G0_0_6_1 - 0.01265625*G0_0_7_0 - 0.0271205357142856*G0_0_7_1 + 0.0361607142857141*G0_0_8_0 + 0.108482142857142*G0_0_8_1 + 0.043392857142857*G0_0_9_0 + 0.0542410714285712*G0_0_9_1 + 0.00381696428571427*G0_1_10_0 + 0.00763392857142852*G0_1_10_1 + 0.00200892857142856*G0_1_11_0 + 0.0241071428571427*G0_1_11_1 + 0.00381696428571427*G0_1_12_0 + 0.00743303571428567*G0_1_12_1 + 0.0361607142857141*G0_1_13_0 + 0.0542410714285711*G0_1_13_1 - 0.01265625*G0_1_14_0 - 0.0271205357142856*G0_1_14_1 - 0.0018080357142857*G0_1_15_0 - 0.00180803571428569*G0_1_15_1 - 0.00180803571428571*G0_1_16_0 - 0.00723214285714283*G0_1_16_1 - 0.01265625*G0_1_17_0 - 0.0271205357142856*G0_1_17_1 + 0.0361607142857141*G0_1_18_0 + 0.108482142857142*G0_1_18_1 + 0.043392857142857*G0_1_19_0 + 0.0542410714285712*G0_1_19_1;
    A[374] = -0.000401785714285711*G0_0_0_0 - 0.000200892857142846*G0_0_0_1 - 0.00100446428571428*G0_0_1_0 - 0.0120535714285714*G0_0_1_1 - 0.00100446428571428*G0_0_2_0 - 0.00220982142857141*G0_0_2_1 - 0.00180803571428572*G0_0_3_0 - 0.0018080357142857*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 + 0.00361607142857141*G0_0_5_0 - 0.00180803571428571*G0_0_5_1 - 0.00723214285714282*G0_0_6_0 - 0.00180803571428571*G0_0_6_1 + 0.00361607142857142*G0_0_7_0 + 0.00542410714285712*G0_0_7_1 - 0.00723214285714284*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 - 0.0108482142857143*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 - 0.000401785714285711*G0_1_10_0 - 0.000200892857142846*G0_1_10_1 - 0.00100446428571428*G0_1_11_0 - 0.0120535714285714*G0_1_11_1 - 0.00100446428571428*G0_1_12_0 - 0.00220982142857141*G0_1_12_1 - 0.00180803571428572*G0_1_13_0 - 0.0018080357142857*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 + 0.00361607142857141*G0_1_15_0 - 0.00180803571428571*G0_1_15_1 - 0.00723214285714282*G0_1_16_0 - 0.00180803571428571*G0_1_16_1 + 0.00361607142857142*G0_1_17_0 + 0.00542410714285712*G0_1_17_1 - 0.00723214285714284*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 - 0.0108482142857143*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[375] = 0.00100446428571428*G0_0_0_0 - 0.0110491071428571*G0_0_0_1 + 0.00401785714285714*G0_0_1_0 - 0.00100446428571428*G0_0_1_1 - 0.000200892857142856*G0_0_2_0 - 0.00301339285714284*G0_0_2_1 - 0.00361607142857139*G0_0_3_0 - 0.00542410714285711*G0_0_3_1 + 0.00180803571428569*G0_0_4_0 + 0.00542410714285712*G0_0_4_1 + 0.0235044642857142*G0_0_5_0 - 0.0036160714285714*G0_0_5_1 + 0.00180803571428571*G0_0_6_0 + 0.0126562499999999*G0_0_6_1 + 0.0126562499999999*G0_0_7_0 - 0.0144642857142856*G0_0_7_1 - 0.0144642857142856*G0_0_8_0 - 0.00361607142857141*G0_0_8_1 + 0.0216964285714285*G0_0_9_0 + 0.00100446428571428*G0_1_10_0 - 0.0110491071428571*G0_1_10_1 + 0.00401785714285714*G0_1_11_0 - 0.00100446428571428*G0_1_11_1 - 0.000200892857142856*G0_1_12_0 - 0.00301339285714284*G0_1_12_1 - 0.00361607142857139*G0_1_13_0 - 0.00542410714285711*G0_1_13_1 + 0.00180803571428569*G0_1_14_0 + 0.00542410714285712*G0_1_14_1 + 0.0235044642857142*G0_1_15_0 - 0.0036160714285714*G0_1_15_1 + 0.00180803571428571*G0_1_16_0 + 0.0126562499999999*G0_1_16_1 + 0.0126562499999999*G0_1_17_0 - 0.0144642857142856*G0_1_17_1 - 0.0144642857142856*G0_1_18_0 - 0.00361607142857141*G0_1_18_1 + 0.0216964285714285*G0_1_19_0;
    A[376] = 0.000401785714285709*G0_0_0_0 + 0.0064285714285714*G0_0_0_1 + 0.00100446428571428*G0_0_1_0 - 0.00100446428571429*G0_0_1_1 + 0.00100446428571428*G0_0_2_0 + 0.00120535714285713*G0_0_2_1 + 0.0018080357142857*G0_0_3_0 + 0.00542410714285711*G0_0_3_1 + 0.0018080357142857*G0_0_4_0 - 0.00361607142857141*G0_0_5_0 - 0.00904017857142854*G0_0_5_1 + 0.00723214285714282*G0_0_6_0 - 0.00361607142857141*G0_0_6_1 - 0.00361607142857142*G0_0_7_0 + 0.0018080357142857*G0_0_7_1 + 0.00723214285714283*G0_0_8_0 - 0.0144642857142857*G0_0_8_1 + 0.0108482142857142*G0_0_9_0 - 0.0108482142857142*G0_0_9_1 + 0.000401785714285709*G0_1_10_0 + 0.0064285714285714*G0_1_10_1 + 0.00100446428571428*G0_1_11_0 - 0.00100446428571429*G0_1_11_1 + 0.00100446428571428*G0_1_12_0 + 0.00120535714285713*G0_1_12_1 + 0.0018080357142857*G0_1_13_0 + 0.00542410714285711*G0_1_13_1 + 0.0018080357142857*G0_1_14_0 - 0.00361607142857141*G0_1_15_0 - 0.00904017857142854*G0_1_15_1 + 0.00723214285714282*G0_1_16_0 - 0.00361607142857141*G0_1_16_1 - 0.00361607142857142*G0_1_17_0 + 0.0018080357142857*G0_1_17_1 + 0.00723214285714283*G0_1_18_0 - 0.0144642857142857*G0_1_18_1 + 0.0108482142857142*G0_1_19_0 - 0.0108482142857142*G0_1_19_1;
    A[377] = -0.00703124999999996*G0_0_0_0 + 0.00502232142857141*G0_0_0_1 + 0.00703124999999996*G0_0_1_0 + 0.0120535714285714*G0_0_1_1 - 0.00421874999999998*G0_0_2_0 - 0.00140624999999999*G0_0_2_1 - 0.00180803571428571*G0_0_3_0 + 0.00904017857142853*G0_0_4_0 + 0.00542410714285711*G0_0_4_1 - 0.0144642857142856*G0_0_5_0 + 0.0126562499999999*G0_0_5_1 + 0.0126562499999999*G0_0_6_0 + 0.00180803571428571*G0_0_6_1 - 0.0216964285714285*G0_0_7_0 + 0.00542410714285711*G0_0_7_1 - 0.0433928571428569*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 - 0.0325446428571428*G0_0_9_0 - 0.0108482142857143*G0_0_9_1 - 0.00703124999999996*G0_1_10_0 + 0.00502232142857141*G0_1_10_1 + 0.00703124999999996*G0_1_11_0 + 0.0120535714285714*G0_1_11_1 - 0.00421874999999998*G0_1_12_0 - 0.00140624999999999*G0_1_12_1 - 0.00180803571428571*G0_1_13_0 + 0.00904017857142853*G0_1_14_0 + 0.00542410714285711*G0_1_14_1 - 0.0144642857142856*G0_1_15_0 + 0.0126562499999999*G0_1_15_1 + 0.0126562499999999*G0_1_16_0 + 0.00180803571428571*G0_1_16_1 - 0.0216964285714285*G0_1_17_0 + 0.00542410714285711*G0_1_17_1 - 0.0433928571428569*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 - 0.0325446428571428*G0_1_19_0 - 0.0108482142857143*G0_1_19_1;
    A[378] = -0.00160714285714285*G0_0_0_0 - 0.00763392857142852*G0_0_0_1 - 0.0200892857142856*G0_0_1_0 - 0.0241071428571427*G0_0_1_1 - 0.00743303571428567*G0_0_2_1 - 0.018080357142857*G0_0_3_0 - 0.0542410714285711*G0_0_3_1 + 0.00361607142857141*G0_0_4_0 + 0.0271205357142856*G0_0_4_1 + 0.00723214285714282*G0_0_5_0 + 0.00180803571428569*G0_0_5_1 - 0.00361607142857141*G0_0_6_0 + 0.00723214285714283*G0_0_6_1 + 0.0216964285714285*G0_0_7_0 + 0.0271205357142856*G0_0_7_1 - 0.108482142857142*G0_0_8_1 + 0.0108482142857143*G0_0_9_0 - 0.0542410714285712*G0_0_9_1 - 0.00160714285714285*G0_1_10_0 - 0.00763392857142852*G0_1_10_1 - 0.0200892857142856*G0_1_11_0 - 0.0241071428571427*G0_1_11_1 - 0.00743303571428567*G0_1_12_1 - 0.018080357142857*G0_1_13_0 - 0.0542410714285711*G0_1_13_1 + 0.00361607142857141*G0_1_14_0 + 0.0271205357142856*G0_1_14_1 + 0.00723214285714282*G0_1_15_0 + 0.00180803571428569*G0_1_15_1 - 0.00361607142857141*G0_1_16_0 + 0.00723214285714283*G0_1_16_1 + 0.0216964285714285*G0_1_17_0 + 0.0271205357142856*G0_1_17_1 - 0.108482142857142*G0_1_18_1 + 0.0108482142857143*G0_1_19_0 - 0.0542410714285712*G0_1_19_1;
    A[379] = -0.00482142857142854*G0_0_0_0 - 0.00482142857142856*G0_0_0_1 - 0.0060267857142857*G0_0_1_0 - 0.00361607142857141*G0_0_2_0 + 0.00361607142857141*G0_0_2_1 - 0.0325446428571427*G0_0_3_0 + 0.0108482142857143*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857142*G0_0_7_1 - 0.0216964285714285*G0_0_8_0 + 0.108482142857142*G0_0_8_1 - 0.0650892857142855*G0_0_9_0 + 0.0216964285714285*G0_0_9_1 - 0.00482142857142854*G0_1_10_0 - 0.00482142857142856*G0_1_10_1 - 0.0060267857142857*G0_1_11_0 - 0.00361607142857141*G0_1_12_0 + 0.00361607142857141*G0_1_12_1 - 0.0325446428571427*G0_1_13_0 + 0.0108482142857143*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857142*G0_1_17_1 - 0.0216964285714285*G0_1_18_0 + 0.108482142857142*G0_1_18_1 - 0.0650892857142855*G0_1_19_0 + 0.0216964285714285*G0_1_19_1;
    A[380] = 0;
    A[381] = 0;
    A[382] = 0;
    A[383] = 0;
    A[384] = 0;
    A[385] = 0;
    A[386] = 0;
    A[387] = 0;
    A[388] = 0;
    A[389] = 0;
    A[390] = -0.00267857142857142*G0_0_0_0 - 0.00267857142857142*G0_0_0_1 - 0.00147321428571428*G0_0_1_0 - 0.00147321428571428*G0_0_1_1 - 0.00147321428571428*G0_0_2_0 - 0.00147321428571428*G0_0_2_1 - 0.00120535714285714*G0_0_3_0 - 0.00120535714285714*G0_0_3_1 - 0.00120535714285714*G0_0_4_0 - 0.00120535714285714*G0_0_4_1 - 0.0120535714285714*G0_0_5_0 - 0.0120535714285714*G0_0_5_1 + 0.00964285714285711*G0_0_6_0 + 0.00964285714285712*G0_0_6_1 - 0.0120535714285714*G0_0_7_0 - 0.0120535714285714*G0_0_7_1 + 0.00964285714285712*G0_0_8_0 + 0.00964285714285712*G0_0_8_1 + 0.0289285714285714*G0_0_9_0 + 0.0289285714285714*G0_0_9_1 - 0.00267857142857142*G0_1_10_0 - 0.00267857142857142*G0_1_10_1 - 0.00147321428571428*G0_1_11_0 - 0.00147321428571428*G0_1_11_1 - 0.00147321428571428*G0_1_12_0 - 0.00147321428571428*G0_1_12_1 - 0.00120535714285714*G0_1_13_0 - 0.00120535714285714*G0_1_13_1 - 0.00120535714285714*G0_1_14_0 - 0.00120535714285714*G0_1_14_1 - 0.0120535714285714*G0_1_15_0 - 0.0120535714285714*G0_1_15_1 + 0.00964285714285711*G0_1_16_0 + 0.00964285714285712*G0_1_16_1 - 0.0120535714285714*G0_1_17_0 - 0.0120535714285714*G0_1_17_1 + 0.00964285714285712*G0_1_18_0 + 0.00964285714285712*G0_1_18_1 + 0.0289285714285714*G0_1_19_0 + 0.0289285714285714*G0_1_19_1;
    A[391] = 0.00147321428571428*G0_0_0_0 + 0.00267857142857142*G0_0_1_0 + 0.00147321428571428*G0_0_2_0 + 0.0120535714285714*G0_0_3_0 - 0.00964285714285712*G0_0_4_0 + 0.00120535714285716*G0_0_5_0 + 0.00120535714285713*G0_0_6_0 - 0.00964285714285709*G0_0_7_0 + 0.0120535714285714*G0_0_8_0 - 0.0289285714285713*G0_0_9_0 + 0.00147321428571428*G0_1_10_0 + 0.00267857142857142*G0_1_11_0 + 0.00147321428571428*G0_1_12_0 + 0.0120535714285714*G0_1_13_0 - 0.00964285714285712*G0_1_14_0 + 0.00120535714285716*G0_1_15_0 + 0.00120535714285713*G0_1_16_0 - 0.00964285714285709*G0_1_17_0 + 0.0120535714285714*G0_1_18_0 - 0.0289285714285713*G0_1_19_0;
    A[392] = 0.00147321428571428*G0_0_0_1 + 0.00147321428571428*G0_0_1_1 + 0.00267857142857141*G0_0_2_1 - 0.00964285714285711*G0_0_3_1 + 0.0120535714285714*G0_0_4_1 - 0.0096428571428571*G0_0_5_1 + 0.0120535714285714*G0_0_6_1 + 0.00120535714285713*G0_0_7_1 + 0.00120535714285712*G0_0_8_1 - 0.0289285714285713*G0_0_9_1 + 0.00147321428571428*G0_1_10_1 + 0.00147321428571428*G0_1_11_1 + 0.00267857142857141*G0_1_12_1 - 0.00964285714285711*G0_1_13_1 + 0.0120535714285714*G0_1_14_1 - 0.0096428571428571*G0_1_15_1 + 0.0120535714285714*G0_1_16_1 + 0.00120535714285713*G0_1_17_1 + 0.00120535714285712*G0_1_18_1 - 0.0289285714285713*G0_1_19_1;
    A[393] = 0.00843749999999997*G0_0_0_0 + 0.00482142857142855*G0_0_0_1 - 0.00602678571428571*G0_0_1_0 + 0.00482142857142856*G0_0_2_1 + 0.0650892857142855*G0_0_3_0 + 0.0542410714285712*G0_0_3_1 + 0.0108482142857142*G0_0_4_0 - 0.0216964285714285*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857143*G0_0_6_0 - 0.0108482142857143*G0_0_6_1 - 0.0216964285714285*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 + 0.043392857142857*G0_0_8_0 + 0.0542410714285712*G0_0_8_1 + 0.173571428571428*G0_0_9_0 + 0.043392857142857*G0_0_9_1 + 0.00843749999999997*G0_1_10_0 + 0.00482142857142855*G0_1_10_1 - 0.00602678571428571*G0_1_11_0 + 0.00482142857142856*G0_1_12_1 + 0.0650892857142855*G0_1_13_0 + 0.0542410714285712*G0_1_13_1 + 0.0108482142857142*G0_1_14_0 - 0.0216964285714285*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857143*G0_1_16_0 - 0.0108482142857143*G0_1_16_1 - 0.0216964285714285*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 + 0.043392857142857*G0_1_18_0 + 0.0542410714285712*G0_1_18_1 + 0.173571428571428*G0_1_19_0 + 0.043392857142857*G0_1_19_1;
    A[394] = 0.00482142857142855*G0_0_0_0 + 0.00843749999999997*G0_0_0_1 + 0.00482142857142856*G0_0_1_0 - 0.0060267857142857*G0_0_2_1 - 0.0216964285714285*G0_0_3_0 + 0.0108482142857142*G0_0_3_1 + 0.0542410714285712*G0_0_4_0 + 0.0650892857142855*G0_0_4_1 - 0.0216964285714285*G0_0_5_0 - 0.0216964285714285*G0_0_5_1 + 0.0542410714285712*G0_0_6_0 + 0.043392857142857*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0216964285714285*G0_0_7_1 - 0.0108482142857143*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 + 0.0433928571428569*G0_0_9_0 + 0.173571428571428*G0_0_9_1 + 0.00482142857142855*G0_1_10_0 + 0.00843749999999997*G0_1_10_1 + 0.00482142857142856*G0_1_11_0 - 0.0060267857142857*G0_1_12_1 - 0.0216964285714285*G0_1_13_0 + 0.0108482142857142*G0_1_13_1 + 0.0542410714285712*G0_1_14_0 + 0.0650892857142855*G0_1_14_1 - 0.0216964285714285*G0_1_15_0 - 0.0216964285714285*G0_1_15_1 + 0.0542410714285712*G0_1_16_0 + 0.043392857142857*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0216964285714285*G0_1_17_1 - 0.0108482142857143*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 + 0.0433928571428569*G0_1_19_0 + 0.173571428571428*G0_1_19_1;
    A[395] = 0.00602678571428572*G0_0_0_0 + 0.00602678571428571*G0_0_0_1 - 0.00843749999999997*G0_0_1_0 - 0.00361607142857142*G0_0_1_1 + 0.00482142857142855*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 + 0.0108482142857143*G0_0_3_1 + 0.0108482142857142*G0_0_4_0 - 0.0650892857142855*G0_0_5_0 - 0.0108482142857142*G0_0_5_1 - 0.0108482142857143*G0_0_6_0 - 0.0325446428571427*G0_0_6_1 - 0.043392857142857*G0_0_7_0 + 0.0108482142857142*G0_0_7_1 + 0.0216964285714285*G0_0_8_0 - 0.173571428571428*G0_0_9_0 - 0.130178571428571*G0_0_9_1 + 0.00602678571428572*G0_1_10_0 + 0.00602678571428571*G0_1_10_1 - 0.00843749999999997*G0_1_11_0 - 0.00361607142857142*G0_1_11_1 + 0.00482142857142855*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 + 0.0108482142857143*G0_1_13_1 + 0.0108482142857142*G0_1_14_0 - 0.0650892857142855*G0_1_15_0 - 0.0108482142857142*G0_1_15_1 - 0.0108482142857143*G0_1_16_0 - 0.0325446428571427*G0_1_16_1 - 0.043392857142857*G0_1_17_0 + 0.0108482142857142*G0_1_17_1 + 0.0216964285714285*G0_1_18_0 - 0.173571428571428*G0_1_19_0 - 0.130178571428571*G0_1_19_1;
    A[396] = -0.00482142857142856*G0_0_0_0 - 0.00482142857142857*G0_0_0_1 - 0.00482142857142856*G0_0_1_0 + 0.00361607142857142*G0_0_1_1 - 0.00602678571428569*G0_0_2_1 + 0.0216964285714285*G0_0_3_0 - 0.0542410714285712*G0_0_4_0 - 0.0108482142857142*G0_0_4_1 + 0.0216964285714285*G0_0_5_0 + 0.0325446428571428*G0_0_5_1 - 0.0542410714285712*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0108482142857143*G0_0_7_0 + 0.0108482142857142*G0_0_8_0 - 0.0108482142857142*G0_0_8_1 - 0.043392857142857*G0_0_9_0 + 0.130178571428571*G0_0_9_1 - 0.00482142857142856*G0_1_10_0 - 0.00482142857142857*G0_1_10_1 - 0.00482142857142856*G0_1_11_0 + 0.00361607142857142*G0_1_11_1 - 0.00602678571428569*G0_1_12_1 + 0.0216964285714285*G0_1_13_0 - 0.0542410714285712*G0_1_14_0 - 0.0108482142857142*G0_1_14_1 + 0.0216964285714285*G0_1_15_0 + 0.0325446428571428*G0_1_15_1 - 0.0542410714285712*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0108482142857143*G0_1_17_0 + 0.0108482142857142*G0_1_18_0 - 0.0108482142857142*G0_1_18_1 - 0.043392857142857*G0_1_19_0 + 0.130178571428571*G0_1_19_1;
    A[397] = 0.00602678571428571*G0_0_0_0 + 0.00602678571428572*G0_0_0_1 + 0.00482142857142857*G0_0_1_0 - 0.00361607142857141*G0_0_2_0 - 0.00843749999999996*G0_0_2_1 + 0.0108482142857143*G0_0_3_1 + 0.0108482142857143*G0_0_4_0 + 0.0216964285714285*G0_0_4_1 + 0.0108482142857143*G0_0_5_0 - 0.043392857142857*G0_0_5_1 + 0.0216964285714285*G0_0_6_1 - 0.0108482142857142*G0_0_7_0 - 0.0650892857142854*G0_0_7_1 - 0.0325446428571427*G0_0_8_0 - 0.0108482142857143*G0_0_8_1 - 0.130178571428571*G0_0_9_0 - 0.173571428571428*G0_0_9_1 + 0.00602678571428571*G0_1_10_0 + 0.00602678571428572*G0_1_10_1 + 0.00482142857142857*G0_1_11_0 - 0.00361607142857141*G0_1_12_0 - 0.00843749999999996*G0_1_12_1 + 0.0108482142857143*G0_1_13_1 + 0.0108482142857143*G0_1_14_0 + 0.0216964285714285*G0_1_14_1 + 0.0108482142857143*G0_1_15_0 - 0.043392857142857*G0_1_15_1 + 0.0216964285714285*G0_1_16_1 - 0.0108482142857142*G0_1_17_0 - 0.0650892857142854*G0_1_17_1 - 0.0325446428571427*G0_1_18_0 - 0.0108482142857143*G0_1_18_1 - 0.130178571428571*G0_1_19_0 - 0.173571428571428*G0_1_19_1;
    A[398] = -0.00482142857142857*G0_0_0_0 - 0.00482142857142856*G0_0_0_1 - 0.0060267857142857*G0_0_1_0 + 0.00361607142857141*G0_0_2_0 - 0.00482142857142856*G0_0_2_1 - 0.0108482142857143*G0_0_3_0 - 0.0542410714285713*G0_0_3_1 + 0.0216964285714285*G0_0_4_1 + 0.0108482142857142*G0_0_5_1 - 0.0108482142857142*G0_0_6_0 + 0.0108482142857143*G0_0_6_1 + 0.0325446428571427*G0_0_7_0 + 0.0216964285714285*G0_0_7_1 + 0.0108482142857143*G0_0_8_0 - 0.0542410714285712*G0_0_8_1 + 0.130178571428571*G0_0_9_0 - 0.0433928571428571*G0_0_9_1 - 0.00482142857142857*G0_1_10_0 - 0.00482142857142856*G0_1_10_1 - 0.0060267857142857*G0_1_11_0 + 0.00361607142857141*G0_1_12_0 - 0.00482142857142856*G0_1_12_1 - 0.0108482142857143*G0_1_13_0 - 0.0542410714285713*G0_1_13_1 + 0.0216964285714285*G0_1_14_1 + 0.0108482142857142*G0_1_15_1 - 0.0108482142857142*G0_1_16_0 + 0.0108482142857143*G0_1_16_1 + 0.0325446428571427*G0_1_17_0 + 0.0216964285714285*G0_1_17_1 + 0.0108482142857143*G0_1_18_0 - 0.0542410714285712*G0_1_18_1 + 0.130178571428571*G0_1_19_0 - 0.0433928571428571*G0_1_19_1;
    A[399] = -0.0144642857142857*G0_0_0_0 - 0.0144642857142857*G0_0_0_1 + 0.0144642857142857*G0_0_1_0 + 0.0144642857142857*G0_0_2_1 - 0.086785714285714*G0_0_3_0 - 0.0216964285714285*G0_0_3_1 - 0.0216964285714285*G0_0_4_0 - 0.086785714285714*G0_0_4_1 + 0.086785714285714*G0_0_5_0 + 0.0650892857142855*G0_0_5_1 + 0.0216964285714285*G0_0_6_0 - 0.0650892857142855*G0_0_6_1 + 0.0650892857142855*G0_0_7_0 + 0.0867857142857139*G0_0_7_1 - 0.0650892857142855*G0_0_8_0 + 0.0216964285714285*G0_0_8_1 - 0.0144642857142857*G0_1_10_0 - 0.0144642857142857*G0_1_10_1 + 0.0144642857142857*G0_1_11_0 + 0.0144642857142857*G0_1_12_1 - 0.086785714285714*G0_1_13_0 - 0.0216964285714285*G0_1_13_1 - 0.0216964285714285*G0_1_14_0 - 0.086785714285714*G0_1_14_1 + 0.086785714285714*G0_1_15_0 + 0.0650892857142855*G0_1_15_1 + 0.0216964285714285*G0_1_16_0 - 0.0650892857142855*G0_1_16_1 + 0.0650892857142855*G0_1_17_0 + 0.0867857142857139*G0_1_17_1 - 0.0650892857142855*G0_1_18_0 + 0.0216964285714285*G0_1_18_1;
  }

};

/// This class defines the interface for the assembly of the global
/// tensor corresponding to a form with r + n arguments, that is, a
/// mapping
///
///     a : V1 x V2 x ... Vr x W1 x W2 x ... x Wn -> R
///
/// with arguments v1, v2, ..., vr, w1, w2, ..., wn. The rank r
/// global tensor A is defined by
///
///     A = a(V1, V2, ..., Vr, w1, w2, ..., wn),
///
/// where each argument Vj represents the application to the
/// sequence of basis functions of Vj and w1, w2, ..., wn are given
/// fixed functions (coefficients).

class UFC_Nonlinear2DBilinearForm: public ufc::form
{
public:

  /// Constructor
  UFC_Nonlinear2DBilinearForm() : ufc::form()
  {
    // Do nothing
  }

  /// Destructor
  virtual ~UFC_Nonlinear2DBilinearForm()
  {
    // Do nothing
  }

  /// Return a string identifying the form
  virtual const char* signature() const
  {
    return "w0_a1[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19](dXa2[0, 1]/dxa0[0, 1]) | vi0[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19][b0[0, 1]]*va1[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19][a0[0, 1]]*((d/dXa2[0, 1])vi1[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19][b0[0, 1]])*dX(0)";
  }

  /// Return the rank of the global tensor (r)
  virtual unsigned int rank() const
  {
    return 2;
  }

  /// Return the number of coefficients (n)
  virtual unsigned int num_coefficients() const
  {
    return 1;
  }

  /// Return the number of cell integrals
  virtual unsigned int num_cell_integrals() const
  {
    return 1;
  }
  
  /// Return the number of exterior facet integrals
  virtual unsigned int num_exterior_facet_integrals() const
  {
    return 0;
  }
  
  /// Return the number of interior facet integrals
  virtual unsigned int num_interior_facet_integrals() const
  {
    return 0;
  }
    
  /// Create a new finite element for argument function i
  virtual ufc::finite_element* create_finite_element(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_finite_element_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_finite_element_1();
      break;
    case 2:
      return new UFC_Nonlinear2DBilinearForm_finite_element_2();
      break;
    }
    return 0;
  }
  
  /// Create a new dof map for argument function i
  virtual ufc::dof_map* create_dof_map(unsigned int i) const
  {
    switch ( i )
    {
    case 0:
      return new UFC_Nonlinear2DBilinearForm_dof_map_0();
      break;
    case 1:
      return new UFC_Nonlinear2DBilinearForm_dof_map_1();
      break;
    case 2:
      return new UFC_Nonlinear2DBilinearForm_dof_map_2();
      break;
    }
    return 0;
  }

  /// Create a new cell integral on sub domain i
  virtual ufc::cell_integral* create_cell_integral(unsigned int i) const
  {
    return new UFC_Nonlinear2DBilinearForm_cell_integral_0();
  }

  /// Create a new exterior facet integral on sub domain i
  virtual ufc::exterior_facet_integral* create_exterior_facet_integral(unsigned int i) const
  {
    return 0;
  }

  /// Create a new interior facet integral on sub domain i
  virtual ufc::interior_facet_integral* create_interior_facet_integral(unsigned int i) const
  {
    return 0;
  }

};

// DOLFIN wrappers

#include <dolfin/fem/Form.h>

class Nonlinear2DBilinearForm : public dolfin::Form
{
public:

  Nonlinear2DBilinearForm(dolfin::Function& w0) : dolfin::Form()
  {
    __coefficients.push_back(&w0);
  }

  /// Return UFC form
  virtual const ufc::form& form() const
  {
    return __form;
  }
  
  /// Return array of coefficients
  virtual const dolfin::Array<dolfin::Function*>& coefficients() const
  {
    return __coefficients;
  }

private:

  // UFC form
  UFC_Nonlinear2DBilinearForm __form;

  /// Array of coefficients
  dolfin::Array<dolfin::Function*> __coefficients;

};

#endif
